Program  juegodelaoca;

uses crt;

   Procedure inicio_juego (var pos,cal:integer);
   Begin
    writeln;
    writeln;
    writeln('             */*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/ ');
    writeln;
    writeln('                  Bienvenido al juego de la oca !!!');
    writeln;
    writeln('             */*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/*/ ');
    writeln;
    writeln;
    writeln('El juego consta de 27 casillas.');
    writeln('Las 5, 9, 14, 18 y 23 son las casillas de la oca y las 6 y 12 son puente. ');
    writeln('Las casillas posada y calavera se definirn a continuacin...');
   repeat
   writeln;
   writeln('Elige la posicion de la casilla de la posada: ');
   {$I-}
   readln(pos);
   {$I+}
   until
  (IOresult=0) and
  ((pos>12) and (pos<27) and (pos<>14) and (pos<>18) and (pos<>23));

   repeat
   writeln('Elige la posicion de la casilla de la calavera: ');
   {$I-}
   readln(cal);
   {$I+}
   until
  (IOresult=0) and
  ((cal>1) and (cal<27) and (cal<>5) and (cal<>9) and (cal<>14)
   and (cal<>18) and (cal<>23) and (cal<>6) and (cal<>12) and (cal<>pos));

  writeln('La posada y la calavera han quedado respectivamente en las casillas: ' ,(pos) ,' y ' , (cal) );
  writeln;
 End;

  Procedure calavera (var posicion:integer;cal:integer);
  begin
   if posicion=cal then
   begin
    posicion:=0;
   writeln('Se ha caido en la casilla calavera: -----> Vuelta a empezar !');
   writeln;
   end;
  end;

  Procedure puente (var posicion:integer;pos:integer);
  Begin
  case posicion of
  6:posicion:=pos;
  12:posicion:=pos;
  end;
  end;



  Procedure tirar_dado_usu (var posicion,cal,pos: integer);
  Var
    dado:integer;
  begin
     dado:=(Random(6))+1;
     writeln('Has sacado un: ',dado);
     writeln;
     posicion:=posicion+dado;
     if posicion>27 then
        posicion:=27-(posicion-27);
     if (posicion=5)or(posicion=9)or(posicion=14)or(posicion=18)then
     begin
      writeln;
      writeln('Has caido en una casilla de la oca asi que avanza a la siguiente oca');
      writeln;
     end;
     if (posicion=6)or(posicion=12)then
     begin
      writeln;
      writeln('Has caido en la casilla del puente, asi que va a la posada y ...');
      writeln;
     end;
     case posicion of
      5: posicion:=9;
      9: posicion:=14;
      14:posicion:=18;
      18:posicion:=23;
     end;
     calavera(posicion,cal);
     puente(posicion,pos);
  end;


  procedure tirar_dado_maq (var posicion,cal,pos: integer);
  var
    dado:integer;
  begin
     dado:=(Random(6))+1;
     writeln('La maquina ha sacado un: ',dado);
     writeln;
     posicion:=posicion+dado;
     if posicion>27 then
       posicion:=27-(posicion-27);
     if (posicion=5)or(posicion=9)or(posicion=14)or(posicion=18)then
     begin
      writeln;
      writeln('La maquina ha caido en una casilla de la oca, asi que avanza a la siguiente oca');
      writeln;
      end;
      if (posicion=6)or(posicion=12)then
     begin
      writeln;
      writeln('La maquina ha caido en un puente, asi que va a la posada y...');
      writeln;
      end;
     case posicion of
      5: posicion:=9;
      9: posicion:=14;
      14:posicion:=18;
      18:posicion:=23;
     end;
     calavera(posicion,cal);
     puente(posicion,pos);
  end;



  procedure dibujar_tablero (var pos_jug, pos_com:integer);
  var
    posicion:integer;
  begin
    for posicion:=1 to 27 do
    begin
      write(posicion:3);

      if pos_jug=posicion then
        begin
        write(' * ');
        if pos_jug=pos_com then
         write('#');
        end
      else
      begin
        if pos_com=posicion then
           write(' # ')
        else
           write('   ');
      end;

      if posicion mod 9 = 0 then
        writeln;
    end;
  end;

  Procedure posada (var pos_jug,pos_com:integer;pos,cal:integer);
  Begin
   if pos_com=pos then
    begin
     writeln('La maquina pierde un turno');
     writeln;
     readln;
     tirar_dado_usu(pos_jug,cal,pos);
    end;
   if pos_jug=pos then
    begin
     dibujar_tablero(pos_jug,pos_com);
     writeln;
     writeln('Sigue tirando la maquina por que has perdido el turno');
     writeln;
     readln;
     tirar_dado_maq(pos_com,cal,pos);
    end;
  End;

     {Programa principal}

 Var pos,cal,pos_jug,pos_com,posicion:integer;
 Begin
 inicio_juego(pos,cal);
 writeln;
 writeln('Usted comienza la partida tirando el dado y ...');
 writeln;

 randomize;
 pos_jug:=0;
 pos_com:=0;

  while (pos_jug<>27)and(pos_com<>27) do
  begin
   tirar_dado_usu(pos_jug,cal,pos);
   dibujar_tablero(pos_jug,pos_com);
    {$I-}
   readln;
    {$I+}

   if (pos_com<>27)and not(pos_jug=27) then
   begin
     tirar_dado_maq(pos_com,cal,pos);
     posada (pos_jug,pos_com,pos,cal);
     dibujar_tablero(pos_jug,pos_com);
      {$I-}
     readln;
      {$I+}

   end;
  end;
   if (pos_jug=27) then
   writeln('Enhorabuena, has ganado');

   if pos_com=27 then
   writeln('Lo siento, ha ganado la maquina');

 readln;
 clrscr
end.