PROGRAM juego_de_la_oca;

{funcion para tirar el dado}
FUNCTION tirar_dado:integer;
VAR
   d:integer;
BEGIN
     writeln('Pulsa enter para tirar el dado');
     readln;
     randomize;
     d:=random(6)+1;
     writeln('Avanzas ',d,' casillas');
     tirar_dado:=d;
     writeln(' ');
END;

{funcion para elegir la casilla de posada}
FUNCTION casilla_posada:integer;
VAR
   posada:integer;
BEGIN
     REPEAT
           write('Elige la casilla de posada: ');
           readln(posada);
           IF (posada<=12)THEN
              writeln('La casilla es incorrecta, debe ser mayor que 12');
           IF (posada>=27)THEN
              write('La casilla es incorrecta, debe ser menor que 27');
           IF ((posada=5)OR(posada=6)OR(posada=9)OR(posada=12)OR(posada=14)
              OR(posada=18) OR(posada=23))THEN
              writeln('La casilla elegida es incorrecta, es una casilla especial');
     UNTIL
           ((posada>12) AND (posada<27) AND(posada<>14) AND (posada<>18)
           AND (posada<>23));
     writeln(' ');
     writeln('LA CASILLA POSADA ES: ',posada);
     writeln(' ');
     casilla_posada:=posada;
END;

{funcion para elegir la casilla de calavera}
FUNCTION casilla_calavera(casilla_posada:integer):integer;
VAR
   calavera:integer;
BEGIN
     REPEAT
           write('Elige la casilla de calavera: ');
           readln(calavera);
           IF  ((calavera<=1) OR (calavera>=27))THEN
               BEGIN
                    write('La casilla elegida es incorrecta, debe ser mayor');
                    writeln(' que 1 y menor que 27');
               END;
           IF((calavera=5) OR (calavera=6) OR(calavera=9) OR (calavera=12) OR
             (calavera=14) OR (calavera=18) OR(calavera=23) OR
             (calavera=casilla_posada))THEN
             writeln('La casilla elegida es incorrecta, es una casilla especial');
     UNTIL
           ((calavera>1) AND (calavera<27) AND(calavera<>5) AND (calavera<>6)
           AND (calavera<>9) AND (calavera<>12) AND(calavera<>14) AND
           (calavera<>18) AND (calavera<>23) AND (calavera<>casilla_posada));
     writeln(' ');
     writeln('LA CASILLA CALAVERA ES: ',calavera);
     writeln(' ');
     casilla_calavera:=calavera;
END;


{procedimiento para mostrar la situacion del jugador q tira el dado}
PROCEDURE avanzar_casillas(d:integer; var casilla:integer);
BEGIN
     casilla:=casilla+d;
     writeln('Estas en la casilla: ', casilla);
     writeln(' ');
END;

{procedimiento para mostrar la situacion del juego}
PROCEDURE situacion_juego(casilla_usuario,casilla_maquina,cas_calavera,cas_posada:integer);
VAR
   i:integer;
BEGIN
     writeln('LA SITUACION DEL JUEGO ES:');
     FOR i:=0 TO 27 DO
         BEGIN
              IF (i<>casilla_usuario)AND(i<>casilla_maquina)THEN
                 write('|  ',i,'|    ')
              ELSE
                  BEGIN
                       IF i=casilla_usuario THEN
                          write('| U ',i,'|    ');
                       IF i=casilla_maquina THEN
                          write('| M ',i,'|    ')
                  END;
               IF (i=cas_posada) THEN
                  write('| Posada',i,'|    ');
               IF i=cas_calavera THEN
                  write('| Calavera',i,'|    ');
         END;
    writeln(' ');
    writeln(' ');
END;

{procedimiento para cuando un jugador cae en calavera}
PROCEDURE calavera(cas_calavera:integer; var casilla:integer);
BEGIN
     writeln('ESTAS EN LA CASILLA CALAVERA ');
     writeln(' Casilla nmero: ',cas_calavera);
     writeln('Vuelves a empezar el juego');
     casilla:=1;
     writeln('Estas en la casilla: ',casilla);
     writeln(' ');
END;

{procedimiento de casillas oca}
PROCEDURE oca (var casilla:integer);
VAR
   d:integer;
BEGIN
      IF (casilla=5) THEN
         BEGIN
              writeln('Estas en la casilla: ',casilla);
              writeln('CASILLA DE OCA ');
              writeln('De oca en oca');
              casilla:=9;
              writeln('Estas en la casilla: ',casilla);
              writeln('Y tiro porque me toca');
              d:=tirar_dado;
              avanzar_casillas(d,casilla);
              writeln(' ');
         END;
         IF (casilla=9) THEN
            BEGIN
                 writeln('Estas en la casilla: ',casilla);
                 writeln('CASILLA DE OCA ');
                 writeln('De oca en oca');
                 casilla:=14;
                 writeln('Estas en la casilla: ',casilla);
                 writeln('Y tiro porque me toca');
                 d:=tirar_dado;
                 avanzar_casillas(d,casilla);
                 writeln(' ');
            END;
            IF (casilla=14) THEN
               BEGIN
                    writeln('Estas en la casilla: ',casilla);
                    writeln('CASILLA DE OCA ');
                    writeln('De oca en oca');
                    casilla:=18;
                    writeln('Estas en la casilla: ',casilla);
                    writeln('Y tiro porque me toca');
                    d:=tirar_dado;
                    avanzar_casillas(d,casilla);
                    writeln(' ');
               END;
            IF (casilla=18) THEN
               BEGIN
                    writeln('Estas en la casilla: ',casilla);
                    writeln('CASILLA DE OCA ');
                    writeln('De oca en oca');
                    casilla:=23;
                    writeln('Estas en la casilla: ',casilla);
                    writeln('Y tiro porque me toca');
                    d:=tirar_dado;
                    avanzar_casillas(d,casilla);
                    writeln(' ');
               END;
            IF (casilla=23) THEN
               BEGIN
                    writeln('Estas en la casilla: ',casilla);
                    writeln('CASILLA DE OCA ');
                    writeln('De oca en oca');
                    casilla:=27;
                    writeln('Estas en la casilla: ',casilla);
                    writeln(' ');
               END;
END;

{Procedimiento rebote}
PROCEDURE rebote(var turno,casilla_usuario,casilla_maquina:integer;cas_posada,cas_calavera:integer);
BEGIN
     IF turno=0 THEN
     BEGIN
        casilla_usuario:=27-(casilla_usuario-27);
        writeln('Estas en la casilla: ',casilla_usuario);
        writeln(' ');
        IF (casilla_usuario=23) THEN
           oca(casilla_usuario);
        IF (casilla_usuario=cas_calavera)THEN
           calavera(cas_calavera,casilla_usuario);
     END;
     IF turno=1 THEN
     BEGIN
        casilla_maquina:=27-(casilla_maquina-27);
        writeln('Estas en la casilla: ',casilla_maquina);
        writeln(' ');
        IF (casilla_maquina=23) THEN
           oca(casilla_maquina);
        IF (casilla_maquina=cas_calavera)THEN
           calavera(cas_calavera,casilla_maquina);
     END;
     {situacion_juego(casilla_usuario,casilla_maquina,cas_calavera,cas_posada); }
END;

{procedimiento para cuando caes en puente}
PROCEDURE puente (cas_posada:integer;var turno,casilla:integer);
BEGIN
     writeln('CASILLA DE PUENTE');
     writeln('Vas a la posada y pierdes turno');
     casilla:=cas_posada;
     writeln('Estas en la posada: ',casilla);
END;

{Procedimiento para cuando cae el usuario en posada}
PROCEDURE posada_usuario (var turno,casilla_maquina,casilla_usuario:integer;cas_calavera,cas_posada,cas_puente:integer);
VAR
   d:integer;
BEGIN
     writeln('CASILLA DE POSADA --> Pierdes turno');
     writeln(' ');
     IF turno=0 THEN
        BEGIN
             casilla_usuario:=cas_posada;
             situacion_juego(casilla_usuario,casilla_maquina,cas_calavera,cas_posada);
             turno:=1;
             writeln('//\\// TURNO DE LA MAQUINA //\\//');
             d:=tirar_dado;
             avanzar_casillas(d,casilla_maquina);
             IF ((casilla_maquina=5)OR(casilla_maquina=9)OR(casilla_maquina=14)
                OR(casilla_maquina=18)OR(casilla_maquina=23))THEN
                oca(casilla_maquina);
             IF(casilla_maquina=cas_calavera)THEN
               calavera(cas_calavera,casilla_maquina);
             IF (casilla_maquina=6)OR(casilla_maquina=12)THEN
                puente (cas_posada,turno,casilla_maquina);
             IF ((casilla_maquina>27)OR(casilla_usuario>27)) THEN
                rebote(turno,casilla_usuario,casilla_maquina,cas_posada,cas_calavera);
        END;
END;

{Procedimiento para cuando cae la maquina en posada}
PROCEDURE posada_maquina (var turno,casilla_maquina,casilla_usuario:integer;cas_calavera,cas_posada,cas_puente:integer);
VAR
   d:integer;
BEGIN
     writeln('CASILLA DE POSADA --> Pierdes turno');
     writeln(' ');
     IF turno=1 THEN
        BEGIN
             casilla_maquina:=cas_posada;
             situacion_juego(casilla_usuario,casilla_maquina,cas_calavera,cas_posada);
             turno:=0;
             writeln('//\\// TU TURNO //\\//');
             d:=tirar_dado;
             avanzar_casillas(d,casilla_usuario);
             IF ((casilla_usuario=5)OR(casilla_usuario=9)OR(casilla_usuario=14)
                OR(casilla_usuario=18)OR(casilla_usuario=23))THEN
                oca(casilla_usuario);
             IF(casilla_usuario=cas_calavera)THEN
               calavera(cas_calavera,casilla_usuario);
             IF (casilla_usuario=6)OR(casilla_usuario=12)THEN
                puente (cas_posada,turno,casilla_usuario);
             IF ((casilla_usuario>27)or(casilla_usuario>27)) THEN
             rebote(turno,casilla_usuario,casilla_maquina,cas_posada,cas_calavera);
        END;
END;

{procedimiento rebote si retrocede y cae en posada}
PROCEDURE rebote_posada(var turno,casilla_usuario,casilla_maquina:integer;cas_calavera,cas_posada,cas_puente:integer);
BEGIN
     IF (casilla_usuario=cas_posada)THEN
        posada_usuario(turno,casilla_maquina,casilla_usuario,cas_calavera,cas_posada,cas_puente);
     IF (casilla_maquina=cas_posada)THEN
        posada_maquina(turno,casilla_maquina,casilla_usuario,cas_calavera,cas_posada,cas_puente);
END;

{procedimiento fin del juego}
PROCEDURE jardin_de_la_oca (var casilla,turno:integer);
BEGIN
     writeln('Estas en la casilla: ',casilla);
     writeln('HAS LLEGADO AL JARDIN DE LA OCA');
     writeln(' ');
     turno:=2;
END;

{Programa principal}
VAR
   c_usuario,c_maquina,turno,casilla:integer;
   c_calavera, c_posada:integer;
   casilla_oca,c_puente,dado:integer;

BEGIN
     {inicializo las variables a 0}
     c_usuario:=0;
     c_maquina:=0;
     c_posada:=0;
     c_calavera:=0;

     writeln(' ///////////////////////////////////////////////');
     writeln(' //////////TABLERO DEL JUEGO DE LA OCA//////////');
     writeln(' ///////////////////////////////////////////////');
     writeln(' ');
     writeln(' _________________________________________________');
     writeln(' |       |       |       |       |       |    oca|');
     writeln(' |       |       |       |       |       |       |');
     writeln(' |      0|      1|      2|      3|      4|      5|');
     writeln(' -------------------------------------------------');
     writeln(' |       |    oca|       |       |       | puente|');
     writeln(' |       |       |       |       |       |       |');
     writeln(' |     17|     18|     19|     20|     21|      6|');
     writeln(' -------------------------------------------------');
     writeln(' |       |       jardin de la oca|       |       |');
     writeln(' |       |                       |       |       |');
     writeln(' |     16|                     27|     22|      7|');
     writeln(' -------------------------------------------------');
     writeln(' |       |       |       |       |    oca|       |');
     writeln(' |       |       |       |       |       |       |');
     writeln(' |     15|     26|     25|     24|     23|      8|');
     writeln(' -------------------------------------------------');
     writeln(' |       |       | puente|       |       |    oca|');
     writeln(' |    oca|       |       |       |       |       |');
     writeln(' |     14|     13|     12|     11|    10 |      9|');
     writeln(' -------------------------------------------------');
     writeln(' ');

     writeln('* COMIENZA EL JUEGO *');
     writeln(' ');
     c_posada:=casilla_posada;
     c_calavera:=casilla_calavera(c_posada);

     {jugadores}
     writeln('* EMPIEZA A JUGAR EL USUARIO * ');
     writeln(' ');

     WHILE (c_usuario<27)AND(c_maquina<27) DO
           BEGIN
                turno:=0;
                IF turno=0 THEN
                   BEGIN
                        {situacion del usuario y la maquina}
                        situacion_juego(c_usuario,c_maquina,c_calavera,c_posada);
                        {turno del usuario}
                        writeln('//\\// TU TURNO //\\//');
                        dado:=tirar_dado;
                        {cuantas casillas avanza y la situacion del usuario}
                        avanzar_casillas(dado,c_usuario);

                        {rebote}
                        IF (c_usuario>27)THEN
                           BEGIN
                           rebote(turno,c_usuario,c_maquina,c_posada,c_calavera);
                           rebote_posada(turno,c_usuario,c_maquina,c_calavera,c_posada,c_puente);
                           END;

                        {casillas oca}
                        IF (c_usuario=5)OR(c_usuario=9)OR(c_usuario=14)OR
                           (c_usuario=18)OR(c_usuario=23) THEN
                           oca (c_usuario);

                        {casillas puente}
                        IF (c_usuario=6)OR(c_usuario=12)THEN
                           puente (c_posada,turno,c_usuario);

                        {casilla posada}
                        IF (c_usuario=c_posada) then
                           posada_usuario(turno,c_maquina,c_usuario,c_calavera,c_posada,c_puente);

                        {rebote}
                        IF (c_usuario>27)THEN
                           BEGIN
                           rebote(turno,c_usuario,c_maquina,c_posada,c_calavera);
                           rebote_posada(turno,c_usuario,c_maquina,c_calavera,c_posada,c_puente);
                           END;

                        {casilla calavera}
                        IF(c_usuario=c_calavera)THEN
                          calavera(c_calavera,c_usuario);

                        {cambio a turno de la maquina}
                        turno:=1;

                        {fin del juego si llega el usuario}
                        IF (c_usuario=27)THEN
                           BEGIN
                                situacion_juego(c_usuario,c_maquina,c_calavera,c_posada);
                                jardin_de_la_oca(c_usuario,turno);
                                writeln('***** HAS GANADO EL JUEGO *****');
                           END;
                   END;

                writeln(' ');

                {turno de la maquina}
                IF turno=1 THEN
                   BEGIN
                        {situacion del usuario y la maquina}
                        situacion_juego(c_usuario,c_maquina,c_calavera,c_posada);
                        {turno de la maquina}
                        writeln('//\\// TURNO DE LA MAQUINA //\\//');
                        dado:=tirar_dado;
                        {cuantas casillas avanza y la situacion de la maquina}
                        avanzar_casillas(dado,c_maquina);

                        {rebote}
                        IF (c_maquina>27)THEN
                           BEGIN
                           rebote(turno,c_usuario,c_maquina,c_posada,c_calavera);
                           rebote_posada(turno,c_usuario,c_maquina,c_calavera,c_posada,c_puente);
                           END;

                        {casillas oca}
                        IF (c_maquina=5)OR(c_maquina=9)OR(c_maquina=14)OR
                           (c_maquina=18)OR(c_maquina=23) THEN
                           oca (c_maquina);

                        {casillas puente}
                        IF (c_maquina=6)OR(c_maquina=12)THEN
                           puente(c_posada,turno,c_maquina);

                        {casilla posada}
                        IF (c_maquina=c_posada)then
                           posada_maquina(turno,c_maquina,c_usuario,c_calavera,c_posada,c_puente);

                        {rebote}
                        IF (c_maquina>27)THEN
                           BEGIN
                           rebote(turno,c_usuario,c_maquina,c_posada,c_calavera);
                           rebote_posada(turno,c_usuario,c_maquina,c_calavera,c_posada,c_puente);
                           END;

                        {casilla calavera}
                        IF (c_maquina=c_calavera)THEN
                           calavera(c_calavera,c_maquina);

                        IF (c_maquina=27)THEN
                           BEGIN
                                situacion_juego(c_usuario,c_maquina,c_calavera,c_posada);
                                jardin_de_la_oca(c_maquina,turno);
                                writeln(' ***** LA MAQUINA GANA EL JUEGO *****');
                           END;
                        turno:=0;
                        writeln(' ');
                   END;
           END;
           readln;
END.

