Program LaOca;
{Se propone la implementacion de una version del juego de la Oca para 2 jugadores (usuario y maquina).
En el juego se usa un tablero con 27 casillas.
Los jugadores empiezan desde la posicion de inicio (casilla 0) y tiran por orden un dado (primero el
usuario, luego la maquina) con el proposito de alcanzar el Jardin de la OCA (casilla 27). Cada jugador
avanzara tantas posiciones como indique su dado.
Hay algunas casillas especiales:
- Oca: casillas 5, 9, 14, 18 y 23. Si se cae en una de estas casillas, se puede avanzar hasta la
siguiente casilla en la que hay una oca y volver a tirar (el contrincante pierde un turno).
- Puente: casillas 6 y 12. Si se cae en estas casillas se salta a la posada y se pierde un turno.
- Posada: una casilla elegida al principio del juego por el usuario. Si se cae en esta casilla se pierde
un turno.
- Calavera: una casilla elegida al principio del juego por el usuario. Si se cae en esta casilla, hay que
volver a la casilla 1.
- Jardin de la Oca: casilla 27. Es necesario sacar los puntos justos para entrar. En caso de exceso se
retroceden desde la meta tantas casillas como puntos sobrantes.
El jugador que vence en el juego es aquel que primero alcanza el jardin de la Oca.}
  Const
    oca1=5;
    Oca2=9;
    oca3=14;
    oca4=18;
    oca5=23;
    puente1=6;
    puente2=12;
    jardinOca=27;



  Procedure pedirDatos(var calavera, posada: integer);
    {Se pide al usuario que indique en el tablero la posicion de las casillas Posada y
Calavera, con la restriccion de que no pueden ser unas casillas que hayan sido sealadas ya como
especiales. Ademas la casilla Posada tiene que ser posterior a cualquier casilla Puente.}
  begin
   {$I-} {La funcion ioResult te sirve para averiguar si en la operacion que acabas de realizar
ocurrio un error de entrada o salida. Esta la utilizas junto con las directivas de compilacion}
   writeln('Escribe la posicion de la casilla calavera:');
   readln(calavera);
   while  (IOResult<>0) or (calavera=Oca1) or (calavera=Oca2) or (calavera=Oca3)
      or (calavera=Oca4) or (calavera=Oca5) or (calavera=Puente1)
      or (calavera=Puente2) or (calavera>=JardinOca) or (calavera<=0) do
                {suprime la opcion de que el jugador elija casillas ya predefinidas, numeros negativos y caracteres}
     begin
      writeln('La posicin no es vlida, elija otro nmero:');
      readln(calavera);
     end;
   writeln('Calavera esta en la casilla:',calavera);
   writeln('Escribe la posicion de la casilla posada:');
   readln(posada);
   while (IOResult<>0) or (posada=Oca1) or (posada=Oca2) or(posada=Oca3) or(posada=Oca4)
      or(posada=Oca5) or(posada=Puente2) or (posada>=JardinOca)
      or (posada<=Puente1) or (posada=calavera) or (posada<=0) do
    {posada posterior a cualquier casilla puente}
     begin
      writeln ('La posicion no es valida, elija otro numero:');
      readln(posada);
     end;

   writeln('Posada esta en la casilla:',posada);
   writeln('La situacion del tablero es la siguiente:');
   {$I+}
  end; {de pedirDatos}

  Procedure jugar(calavera, posada: integer; var finPartida: boolean; var turno, posO, posJ, contadorj, contadoro:integer);
  {El procedimiento jugar ejecuta la tirada, es decir, tira el dado y actualiza las posiciones y los contadores necesarios}

     procedure tirarDado (var dado: integer);
        {tirarDado asigna a dado un nmero entre 1 y 6}
        begin
        dado:= Random(6) + 1;
        end; {de tirarDado}



     var
     dado:integer;
     posj2:integer;
     poso2:integer;

     begin{de jugar}


       if turno = 1 then {juega jugador}
        begin
         if contadorj = 0 then
          begin
          writeln('Jugador un turno sin jugar');      { contador=0 se queda un turno sin tirar}
          contadorj:= contadorj + 1;{pone su contador=1}
          turno:=2;{asigna un turno mas al ordenador,ya que el jugador ha perdido un turno}
          end
          else
           begin
           writeln('Pulse intro para tirar el dado');
           readln;
           randomize;
           tirarDado(dado);   {llama al procedimiento tirarDado }
           writeln('Jugador ha sacado : ', dado);
           posJ2:=posJ + dado;
           if posj2>27 then
            begin
            posj2:=27-(posj2-27);
            end;
           turno:=2;
           posj:=posj2;
           if posJ=Oca1 then{cambia la posicion del jugador al caer en oca, por tanto actualizamos
                                y vuelve a tirar}
             begin
             posJ2:=oca2;
             writeln('De oca a oca y tiro porque me toca');
             turno:=1;{Le vuelve a tocar, por tanto vuelve a ser su turno}
             end;
           if posJ=Oca2 then
           begin
            posJ2:=oca3;
            writeln('De oca a oca y tiro porque me toca');
            turno:=1;
           end;
           if posJ=Oca3 then
           begin
            posJ2:=oca4;
            writeln('De oca a oca y tiro porque me toca');
            turno:=1;
           end;
           if posJ=Oca4 then
           begin
            posJ2:=oca5;
            writeln('De oca a oca y tiro porque me toca');
            turno:=1;
           end;
           if posJ=Oca5 then
           begin
            posJ2:=JardinOca;
            writeln('La oca te lleva a su jardin');
            finPartida:=true;
           end;

         if (posJ=Puente1) or (posJ=Puente2) or (posJ=posada) then
           begin
            posJ2:=posada;
            writeln('Te quedas un turno sin jugar esperando en la posada y vas a la casilla es:', posada);
            contadorj:=0;
           end;
         if posj=calavera then
              begin
              posj2:=1;{le asigna su nueva posicion,casilla 1,puesto que a caido en calavera}
              writeln('CALAVERA! Vuelves a empezar!');
              end;
           posj:=posj2;
           end;
        end
         else    {juega ordenador, lo mismo pero para el ordenador}
          begin
          if contadoro = 0 then
           begin
           writeln('Ordenador se queda un turno sin jugar');
           contadoro:= 1;
           turno:= 1;
           end
           else
           begin
           tirarDado(dado);
           writeln('Ordenador ha sacado un: ', dado);
           posO2:=posO + dado;
           if poso2>27 then
              begin
                poso2:=27-(poso2-27);
              end;
           turno:=1;
           poso:=poso2;
           if posO=Oca1 then
              begin
               posO2:=oca2;
               writeln('De oca a oca y tira porque le toca');
               turno:=2;
              end;
           if posO=Oca2 then
              begin
               posO2:=oca3;
               writeln('De oca a oca y tira porque le toca');
               turno:=2;
              end;
           if posO=Oca3 then
             begin
              posO2:=oca4;
              writeln('De oca a oca y tira porque le toca');
              turno:=2;
             end;
           if posO=Oca4 then
             begin
              posO2:=oca5;
              writeln('De oca a oca y tira porque le toca');
              turno:=2;
             end;
           if posO=Oca5 then
             begin
              posO2:=JardinOca;
              writeln('La oca le lleva a su jardin');
              finpartida:=true;
             end;

           if (posO=Puente1) or (posO=Puente2) or (posO=posada) then
             begin
              posO2:=posada;
              writeln('Ordenador se queda un turno sin jugar esperando en la posada y va a la casilla:',posada);
              contadoro:=0;
             end;
           if posO=calavera then
              begin
              posO2:=1;
              writeln('CALAVERA! Ordenador vuelve a empezar! ');
              end;

             poso:=poso2;

            end;

          end;

     end; {de jugar }
   procedure pintarOca(calavera, posada, poso, posj:integer);
     procedure pintarLinea (fila, calavera, posada, posJ, posO:integer);
      function casillaEspecial(casilla:integer) : boolean;{si en la casilla en la que ha caido es especial entonces entrara
       en esta funcion y le asignara su correspondiente jugada}
         begin if (casilla= oca1) or (casilla = oca2) or (casilla = oca3)
               or (casilla = oca4) or (casilla = oca5) or (casilla = jardinOca)
               or (casilla = calavera) or (casilla = posada)
               or (casilla = puente1) or (casilla = puente2) then
               begin
               casillaEspecial := true;
               end
            else
               begin
               casillaEspecial := false;
               end;
         end;
         procedure escribeCaracter(casilla: integer);{pinta en el tablero las posiciones de las casillas especiales}
           begin
            if (casilla = oca1) or (casilla = oca2) or (casilla = oca3)
             or (casilla = oca4) or (casilla = oca5) then
               begin
               write('Oc');
               end;
            if (casilla = JardinOca) then
               begin
               write('JARDIN OCA!!');
               end;
            if (casilla = posada) then
               begin
               write('Po')
               end;
            if (casilla = calavera) then
               begin
               write('Ca');
               end;
            if (casilla = puente1) or (casilla = puente2) then
               begin
               write('Pu');
               end;
           end;
      procedure pintaJugador(casilla:integer; posJ, posO: integer);{pinta en el tablero la posicion actual de los jugadores}
        begin
         if casilla = posJ then
            begin
            write('J');
            end
            else
               begin
               write(' ');
               end;
         if casilla = posO then
            begin
            write('O');
            end
            else
               begin
               write(' ');
               end;

        end;{de pintaJugador}

      var
      j: integer;
      casilla:integer;
      begin
         write('|');
         for j:=1 to 7 do
            begin
               if  (fila<>4)  or (j<>7) then{suprime la casilla 28}
                begin
                 casilla:=fila*7+j-7;
                 write(' ',casilla);
                 if casilla<10 then{puesto que ocupan menos por tener menos numeros,menos caracteres,
                                 se les aade un espacio para igualar el tablero}
                  begin
                   write(' ');
                  end;
                 write(' ');
                 if casillaEspecial(casilla) then
                  begin
                  escribeCaracter(casilla);{llama al procedimiento escribeCaracter}
                  end
                  else
                     begin
                        write ('  ');
                     end;
               pintaJugador(casilla, posJ, posO);{llama al procedimiento pintaJugador}
               write(' |');
            end;
            end;
            writeln('');
      end;

   var
   nFilas:integer;
   i:integer;
   begin
      nfilas := 4;{pinta el tablero, la primera linea de cada fila y la ultima }
      writeln('+---------+---------+---------+---------+---------+---------+---------+');
      for i := 1 to nfilas do
         begin
            pintarLinea(i,calavera,posada, posJ, posO);
            writeln('+---------+---------+---------+---------+---------+---------+---------+');
         end;
   end;

  Var
    posJ:integer; {posicion del jugador}
    posO:integer; {posicion del ordenador}
    calavera, posada:integer;
    finPartida: boolean; {variable booleana, cuando acabe la partida ser true}
    turno, contadorj,contadoro: integer; {si turno=1 entonces juega el jugador, sino, lo hace el ordenador}
                                         {contadorj y contadoro son unas variables que sirven para controlar
                                         que se pierda el turno al caer en las casillas que lo exijan}
Begin       {de laOca}
 writeln('Bienvenido al juego de la oca');
 writeln(' ');
 PedirDatos(calavera, posada);
 posJ:=0;
 posO:=0; {inicializamos la posicion de los jugadores}
 turno:=1; {siempre empieza el jugador}
 contadorj:=1; {Inicializamos los valores de los contadores}
 contadoro:=1;
 while (finPartida = false) do
   begin
    pintarOca(calavera, posada, poso, posj);
    jugar(calavera, posada, finPartida, turno, posO, posJ, contadorj, contadoro);
    {finPartida, turno, posO, posJ, contadorj, contadoro son variables de entrada y de salida}
    if posJ = 27 then                 {Si despues de jugar cualquiera de los dos esta en la casilla 27
                                       quiere decir que ha ganado, entonces se muestra por pantalla
                                       un mensaje y se actualiza finPartida=true para que salga del bucle
                                       y acabe la partida}
        begin
         writeln('Jugador ha ganado');
         finPartida:=true;
         readln;
        end;
    if poso = 27 then
        begin
         writeln('Ordenador ha ganado');
         finpartida:=true;
         readln;
        end;
     end;
   end.
end.