Program Juego_de_la_Oca;
     Uses Crt;
     Procedure Instrucciones;
     {Este procedimiento est creado para informar al usuario de las casillas
     que no puede elegir como casilla POSADA y CALAVERA.}
               Begin
                    TextColor(Yellow);
                    writeln ('              ___  ___   ___      _     ___          ___      ___   ___  ___ ');
                    writeln ('     | |   | |    |     |   |    |  \  |       |    |   |    |   | |    |   |');
                    writeln ('     | |   | |___ | __  |   |    |   | |___    |    |___|    |   | |    |___|');
                    writeln (' |   | |   | |    ||  | |   |    |   | |       |    |   |    |   | |    |   |');
                    writeln (' |___| |___| |___ |___| |___|    |_ /  |___    |___ |   |    |___| |___ |   |');
                    writeln;
                    writeln;
                    TextColor(Green+128);
                    writeln ('                        BIENVENIDO AL JUEGO DE LA OCA');
                    TextColor(White);
                    writeln;
                    writeln;
                    writeln ('El usuario tiene que elegir la casilla correspondiente ');
                    writeln ('a la POSADA y a la CALAVERA, en un tablero de 27 casillas.');
                    writeln ('Estas casillas no pueden coincidir entre ellas, adems ');
                    write ('la casilla POSADA debe ser superior a una casilla ');
                    TextColor(13);
                    writeln ('PUENTE, ');
                    TextColor(White);
                    writeln ('y no puede coincidir con ninguna casilla especial expuesta a continuacin:');
                    TextColor(11);
                    writeln ('- OCA: 0, 1, 5, 9, 14, 18 y 23.');
                    TextColor(13);
                    writeln ('- PUENTE: 0, 1, 6 y 12.');
                    TextColor(White)
               End;

     Procedure Posada_Calavera (var Casilla_Posada,Casilla_Calavera:integer);
     {Este procedimiento est creado para preguntar al usuario la casilla que
     desea introducir como posada y calavera, restringiendo aquellas casillas
     especiales, como por ejemplo las casillas Ocas y Puentes.
     Este procedimiento es invocado por el programa principal.}
          Begin
          {$I-}
               Repeat
                     write ('Escribe la casilla correspondiente a la posada: ');
                     readln (Casilla_Posada);
               Until (IOResult=0) and (Casilla_Posada>6) and
                     (Casilla_Posada<>9) and (Casilla_Posada<>12) and
                     (Casilla_Posada<>14) and (Casilla_Posada<>18) and
                     (Casilla_Posada<>23) and (Casilla_Posada<27);
               Repeat
                     write ('Escribe la casilla correspondiente a la calavera: ');
                     readln (Casilla_Calavera);
               Until (IOResult=0) and (Casilla_Calavera<>Casilla_Posada) and
                     (Casilla_Calavera<>5) and (Casilla_Calavera<>6) and
                     (Casilla_Calavera<>9) and (Casilla_Calavera<>12) and
                     (Casilla_Calavera<>14) and (Casilla_Calavera<>18) and
                     (Casilla_Calavera<>23) and (Casilla_Calavera<27) and
                     (Casilla_Calavera>1)
          {$I+}
          End;

     Procedure Tablero (C_Pos,C_Cal:integer);
     {Este procedimiento est creado para reproducir en cada turno el tablero
     sin la necesidad de dibujarlo constantemente.
     Este procedimiento es invocado por turno_usuario y turno_maquina.}
               Begin
                    writeln(' ______________________________________________________ ');
                    write('|'); TextBackground(Red); write('        0'); TextBackground(Black);
                    write('|       1|       2|       3|       4|'); TextBackground(1);
                    write('       5'); TextBackground(Black); writeln('|');
                    write('|'); TextBackground(Red); write(' SALIDA  '); TextBackground(Black);
                    write('|        |        |        |        |'); TextBackground(1);
                    write('   OCA  '); TextBackground(Black); writeln('|');
                    write('|'); TextBackground(Red); write('_________');
                    TextBackground(Black); write('|________|________|________|________|');
                    TextBackground(1); write('        '); TextBackground(Black); writeln('|');
                    write(' __________________________________________   |');
                    TextBackground(1);
                    write('________');
                    TextBackground(Black);
                    writeln('|');
                    write('|      17|');
                    TextBackground(1);
                    write('      18');
                    TextBackground(Black);
                    write('|      19|     20|     21|  |');
                    TextBackground(14);
                    write('       6');
                    TextBackground(Black);
                    writeln('|');
                    write('|        |');
                    TextBackground(1);
                    write('  OCA   ');
                    TextBackground(Black);
                    write('|        |       |       |  |');
                    TextBackground(14);
                    write(' PUENTE ');
                    TextBackground(Black);
                    writeln('|');
                    write('|        |');
                    TextBackground(1);
                    write('________');
                    TextBackground(Black);
                    write('|________|_______|       |  |');
                    TextBackground(14);
                    write('        ');
                    TextBackground(Black);
                    writeln('|');
                    write('|________|  _____________________  |_______|  |');
                    TextBackground(14);
                    write('________');
                    TextBackground(Black);
                    writeln('|');
                    write('|      16| |');
                    TextBackground(10);
                    write('                   27');
                    TextBackground(Black);
                    writeln('| |     22|  |       7|');
                    write('|        | |');
                    TextBackground(10);
                    write('     JARDIN DE       ');
                    TextBackground(Black);
                    write('| |       |  |        |');
                    write ('  Casilla POSADA: ');
                    writeln (C_Pos);
                    write('|        | |');
                    TextBackground(10);
                    write('      LA OCA         ');
                    TextBackground(Black);
                    write('| |       |  |        |');
                    write ('  Casilla CALAVERA: ');
                    writeln (C_Cal);
                    write('|________| |');
                    TextBackground(10);
                    write('_______ _____________');
                    TextBackground(Black);
                    writeln('| |_______|  |________|');
                    write('|      15| |     26|_______________|');
                    TextBackground(1);
                    write('     23');
                    TextBackground(Black);
                    writeln('|  |       8|');
                    write('|        | |       |     25|     24|');
                    TextBackground(1);
                    write('  OCA  ');
                    TextBackground(Black);
                    writeln('|  |        |');
                    write('|        | |       |       |       |');
                    TextBackground(1);
                    write('       ');
                    TextBackground(Black);
                    writeln('|  |        |');
                    write('|________| |_______|_______|_______|');
                    TextBackground(1);
                    write('_______');
                    TextBackground(Black);
                    writeln('|  |________|');
                    write('|');
                    TextBackground(1);
                    write('      14');
                    TextBackground(Black);
                    write('|____________________________________|');
                    TextBackground(1);
                    write('       9');
                    TextBackground(Black);
                    writeln('|');
                    write('|');
                    TextBackground(1);
                    write('  OCA   ');
                    TextBackground(Black);
                    write('|       13|');
                    TextBackground(14);
                    write('      12');
                    TextBackground(Black);
                    write('|      11|      10|');
                    TextBackground(1);
                    write('   OCA  ');
                    TextBackground(Black);
                    writeln('|');
                    write('|');
                    TextBackground(1);
                    write('        ');
                    TextBackground(Black);
                    write('|         |');
                    TextBackground(14);
                    write(' PUENTE ');
                    TextBackground(Black);
                    write('|        |        |');
                    TextBackground(1);
                    write('        ');
                    TextBackground(Black);
                    writeln('|');
                    write('|');
                    TextBackground(1);
                    write('________');
                    TextBackground(Black);
                    write('|_________|');
                    TextBackground(14);
                    write('________');
                    TextBackground(Black);
                    write('|________|________|');
                    TextBackground(1);
                    write('________');
                    TextBackground(Black);
                    writeln('|')
               End;

     Procedure Continuar;
     {Este procedimiento est creado para cambiar de turno, cuando el usuario
     o la mquina ha acabado.
     Este procedimiento no invoca a ningn otro y es invocado por el programa
     principal.}
               Begin
                    writeln;
                    TextColor(10);
                    write ('Pulsa Intro para CONTINUAR: ');
                    readln;
                    TextColor(White);
                    writeln;
               End;


     Procedure Dado;
     {Este procedimiento est creado para tirar el dado en cada turno.
     Este procedimiento no invoca a ningn otro, pero sin embargo
     es invocado por los procedimientos Jardin_Oca, turno_usuario y turno_maquina.}

               Begin
                    writeln;
                    TextColor(10);
                    write ('Pulsa Intro para tirar el DADO: ');
                    readln;
                    TextColor(White);
                    writeln
               End;

     Procedure Jardin_oca (var Contador_STD,Posa,Cala:integer);
     {Este procedimiento comprueba en cada tirada (tanto la del usuario como la de la
     mquina) la posibilidad de caer en una casilla oca o puente, y en el caso de ser
     as, realiza los clculos correspondientes a esas casilla especiales.
     Este procedimiento es invocado por los procedimientos turno_usuario y turno_maquina
     que vienen a continuacin.}
               Var
                  Tirada:byte;
                  tecla:char;
               Begin
                    If (Contador_STD<27) then
                       Begin
                            Case Contador_STD of
                                 5: Begin
                                         TextColor(9);
                                         Write ('Enhorabuena, ha caido en la casilla ');
                                         TextColor(137); write ('Oca!: '); TextColor(9);
                                         writeln ('5');
                                         Write ('Ahora va a la casilla: ');
                                         Contador_STD:=9;
                                         Writeln (Contador_STD);
                                         Writeln ('Vuelve a tirar el dado.');
                                         Dado;
                                         Tirada:=Random(6)+1;
                                         Write ('Ha sacado: ');
                                         Writeln (Tirada);
                                         Contador_STD:=Contador_STD+Tirada;
                                         TextColor(White)
                                    End;
                                 9: Begin
                                         TextColor(9);
                                         Write ('Enhorabuena, ha caido en la casilla ');
                                         TextColor(137); write ('Oca!: '); TextColor(9);
                                         writeln ('9');
                                         Write ('Ahora va a la casilla: ');
                                         Contador_STD:=14;
                                         Writeln (Contador_STD);
                                         Writeln ('Vuelve a tirar el dado.');
                                         Dado;
                                         Tirada:=Random(6)+1;
                                         Write ('Ha sacado: ');
                                         Writeln (Tirada);
                                         Contador_STD:=Contador_STD+Tirada;
                                         TExtColor(White)
                                    End;
                                 14:Begin
                                         TextColor(9);
                                         Write ('Enhorabuena, ha caido en la casilla ');
                                         TextColor(137); write ('Oca!: '); TextColor(9);
                                         writeln ('14');
                                         Write ('Ahora va a la casilla: ');
                                         Contador_STD:=18;
                                         Writeln (Contador_STD);
                                         Writeln ('Vuelve a tirar el dado.');
                                         Dado;
                                         Tirada:=Random(6)+1;
                                         Write ('Ha sacado: ');
                                         Writeln (Tirada);
                                         Contador_STD:=Contador_STD+Tirada;
                                         TextColor(White)
                                    End;
                                 18:Begin
                                         TextColor(9);
                                         Write ('Enhorabuena, ha caido en la casilla ');
                                         TextColor(137); write ('Oca!: '); TextColor(9);
                                         writeln ('18');
                                         Write ('Ahora va a la casilla: ');
                                         Contador_STD:=23;
                                         Writeln (Contador_STD);
                                         Writeln ('Vuelve a tirar el dado.');
                                         Dado;
                                         Tirada:=Random(6)+1;
                                         Write ('Ha sacado: ');
                                         Writeln (Tirada);
                                         Contador_STD:=Contador_STD+Tirada;
                                         TextColor(White)
                                    End;
                                 23:Begin
                                         TextColor(9);
                                         Write ('Enhorabuena, ha caido en la casilla ');
                                         TextColor(137); write ('Oca!: '); TextColor(9);
                                         writeln ('23');
                                         Writeln ('Vuelve a tirar el dado.');
                                         Dado;
                                         Tirada:=Random(6)+1;
                                         Write ('Ha sacado: ');
                                         Writeln (Tirada);
                                         Contador_STD:=Contador_STD+Tirada;
                                         TextColor(White);
                                    End;
                            End;
                       End;
                       Case Contador_STD of
                            6: Begin
                                    TextColor(12);
                                    write ('Ha caido en la casilla ');
                                    TextColor(140); write ('Puente: '); TextColor(12);
                                    writeln ('6');
                                    write ('Va a la casilla Posada: ');
                                    Contador_STD:=Posa;
                                    writeln (Contador_STD);
                                    Writeln ('Pierde turno.');
                                    TextColor(White)
                               End;
                            12:Begin
                                    TextColor(12);
                                    write ('Ha caido en la casilla ');
                                    TextColor(140); write ('Puente: '); TextColor(12);
                                    writeln ('12');
                                    write ('Va a la casilla Posada: ');
                                    Contador_STD:=Posa;
                                    writeln (Contador_STD);
                                    Writeln ('Pierde turno.');
                                    TextColor(White)
                               End;
                       End;
               End;

     Procedure turno_usuario (var Casilla_Posada,Casilla_Calavera,Contador_STD_U:integer);
     {Este procemiento se encarga de que el usuario avance de casilla, comprobando en todo
     momento la posibilidad de caer en una casilla especial.
     Este procedimiento invoca a los procedimientos tablero y jardin_oca, y a su vez es invocado
     por el programa principal.}
               Var
                  Tirada:byte;
                  tecla: char;
               Begin
                    writeln;
                    TextColor(6);
                    Writeln ('ES TU TURNO');
                    writeln ('"""""""""""');
                    TextColor(White);
                    Dado;
                    Tirada:=Random(6)+1;
                    Write ('Has sacado: ');
                    Writeln (Tirada);
                    Contador_STD_U:=Contador_STD_U+Tirada;
                    While (Contador_STD_U=5) or (Contador_STD_U=6) or
                          (Contador_STD_U=9) or (Contador_STD_U=12) or
                          (Contador_STD_U=14) or (Contador_STD_U=18) or
                          (Contador_STD_U=23) do
                          Jardin_Oca (Contador_STD_U,Casilla_Posada,Casilla_Calavera);
                    {Este bucle esta creado porque puede dar la casualidad que el usuario
                    caiga dos o ms veces consecutivas en una casilla Oca}
                    If (Contador_STD_U>27) then
                       Begin
                            Contador_STD_U:=(27-(Contador_STD_U-27));
                            Write ('Has caido en la casilla: ');
                            Writeln (Contador_STD_U)
                       End
                    Else if (Contador_STD_U<>Casilla_Posada) then
                        Begin
                             Write ('Has caido en la casilla: ');
                             Writeln (Contador_STD_U)
                        End;
                    {Esta condicional se encarga de comprobar que en cada tirada no
                    se pase de la casilla 27, y si asi lo hace retrocede tantas casillas
                    como posiciones se haya pasado de la 27. Y la segunda condicional, sirve
                    para que no repita dos veces la posicin del usuario despues de haber
                    caido en una casilla puente}
                    If (Contador_STD_U=27) then
                       Begin
                            writeln;
                            TextBackground(13);
                            TextColor(Yellow+128);
                            writeln ('ENHORABUENA, HAS GANADO.');
                            TextColor(White);
                            TextBackground(Black);
                            writeln;
                            writeln ('Lo siento maquina, pero el jugador te ha ganado')
                       End;
                    {Esta condicional comprueba si el usuario ha caido en la casilla 27
                    y si ha sido asi, da fin al juego.}
               End;

     Procedure turno_maquina (var Casilla_Posada,Casilla_Calavera,Contador_STD_M:integer);
     {Este procedimiento hace la misma funcin que el procedimiento turno_usuario, solo que
     para la mquina.}
               Var
                  Tirada:byte;
                  tecla: char;
               Begin
                    writeln;
                    TextColor(6);
                    Writeln ('ES EL TURNO DE LA MAQUINA');
                    Writeln ('"""""""""""""""""""""""""');
                    TextColor(White);
                    Tirada:=Random(6)+1;
                    Write ('La maquina ha sacado: ');
                    Writeln (Tirada);
                    Contador_STD_M:=Contador_STD_M+Tirada;
                    While (Contador_STD_M=5) or (Contador_STD_M=6) or
                          (Contador_STD_M=9) or (Contador_STD_M=12) or
                          (Contador_STD_M=14) or (Contador_STD_M=18) or
                          (Contador_STD_M=23) do
                          Jardin_Oca (Contador_STD_M,Casilla_Posada,Casilla_Calavera);
                    {Este bucle esta creado, porque puede dar la casualidad que la maquina
                    caiga dos o mas veces seguidas en una casilla Oca}
                    If (Contador_STD_M>27) then
                       Begin
                            Contador_STD_M:=(27-(Contador_STD_M-27));
                            Write ('Ha caido en la casilla: ');
                            Writeln (Contador_STD_M)
                       End
                    Else If (Contador_STD_M<>Casilla_Posada) then
                        Begin
                             Write ('Ha caido en la casilla: ');
                             Writeln (Contador_STD_M)
                        End;
                    If (Contador_STD_M=27) then
                          Begin
                               writeln;
                               TextBackground(13);
                               TextColor(Yellow+128);
                               writeln ('LA MAQUINA TE HA GANADO.');
                               TextColor(White);
                               TextBackground(Black);
                               writeln
                          End
               End;

     Procedure Pos_Cal (var Usuario,Maquina,Posada,Calavera:integer);
     {Este procedimiento se encarga de comprobar si el usuario o la mquina
     han caido en la casilla posada o calavera, y si es asi, se encarga de
     realizar los pasos correspondientes, como: retroceder de casilla, perder
     turno, etc.
     Este procedimiento invoca a turno_usuario y a turno_maquina, y es invocado
     por el programa principal.}
               Begin
                    If (Usuario=Posada) and (Maquina<>27) then
                       Begin
                            writeln ('Estas en la casilla Posada, por lo que ');
                            writeln ('le toca jugar a la maquina, y pierdes un turno.');
                            turno_maquina(Posada,Calavera,Maquina)
                       End;
                    If (Usuario=Posada) and (Maquina=27)
                    then writeln ('La has cagado chato.');

                    If (Maquina=Posada) and (Usuario<>27) then
                         Begin
                              writeln ('La maquina esta en la casilla Posada, por lo que');
                              writeln ('le toca jugar al usuario, y pierde un turno.');
                              turno_usuario(Posada,Calavera,Usuario)
                         End;
                    If (Maquina=Posada) and (Usuario=27)
                    then writeln ('La mquina la ha cagado.');

                    If (Usuario=Calavera) and (Maquina<>27) then
                       Begin
                            Usuario:=1;
                            Writeln ('Lo siento, pero has caido en la casilla calavera.');
                            Write ('Regresas a la casilla: ');
                            Writeln (Usuario);
                            turno_maquina(Posada,Calavera,Maquina)
                       End;
                    If (Usuario=Calavera) and (Maquina=27)
                    then writeln ('La has cagado chato.');

                    If (Maquina=Calavera) and (Usuario<>27) then
                       Begin
                            Maquina:=1;
                            Writeln ('La maquina ha caido en la casilla calavera.');
                            Write ('Regresa a la casilla: ');
                            Writeln (Maquina);
                            turno_usuario (Posada,Calavera,Usuario)
                       End;
                     If (Maquina=Calavera) and (Usuario=27)
                     then writeln ('La maquina la ha cagado.')
                     {Estas condicionales sirven para asegurar que cuando uno de los
                     dos jugadores haya alcanzado la casilla 27, finalice el juego y no
                     deje continuar el turno del otro jugador.}
               End;

     Procedure Mostrar_Casilla (U,M:integer);
     {Este procedimiento sirve para mostrar en la pantalla la posicin
     actualizada de cada jugador. Utiliza variables de entrada y es invocado
     por el programa principal.}
               Begin
                    writeln;
                    writeln;
                    TextColor(Yellow);
                    write ('El usuario est en la casilla: ');
                    TextColor(White);
                    writeln (U);
                    TextColor(13);
                    write ('La mquina est en la casilla: ');
                    TextColor(White);
                    writeln (M);
                    writeln
               End;

     Procedure Fin_Juego;
     {Este procedimiento esta creado para despedir el juego, y se utiliza en
     el programa principal.}
               Begin
                    writeln;
                    TextColor (Green+128);
                    writeln ('FIN DEL JUEGO');
                    TextColor (White);
                    writeln;
                    writeln ('Gracias, por confiar en nuestros productos.');
                    writeln ('Le enviaremos actualizaciones periodicamente.');
                    writeln;
                    writeln ('JUEGO DE LA OCA   Version 1.0   Copyright (c) 2009  Spain');
                    writeln
               End;
     Var
        Contador_U,Contador_M,Pos,Cal:integer;
     Begin
          Randomize;
          Clrscr;
          writeln ('JUEGO DE LA OCA   Version 1.0   Copyright (c) 2009  Spain.');
          writeln;
          writeln ('Juan Villafranca and Vctor Ruiz.   All rights reserved.');
          writeln;
          Instrucciones;
          Posada_Calavera(Pos,Cal);
          Tablero(Pos,Cal);
          Contador_U:=0;
          Contador_M:=0;
          While (Contador_U<27) and (Contador_M<27) do
                Begin
                     Clrscr;
                     Tablero(Pos,Cal);
                     Mostrar_Casilla (Contador_U,Contador_M);
                     turno_usuario (Pos,Cal,Contador_U);
                     Pos_Cal (Contador_U,Contador_M,Pos,Cal);
                     Mostrar_Casilla (Contador_U,Contador_M);
                     If (Contador_U=27) then Fin_Juego;
                     Continuar;
                     If (Contador_U<>27) then
                        Begin
                             Clrscr;
                             Tablero(Pos,Cal);
                             Mostrar_Casilla (Contador_U,Contador_M);
                             turno_maquina (Pos,Cal,Contador_M);
                             Pos_Cal (Contador_U,Contador_M,Pos,Cal);
                             Mostrar_Casilla (Contador_U,Contador_M);
                             If (Contador_M=27) then Fin_Juego;
                             Continuar
                        End
                End
     End.