PROGRAM Juego_Oca;
{Este programa permite efectuar partidas entre el usuario y la maquina al
Juego de la Oca}

USES Crt, Dos;

{Definicion de las funciones y procedimientos que se son necesarios para
ejecutar el programa}

  PROCEDURE Mostrar_Elegidas (pos,cal:integer);
  {Muestra un mensaje por pantalla de las casillas que ha elegido el usuario
  para la posada y calavera} {pos,cal son variables de entrada:informacion q
  introduce el usuario por teclado}
    VAR
      i:integer;  {Contador del Bucle FOR}
    BEGIN
      Clrscr;
      FOR i:=20 TO 60 DO
        BEGIN
          textcolor(11);
          gotoxy (i,10);
          write ('*');
          gotoxy (i,20);
          write ('*');
          textcolor(7)
        END;
      gotoxy(25,13);
      write ('LAS CASILLAS ELEGIDAS SON:');
      gotoxy(30,15);
      textcolor(14);
      write ('Posada: ',pos);
      gotoxy(30,17);
      textcolor(3);
      write ('Calavera: ',cal);
      textcolor(7);
      Delay(30000) {Pausa la ejecucin los milisegundos especificados}
    END;

  PROCEDURE Elegir_Casillas (var pos,cal: integer);
    {Permite elegir al usuario la casilla de la Posada y Calavera}
    {pos,cal son variables de salida: se rellenan con las casillas que
    introduce el usuario}
    BEGIN
      {$I-}
        REPEAT
          Clrscr;
          gotoxy(10,10);
          write ('Elija una casilla para la Posada: ');
          read(pos);
          IF (IOResult<>0) OR (pos<=12) OR (pos=14) OR (pos=18) OR (pos=23)
             OR (pos>=27) THEN
            BEGIN
              gotoxy(10,11);
              write ('La casilla elegida no es vlida.');
              Delay(7000)
            END
        UNTIL (IOResult=0) AND (pos>12) AND (pos<>14) AND (pos<>18) AND
              (pos<>23) AND (pos<>27) AND (pos<28);
      {$I+}

      {$I-}
        REPEAT
          Clrscr;
          gotoxy(10,10);
          write ('Elija una casilla para la Calavera: ');
          read(cal);
          IF (IOResult<>0) OR (cal=1) OR (cal=5) OR (cal=6) OR (cal=9)
             OR (cal=12) OR (cal=14) OR (cal=18) OR (cal=23) OR (cal=pos)
             OR (cal>=27) THEN
            BEGIN
              gotoxy(10,11);
              write ('La casilla elegida no es vlida.');
              Delay (7000)
            END
        UNTIL (IOResult=0) AND (cal<>1) AND (cal<>5) AND (cal<>6) AND (cal<>9)
              AND (cal<>12) AND (cal<>14) AND (cal<>18) AND (cal<>23) AND
              (cal<>27) AND (cal<28) AND (cal<>pos);
      {$I+}
      Mostrar_Elegidas(pos,cal);
    END;

  PROCEDURE Dibujar_Tablero (pos,cal:integer);
  {Sirve para mostrar por pantalla el tablero de juego}
  {pos,cal son variables de entrada: con la informacion introducida por el
  usuario}
    VAR
      i,col: integer;
      {i es el contador del bucle FOR y col es la posicion de la columna
      donde quiero dibujar}
    BEGIN
      Clrscr;
      gotoxy (5,10);
      write ('|');
      gotoxy (5,12);
      write ('|');
      gotoxy (5,14);
      write ('|');
      col:=6;
      FOR i:=1 TO 27 DO
        BEGIN
          gotoxy(col,10);
          write('X|');
          gotoxy(col,12);
          write(' |');
          gotoxy(col,14);
          write(' |');
          col:= col+2
        END;
      textcolor(5);
      gotoxy(6,10);
      write('1');
      textcolor(2);
      gotoxy(14,10);
      write('O');
      gotoxy(22,10);
      write('O');
      gotoxy(32,10);
      write('O');
      gotoxy(40,10);
      write('O');
      gotoxy(50,10);
      write('O');
      textcolor (12);
      gotoxy(16,10);
      write('P');
      gotoxy(28,10);
      write('P');
      textcolor (1);
      gotoxy(58,10);
      write('F');
      textcolor(14);
      gotoxy ((pos*2)+4,10);
      write ('P');
      textcolor(3);
      gotoxy((cal*2)+4,10);
      write ('C');
      textcolor(7)
    END;

  PROCEDURE Posicion_Inicial (var j1,j2,turno:integer);
  {Para indicar donde empieza el juego. j1(usuario) y j2(maquina) son
  variables de salida para marcar la posicion inicial de juego;
  turno es una variable para indicar si juega el usuario (turno=1) o la
  maquina (turno=2)}
    CONST
      p_i=4;
      {Posiciones iniciales de los dos jugadores}
    BEGIN
      j1:=p_i;
      j2:=p_i;
      turno:=1;
      gotoxy(p_i,12);
      write ('U');
      gotoxy(p_i,14);
      write ('M')
    END;

  FUNCTION Tirada_Dado (jugador:integer;var dado:integer):integer;
  {Funcin que sirve para el dado y colocar al jugador en la posicion adecuada}
  {De entrada para coger el numero en la posicion del jugador, dado para mostrar
  el mensaje de la puntuacion del dado}
    BEGIN
      dado:= random (6)+1; {Cuantos numeros va a sacar (6) a partir del
                            numero 1, y dnd se guarda}
      jugador:= (dado*2)+ jugador;
      Tirada_Dado:=jugador
    END;

  PROCEDURE Informacion (dado:integer);
  {Muestra por pantalla el turno del jugador correspondiente y el numero
  del dado}
  VAR
    i:integer;
  BEGIN
    IF (dado<>0) THEN
    FOR i:=20 TO 50 DO
      BEGIN
        gotoxy(i,18);
        write('*');
        gotoxy (i,24);
        write('*');
        gotoxy(23,22);
        write('Puntuacion del dado: ', dado);
      END
  END;
  PROCEDURE Tirada(var j1,j2,turno,pos,cal:integer; var pt1,pt2:boolean);
  {Sirve para tirar el dado y colocarlo en la casilla adecuada}
    VAR
      dado,sobra: integer;
      a: char;
    BEGIN
      IF (turno=1) THEN
      BEGIN
        IF (pt1=false) THEN {Si no pierdo turno, juego}
        BEGIN
          gotoxy(23,20);
          write('Jugada del usuario');
          j1:= Tirada_Dado(j1,dado);
          IF (j1>58) THEN
            BEGIN
              sobra:= j1-58; {Cantidad de columnas que sobran}
              j1:= 58 - sobra
            END;
          IF (j1=40) THEN
            BEGIN
              turno:=1;
              j1:=50;
              textcolor(2);
              gotoxy(5,3);
              write ('CASILLA OCA: Se avanza hasta la siguiente oca y vuelve a tirar');
              textcolor(7);
            END;
          IF (j1=32) THEN
            BEGIN
              turno:=1;
              j1:=40;
              textcolor(2);
              gotoxy(5,3);
              writeln ('CASILLA OCA: Se avanza hasta la siguiente oca y vuelve a tirar');
              textcolor(7);
            END;
          IF (j1=22) THEN
            BEGIN
              turno:=1;
              j1:=32;
              textcolor(2);
              gotoxy(5,3);
              writeln ('CASILLA OCA: Se avanza hasta la siguiente oca y vuelve a tirar');
              textcolor(7);
            END;
          IF (j1=14) THEN
            BEGIN
              turno:=1;
              j1:=22;
              textcolor(2);
              gotoxy(5,3);
              writeln ('CASILLA OCA: Se avanza hasta la siguiente oca y vuelve a tirar');
              textcolor(7);
            END;
          {IF (j1=50) THEN
            BEGIN
              turno:=1;
              j1:=57;
              textcolor(2);
              gotoxy(5,3);
              writeln ('CASILLA OCA: Se avanza hasta la siguiente oca y vuelve a tirar');
              textcolor(7);
            END;}     {La ultima oca no la tengo en cuenta como casilla
                       especial, xq no especifica nada en el guin}
          IF (j1=16) OR (j1=28) THEN
            BEGIN
              j1:=(pos*2)+4;
              turno:=2;
              textcolor(12);
              gotoxy(5,3);
              writeln ('CASILLA PUENTE: Se salta a la posada y pierde turno');
              textcolor(7)
            END;
          IF (j1=58) THEN
            BEGIN
              textcolor(1);
              gotoxy (5,3);
              writeln('JARDIN DE LA OCA: Ha ganado el juego el usuario');
              textcolor(7)
            END;
          IF (j1=(pos*2)+4) THEN
            BEGIN
              turno:=2;
              pt1:=true;
              textcolor(14);
              gotoxy (5,5);
              writeln ('CASILLA POSADA: Pierde turno');
              textcolor(7)
            END;
          IF (j1=(cal*2)+4) THEN
            BEGIN
              j1:=6;
              turno:=2;
              textcolor(8);
              gotoxy(5,3);
              writeln ('CASILLA CALAVERA: Retrocede hasta la primera casilla');
              textcolor(7)
            END;
          IF (j1<>14) AND (j1<>16) AND (j1<>22) AND (j1<>28) AND (j1<>32) AND
             (j1<>40) AND (j1<>50) AND (j1<>58) AND (j1<>(pos*2)+4) AND
             (j1<>(cal*2)+4) THEN
          turno:=2
        END
        ELSE
          BEGIN
          gotoxy(5,3);
          write('Pierde turno el usuario al estar en la posada');
          dado:=0;
          pt1:=false;
          turno:=2
          END;
      END {Cierre de IF turno=1}

      ELSE  {Si el turno=2 -> maquina}
      BEGIN
        IF (pt2= false) THEN {Si no pierde el turno, juega}
        BEGIN
          gotoxy(23,20);
          write ('Jugada de la maquina');
          j2:= Tirada_Dado(j2,dado); {Para posicionar en cada momento al jugador segun puntuacion dado}
          IF (j2>58) THEN
            BEGIN
              sobra:= j2-58; {Cantidad de columnas que sobran}
              j2:= 58 - sobra
            END;
          IF (j2=40) THEN
            BEGIN
              turno:=2;
              j2:=50;
              textcolor(2);
              gotoxy(5,3);
              writeln ('CASILLA OCA: Se avanza hasta la siguiente oca y vuelve a tirar');
              textcolor(7);
            END;
          IF (j2=32) THEN
            BEGIN
              turno:=2;
              j2:=40;
              textcolor(2);
              gotoxy(5,3);
              writeln ('CASILLA OCA: Se avanza hasta la siguiente oca y vuelve a tirar');
              textcolor(7);
            END;
          IF (j2=22) THEN
            BEGIN
              turno:=2;
              j2:=32;
              textcolor(2);
              gotoxy(5,3);
              writeln ('CASILLA OCA: Se avanza hasta la siguiente oca y vuelve a tirar');
              textcolor(7);
            END;
          IF (j2=14) THEN
            BEGIN
              turno:=2;
              j2:=22;
              textcolor(2);
              gotoxy(5,3);
              writeln ('CASILLA OCA: Se avanza hasta la siguiente oca y vuelve a tirar');
              textcolor(7);
            END;
          {IF (j2=50) THEN
            BEGIN
              turno:=2;
              j2:=57;
              textcolor(2);
              gotoxy(5,3);
              writeln ('CASILLA OCA: Se avanza hasta la siguiente oca y vuelve a tirar');
              textcolor(7);
            END;}     {La ultima oca no la tengo en cuenta como casilla
            especial, xq no especifica nada en el guin}
          IF (j2=16) OR (j2=28) THEN
            BEGIN
              j2:=(pos*2)+4;
              turno:=1;
              textcolor(6);
              gotoxy(5,3);
              writeln ('CASILLA PUENTE: Se salta a la posada y pierde turno');
              textcolor(7)
            END;
          IF (j2=58) THEN
            BEGIN
              textcolor(1);
              gotoxy (5,3);
              writeln('JARDIN DE LA OCA: Ha ganado el juego la maquina');
              textcolor(7)
            END;
          IF (j2=(pos*2)+4) THEN
            BEGIN
              turno:=1;
              pt2:= true;
              textcolor(14);
              gotoxy (5,5);
              writeln ('CASILLA POSADA: Pierde turno');
              textcolor(7)
            END;
          IF (j2=(cal*2)+4) THEN
            BEGIN
              j2:=6;
              turno:=1;
              textcolor(8);
              gotoxy(5,3);
              writeln ('CASILLA CALAVERA: Retrocede hasta la primera casilla');
              textcolor(7)
            END;
          IF (j2<>14) AND (j2<>16) AND (j2<>22) AND (j2<>28) AND (j2<>32) AND
             (j2<>40) AND (j2<>50) AND (j2<>58) AND (j2<>(pos*2)+4) AND
             (j2<>(cal*2)+4) THEN
          turno:=1
        END
        ELSE
          BEGIN
            gotoxy(5,3);
            write ('La maquina pierde turno por estar en la posada');
            dado:=0;
            pt2:=false;
            turno:=1
          END;
      END; {Fin del IF turno=2 (ELSE)}
      gotoxy(j1,12);
      write('U');
      gotoxy(j2,14);
      write('M');
      Informacion(dado);
      a:=readkey
    END;

  PROCEDURE Juego;
  {Es el procedimiento principal que permite jugar utilizando todos los
  procedimientos definidos anteriormente}
    VAR
      pos,cal,j1,j2,turno:integer;
      a: char;
      pt1,pt2:boolean;
    BEGIN
      pt1:=false;
      pt2:=false;
      {Los dos pierde turno los inicializo en falso porque se juega normal.
       En true cuando tenga que perder el turno}
      Elegir_Casillas(pos,cal);
      Dibujar_Tablero(pos,cal);
      Posicion_Inicial(j1,j2,turno);
      a:= readkey;
      REPEAT
        Clrscr;
        Dibujar_Tablero(pos,cal);
        Tirada(j1,j2,turno,pos,cal,pt1,pt2)
      UNTIL (j1=58) OR (j2=58) {Posicion de la columna, no de las casillas}
    END;


{Comienzo del programa principal}
VAR
  resp:char;

BEGIN
  Randomize; {Para romper la secuencia de la tirada.Se pone solo 1 vez}
  REPEAT
    Clrscr;
    Juego;
    {$I-}
      REPEAT
        gotoxy (20,40);
        textcolor(4);
        write ('Quiere volver a jugar? Responda S/N: ');
        readln (resp) ;
      UNTIL (resp='s') OR (resp='S') OR (resp='n') OR (resp='N');
      textcolor(7);
    {$I+}
  UNTIL (resp='n') OR (resp='N')
END.