Program juegodelaoca;
Uses Crt; {para usar la funcion textcolor}
Const {declaracion de constantes para las casillas especiales}
OCA1=5;
OCA2=9;
OCA3=14;
OCA4=18;
OCA5=23;
JARDIN_OCA=27;
PUENTE1=6;
PUENTE2=12;


      {funcion para tirar el dado, el randomize estar fuera}
      {para usarlo solo una vez y no repetirlo en cada llamada}
      Function dado:integer;
        Begin
         dado:=random(6)+1;
        end;


      {procedimiento que dibuja una oca con colores cuando gana el jugador}
      Procedure HasGanado;
       Begin
        textcolor(white);    writeln('           ,---,                    ');
        textcolor(14);    write('      ___');   textcolor(white);
        writeln('`     `,');
        textcolor(14);    write('      `===');textcolor(white);
        textcolor(lightblue);     write('  O   ');  textcolor(white);
        writeln(' :                  ');
        writeln('       `       .                   ');
        writeln('         \     /                    ');
        writeln('          |   |                     ');
        writeln('          |   |    FELICIDADES!!!                 ');
        writeln('          |   |     HAS GANADO!!                 ');
        writeln('          |   |                   , ');
        writeln('         /     \_________________/| ');
        writeln('        |                         |');
        writeln('        |     ___________         |');
        writeln('        |     __________7        / ');
        textcolor(lightblue);
        write(' ^-^-^-^');   textcolor(white);
        write('|     ________7        /');
        textcolor(lightblue);
        writeln(' ^-^-^ ');
        write(' ^-^-^-^');  textcolor(white);
        write('|     ______7        /');
        textcolor(lightblue);
        writeln(' ^-^-^-^     ');
        write(' ^-^-^-^'); textcolor(white);
        write(' \_________________/');
        textcolor(lightblue);    writeln(' ^-^-^-^-^      ');
        writeln(' ^-^-^-^-^-^-^-^-^-^-^-^-^-^-^-^-^-^-^   ');
        writeln(' ^-^-^-^-^-^-^-^-^-^-^-^-^-^-^-^-^-^-^   ');
        NormVideo;

    end;


      {Procedimiento que muestra el tablero, sealando las casillas especiales}
      {en distintos colores, salvo posada y calavera que los muestra al margen}
      {por ello el uso de dos parametros}
      Procedure tablero(muestraposada,muestracalavera:integer);
        Begin
         textcolor(white);
         writeln('       _____________________________ ');
         writeln('      |    |    |    |    |    |    |');
         write('      | 15 |');
         textcolor(12);      write(' 14');    textcolor(white);
         write(' | 13 |');
         textcolor(14);      write(' 12');    textcolor(white);
         write(' | 11 | 10 |');   writeln('   Posada = ',muestraposada,'   Calavera = ',muestracalavera);
         writeln('      |____|____|____|____|____|____|');
         writeln('      |    |    |    |    |    |    |');
         write('      | 16 |');
         textcolor(lightblue); write(' 27');  textcolor(white);
         write(' | 26 | 25 |');
               write(' 24');
         write(' |');
         textcolor(12);      write(' 9');  textcolor(white);
         write('  |');
         textcolor(12);      writeln('   ---- OCA'); textcolor(white);
         writeln('      |____|____|____|____|____|____|');
         writeln('      |    |    | EL JUEGO|    |    |');
         write('      | 17 |');
         write('   ');
         write(' |  DE LA  |');
         textcolor(12);      write(' 23');  textcolor(white);
         write(' | 8  |');
         textcolor(14);      writeln('   ---- PUENTE'); textcolor(white);
         writeln('      |____|____|___OCA___|____|____|');
         writeln('      |    |    |    |    |    |    |');
         write('      |');
         textcolor(12);      write(' 18');  textcolor(white);
         write(' | 19 | 20 | 21 | 22 | 7  |');
         textcolor(lightblue);      writeln('   ---- JARDIN DE LA OCA'); textcolor(white);
         writeln('      |____|____|____|____|____|____|');
         writeln('      |    |    |    |    |    |    |');
         write  ('      | 1  | 2  | 3  | 4  |');
         textcolor(12);      write(' 5'); textcolor(white);
         write('  |');
         textcolor(14);      write(' 6');    textcolor(white);
         writeln('  |');
         writeln('      |____|____|____|____|____|____|');
         NormVideo;
        end;


      {Procedimiento para calcular el "efecto rebote" que tiene la oca}
      {cuando se llega a la casilla 27, para que asi sea una partida finita}
      Procedure rebote (dador:integer; var casilla_actual:integer);
        Begin
         if (casilla_actual+dador>JARDIN_OCA) then
             casilla_actual:=JARDIN_OCA-(casilla_actual+dador-JARDIN_OCA)
             else
             casilla_actual:=casilla_actual+dador;
        end;


      {Procedimiento que pide las casillas posada y calavera, con todas}
      {sus restricciones respectivamente, 2 parmetros entrada/salida}
      Procedure pidedatos (var pideposada,pidecalavera:integer);
        Begin

         pideposada:=5;
         writeln('Antes de introducir la casilla posada y calavera:');
         writeln('Tenga en cuenta que no pueden ser casillas especiales!');
         writeln('Tales como ocas (5,9,14,18 y 23), puentes (6 y 12) y jardn de la oca (27)');
         writeln('Adems,la posada tiene que estar despus de los puentes.');
         writeln; {para descargarlo esteticamente}

         {$I-}
         while((IOResult<>0) or (pideposada=OCA3) or (pideposada=OCA4) or (pideposada=OCA5) or (pideposada=PUENTE1)
         or (pideposada=PUENTE2) or (pideposada<13) or (pideposada>26)) do
         begin
            write('Introduzca el nmero de la casilla con posada: ');
            readln(pideposada);
         end;
         {$I+}


         {se hace la iteracion analoga a la posada teniendo en cuenta que
         ahora no puede ser la misma posicin que la que se ha elegido antes
         en la posada y no hay restriccin por los puentes}

         pidecalavera:=5;

         {$I-}
         while(IOResult<>0) or (pidecalavera=OCA1) or (pidecalavera=OCA2) or (pidecalavera=OCA3) or (pidecalavera=OCA4)
         or (pidecalavera=OCA5) or (pidecalavera=6) or (pidecalavera=12) or (pidecalavera=JARDIN_OCA)
         or (pidecalavera=pideposada) or (pidecalavera>JARDIN_OCA) or (pidecalavera<2) do
         begin
            write('Introduzca el nmero de la casilla con calavera: ');
            readln(pidecalavera);
         end;
         {$I+}

        end;


      {Procedimiento que te mueve a la oca siguiente en el tablero cuando}
      {caes en una de ella, si caes en la ltima oca, ganas}
      Procedure Oca(var casillajug:integer);
        Begin
         Case casillajug of

          OCA1:Begin casillajug:=OCA2;
          writeln('De oca a oca y tiras porque te toca!');
          end;
          OCA2:Begin casillajug:=OCA3;
          writeln('De oca a oca y tiras porque te toca!');
          end;
          OCA3:Begin casillajug:=OCA4;
          writeln('De oca a oca y tiras porque te toca!');
          end;
          OCA4:Begin casillajug:=OCA5;
          writeln('De oca a oca y tiras porque te toca!');
          end;
          OCA5:Begin casillajug:=JARDIN_OCA;
          writeln('De oca a oca y tiras porque te toca!');
          end;

         end;
        end;


      {Procedimiento que te lleva a la posada si caes en un puente}
      {1 parametro de entrada para la posada y uno de entrada/salida}
      {para la posicin actual, porque hay que actualizarla}
      Procedure Puente(posadap:integer;var casillajugp:integer);
        begin
          if (casillajugp=PUENTE1) or (casillajugp=PUENTE2) then
              begin
               casillajugp:=posadap;
               writeln('Has caido en un puente! Vas a la posada!');
               readln;
              end;
        end;


      {Procedimiento que te lleva a la casilla 1 si caes en la calavera,}
      {parmetros anlogos al procedimiento anterior}
      Procedure Calave(calaverap:integer;var casillajugpc:integer);
        begin
          if (calaverap=casillajugpc) then
             begin
              casillajugpc:=1;
              writeln('Has caido en la calavera, vuelves a la casilla ',casillajugpc);
             end;
        end;

      {Procedimiento para comprobar la casilla y ver qu hacer con el turno}
      Procedure Compruebacasillaturno(casillaplayer,posadabis:integer;var turnop:integer;var changeturno:boolean);
         Begin
          if (casillaplayer=OCA1) or (casillaplayer=OCA2) or (casillaplayer=OCA3)  {comprueba ocas}
            or (casillaplayer=OCA4) or (casillaplayer=OCA5) then
             begin
                  if (turnop=1) then
                    turnop:=1                        {Primero se comprueba en que turno esta}
                    else turnop:=2;                  {y si es oca repite turno el jugador al que le toque}
                  writeln('Repites turno!');
                  readln;
             end
             else if casillaplayer=posadabis then        {si no es oca... si es posada}
                   begin                        {se vuelve a comprobar en que turno esta y}
                    changeturno:=false;                    {no cambiara turno en el siguiente turno}
                    if turnop=1 then                           { y sera turno del otro jugador}
                      turnop:=2
                      else
                      turnop:=1
                   end
             else
                  if changeturno then          {si no es posada ni oca, hay que cambiar turno}
                     if turnop=1 then
                       turnop:=2
                       else turnop:=1            {luego sera el turno del siguiente jugador}
                  else
                     changeturno:=true;         {el otro jugador esta en la posada
                                                luego se repite el turno pero cambia el
                                                booleano para que solo se repita 1 vez}

        end;



Var
  posada, calavera, turno, casillaj, casillam, midado:integer;
  cambiaturno:boolean;

  {* Nota: se ha declarado una variable midado para asignarle el valor de}
  {La funcin dado, y asi tener el mismo valor de dado, ya que lo usamos}
  {varias veces por iteracin, para decir "ha salido 5" y para operar con}
  {dicho valor}


  { ---------------- EMPIEZA EL PROGRAMA --------------- }
Begin
randomize; {para que el valor random sea distinto cada vez}

  writeln('BIENVENIDO AL JUEGO DE LA OCA!');
  writeln('');



  pidedatos(posada,calavera);   {llamada al procedimiento para pedir posada
                                y calavera}
  cambiaturno:=true;
  casillaj:=0;
  casillam:=0;
  turno:=1; {cuando turno=1 es turno del jugador, cuando es 2, de la maquina}
  writeln('');
  writeln('COMIENZA EL JUEGO!');
  writeln('');
  repeat

    while (turno=1) do
      begin
        writeln('Tire su dado! (Presione ENTER)');
        readln;
        midado:=dado;
        writeln('Ha salido ',midado);

        rebote(midado,casillaj);
        Puente(posada, casillaj);
        Oca(casillaj);
        Calave(calavera,casillaj);
        writeln('El jugador est en la casilla ',casillaj);
        writeln('La mquina est en la casilla ',casillam);
        writeln('');
        tablero(posada,calavera);readln; clrscr;
        readln;
        Compruebacasillaturno(casillaj,posada,turno,cambiaturno);


      end;

    While (turno=2) do
      begin
        If (casillaj<>JARDIN_OCA) then
           Begin
             writeln('La mquina tira el dado (Presione ENTER)');
             readln;
             midado:=dado;
             writeln('Ha salido ',midado);


             rebote(midado,casillam);
             Puente(posada, casillam);
             Oca(casillam);
             Calave(calavera,casillam);
             writeln('La mquina est en la casilla ',casillam);
             writeln('El jugador est en la casilla ',casillaj);
             writeln('');
             tablero(posada,calavera); readln;  clrscr;
             readln;
           end;
            Compruebacasillaturno(casillam,posada,turno,cambiaturno);

      end;

  until (casillaj=JARDIN_OCA) or (casillam=JARDIN_OCA);
  if (casillaj=JARDIN_OCA) then
  begin
   HasGanado;
   end
   else
    writeln('Ha ganado la mquina!');
    readln;
end.