{Nombre: David Fron Ayala
Especialidad: Elctricidad
Grupo: G12
Puesto: 02
Practica: D1 }


Program Oca;
Uses crt;
const
max_casillas=27;
type
casilla=record
  numero:integer;
  tipo:string[10];
  player1,player2:string[1];

end;
tablero=array [1..max_casillas] of casilla;
cadena1=string[1];
var
t_oca:tablero;
turno:cadena1;
dado:byte;
fin_partida:string[1];
posicion,posicion_aux,extra_h,extra_m,posada:byte;
esperar:char;

{Para la resolucion del juego de la Oca se ha decidido utiliar un vector de registros. Cada registro esta
compuesto por 4 campos: numero, tipo, player1 y player2. El vector tiene 27 resgistros, correspondientes
a las 27 casillas del Juego de la OCA.}


function tirar_dado(t2:cadena1): byte;
{Esta funcion nos devuelve la tirada del dado en cada turno}

var
   num: byte;
   t:char;
begin

   gotoxy(1,16);Write('                                                ');
   gotoxy(1,16);
   if (t2='m')
   then write('Tira dado Maquina')
   else write('Tira dado Usuario');
   t:=readkey;

   num:=random(6);
   num:=num + 1;

   gotoxy(1,16);
   if (t2='m')
   then write('AVANZA Maquina: ',num, ' casillas')
   else write('AVANZA Usuario: ',num, ' casillas');
   t:=readkey;
   tirar_dado:=num;
end;



function buscar_player(t:cadena1;x:tablero): byte;
{El objetivo de esta funcion es la de obtener la posicion de el jugador (maquina o usuario)}

var
   i: byte;
begin
  buscar_player:=0;
  for i:=1 to max_casillas do begin
    if ((t='m') and (x[i].player1='x')) then
    begin;
     buscar_player:=i;
     exit;
    end;
    if ((t='h') and (x[i].player2='x')) then
    begin;
     buscar_player:=i;
     exit;
    end;
  end;
end;



function obtener_posada(x:tablero): byte;
{ la funcion nos devuelve la  posicion de la posada en el vector}

var
   i: byte;
begin
  obtener_posada:=0;
  for i:=13 to max_casillas do begin
    if x[i].tipo='POSADA    ' then
    begin;
     obtener_posada:=i;
     exit;
    end;
  end;
end;



function obtener_final_partida(x:tablero): cadena1;
{Devuelve si se ha llegado a la casilla 27, para saber si ha terminado juego}

begin
  if ((x[max_casillas].player1='x') or (x[max_casillas].player2='x'))
  then obtener_final_partida:='s'
  else obtener_final_partida:='n';
end;



Procedure cargar_tabla(var x:tablero;cal,posda:real);
{pinta el tablero inicial con los parametros que el jugador marque}
var
 i:byte;

begin
  for i:=1 to max_casillas do begin
       case i of
          5,9,14,18,23: x[i].tipo:='OCA       ';
          6,12: x[i].tipo:='PUENTE    ';
          else begin;
             if (i=cal) then x[i].tipo:='CALAVERA  '
             else if (i=posda) then x[i].tipo:='POSADA    '
                  else x[i].tipo:='          ';
          end;
       end;
  end;
end;


Procedure introducir_datos(var x:tablero);
{Introduccion de datos por teclado}

var
 i,j:byte;
 vpuente1,vpuente2:byte;
 vposada,vcalavera:real;
begin
  clrscr;
  vpuente1:=6;
  vpuente2:=12;
  vposada:=0;
  vcalavera:=0;
  repeat
     {$I-}
     writeln ('En que casilla quiere la posada ');
     readln(vposada);
     while IORESULT <>0 do begin
     writeln ('Valor erroneo, tiene que introducir un numero dentro del rango');
     readln(vposada)
    end;
    {$I+}
  until ((vposada>0)and (vposada<max_casillas)and
         (vposada<>5) and (vposada<>9) and (vposada<>14) and
         (vposada<>18) and (vposada<>23)and (vposada>vpuente1) and
         (vposada>vpuente2));
  repeat
     {$I-}
     writeln ('En que casilla quieres la calavera');
     readln(vcalavera);
     while IORESULT <>0 do begin
     writeln ('Valor erroneo, tiene que introducir un numero dentro del rango');
     readln(vcalavera)
    end;
     {$I+}
  until ((vcalavera>0) and (vcalavera<max_casillas)and
         (vcalavera<>5) and (vcalavera<>9) and (vcalavera<>14) and
         (vcalavera<>vposada)and (vcalavera<>18) and
         (vcalavera<>23) and (vcalavera<>vpuente1) and
         (vcalavera<>vpuente2));
  clrscr;

  cargar_tabla(x,vcalavera,vposada);
end;


Procedure movimiento_players(t:cadena1;d,p:byte;var x:tablero);
{Nos indica la poscion inicial y la posicion nueva donde va la ficha}
var
  i,pn:byte;
begin
  pn:=p+d;
  if pn>=28 then pn:=max_casillas-(pn-max_casillas);
  if (t='m') then begin;
     if p<>0 then x[p].player1:=' ';
     if x[pn].tipo='CALAVERA  '
     then x[1].player1:='x'
     else begin;
       case pn of
          23:pn:=max_casillas;
          18:pn:=23;
          14:pn:=18;
           9:pn:=14;
           5:pn:=9;
        6,12:pn:=obtener_posada(x);
       end;
       x[pn].player1:='x';
     end;
  end

  else begin;
     if p<>0 then x[p].player2:=' ';
     if x[pn].tipo='CALAVERA  '
     then x[1].player2:='x'
     else begin;
       case pn of
          23:pn:=max_casillas;
          18:pn:=23;
          14:pn:=18;
           9:pn:=14;
           5:pn:=9;
        6,12:pn:=obtener_posada(x);
       end;
       x[pn].player2:='x';
     end;
  end;
end;


Procedure  obtener_turno (p,po:byte;var t:cadena1; var ex_h,ex_m:byte);
{Nos dice a quien le toca el turno de juego }

begin
 if t='m' then
  begin;
     case p of
          5,9,14,18,23: t:='m';
          else begin;
             if p=po then
             begin;
              ex_h:=1;
              t:='h';
             end
             else begin;
               if ex_m=0 then t:='h'
               else ex_m:=0;
             end;
          end;
    end;
  end
  else begin;
     case p of
          5,9,14,18,23: t:='h';
          else begin;
             if p=po then
             begin;
              ex_m:=1;
              t:='m';
             end
             else begin;
               if ex_h=0 then t:='m'
               else ex_h:=0;
             end;
          end;
    end;
  end;
end;


Procedure dibujar(x:tablero);
{Procedimiento para dibujar tablero, con colores...}

var
  i:byte;
begin

     clrscr; textcolor(white);

     gotoxy (1,13); write('La OCA');
     gotoxy (1,14); write('Maquina:P1');
     gotoxy (1,15); write('Usuario:P2');

     gotoxy(1,1);write ('Nu');
     gotoxy(6,1);write('Tipo');
     gotoxy(15,1);write('P1   P2 ');

     gotoxy(25,1);write ('Nu');
     gotoxy(30,1);write('Tipo');
     gotoxy(39,1);write('P1   P2 ');

     gotoxy(49,1);write ('Nu');
     gotoxy(54,1);write('Tipo');
     gotoxy(63,1);write('P1   P2 ');

     for i:=1 to max_casillas do begin
       if x[i].tipo='OCA       ' then textcolor(yellow)
       else if x[i].tipo='CALAVERA  ' then textcolor(red)
            else if x[i].tipo='POSADA    ' then textcolor(green)
                 else if x[i].tipo='PUENTE    ' then textcolor(blue)
                      else Normvideo;
       if (i<=9)
       then begin;
         gotoxy(1,i+1);
         write(i,'    ',x[i].tipo, x[i].player1,'    ',x[i].player2);
       end
       else begin;
          if (i>=19)
          then gotoxy(49,i-17)
          else gotoxy(25,i-8);
          write(i,'   ',x[i].tipo, x[i].player1,'    ',x[i].player2);
       end;
     end;
  end;


Procedure ganador(x:tablero);
{Indica quien ha ganado la partida, con color...}

begin
  gotoxy(1,18);textcolor(white);
  if x[max_casillas].player1='x' then writeln ('Ha ganado la maquina.Pulse una tecla para finalizar juego.')
  else writeln ('Ha ganado el usuario.Pulse una tecla para finalizar juego.');
  esperar:=readkey;
end;


Procedure actualizar_mov_extras (p,p_aux,vposada:byte; var ex_h,ex_m:byte);
{Inicializa los movimientos extraordinarios de los jugadores, cuando ambos jugadores caen en la posada }

begin
  if ((p=p_aux) and (p=vposada)) then
    begin;
      ex_h:=0;
      ex_m:=0;
    end;
end;


begin
  randomize;
  clrScr;
  turno:='m';
  extra_h:=0;
  extra_m:=0;
  posicion_aux:=0;
  introducir_datos(t_oca);
  posada:=obtener_posada(t_oca);
  fin_partida:=obtener_final_partida(t_oca);
  repeat
     dibujar(t_oca);
     dado:=tirar_dado(turno);
     posicion:=buscar_player(turno,t_oca);
     movimiento_players(turno,dado,posicion,t_oca);
     dibujar(t_oca);
     posicion:=buscar_player(turno,t_oca);
     obtener_turno(posicion,posada,turno,extra_h,extra_m);
     posicion:=buscar_player('m',t_oca);
     posicion_aux:=buscar_player('h',t_oca);
     actualizar_mov_extras(posicion,posicion_aux,posada,extra_h,extra_m);
     fin_partida:=obtener_final_partida(t_oca);
  until fin_partida='s';
  ganador(t_oca);
end.