Program OCA;
uses crt;

{Presentacin inicial:Presenta un ttulo para el juego}
Procedure Presentacion;
Begin
     writeln;
     writeln('               VAMOS A JUGAR AL JUEGO DE LA OCA!');
     writeln;
     writeln;
     writeln('           *****************************************');
     writeln('           **            JUEGO DE LA OCA          **');
     writeln('           *****************************************');
     writeln;
     writeln;
end;

{Elegir casilla posada:Pide al usuario la posicion de la casilla posada}
Procedure PosPosada(var posada:byte);
begin

     {$I-}
     repeat

          begin
               writeln;
               writeln ('Introduce la posicin de la POSADA. Debe ser posterior a cualquier casilla');
               writeln;
               writeln(' puente y menor que el nmero total de casillas (27).');
               writeln;
               readln(posada);

               If ((posada=9) or (posada=14) or (posada=18) or (posada=23) or (posada=27)) then
               begin
                    writeln;
                    writeln('Introduce una casilla que no sea OCA.');
                    writeln
               end;


               {Posada no puede ser mayor que el total de casillas}
               If (posada>27) then
               begin
                    writeln;
                    writeln('Tiene que ser un nmero menor que el nmero de casillas.');
                    writeln
               end;

               {Posada no puede ser una casilla puente}
               If ((posada=6) or (posada=12)) then
               begin
                    writeln;
                    writeln('Introduce una casilla que no sea PUENTE.');
                    writeln
               end;

               If (posada<13) then
               begin
                    writeln;
                    write('La casilla posada tiene que ser posterior a cualquier ');
                    writeln('casilla puente.');
                    writeln
               end;

          end;

     until (ioresult=0) and (posada>=13) and (posada<>6) and (posada<>12) and (posada<>9) and (posada<>14) and (posada<>18)
     and (posada<>23) and (posada<27);
     {$I+}

     writeln;
     writeln('Posada es la casilla ',posada);
     writeln
end;



{Elegir casilla calavera}

Procedure PosCalavera (var calavera:byte); {Pide al usuario la posicion de la casilla calavera}
begin

     {$I-}
     repeat

          begin
               writeln;
               writeln ('Introduce la posicion CALAVERA.');
               writeln ('Nmero menor que el nmero total de casillas (27)');
               writeln;

               readln(calavera);

               {Informa al usuario de que la casilla que ha elegido es una casilla oca}
               If ((calavera=5) or (calavera=9) or (calavera=14) or (calavera=18) or (calavera=23) or (calavera=27)) then
               begin
                    writeln;
                    writeln('Introduce una casilla que no sea oca.');
                    writeln;
               end;

               {Informa al usuario de que la casilla que ha elegido es casilla puente}
               If ((calavera=6) or (calavera=12)) then
               begin
                    writeln;
                    writeln('Introduce una casilla que no sea puente.');
                    writeln
               end;


               {Informa al usuario de que ha tecleado un numero mayor que el total de casillas}
               If (calavera>27) then
               begin
                    writeln;
                    writeln('Teclea un nmero menor que el total de casillas.');
                    writeln
               end;

          end;

     until (ioresult=0) and (calavera<>5) and (calavera<>6) and (calavera<>12)
     and (calavera<>9) and (calavera<>14) and (calavera<>18) and (calavera<>23)
     and (calavera<27);
     {$I+}
     writeln;
     writeln('Calavera es la casilla ',calavera);

end;

{Preguntamos al usuario quien empieza}

procedure QuienEmpieza (var jugador:char);

begin
     repeat

           writeln;
           write('QUIEN EMPIEZA?');
           writeln('PULSA "A" SI EMPIEZAS TU O PULSA "B" SI EMPIEZO YO.');
           writeln;
           readln(jugador);

           case jugador of
                          'A','a': begin
                                        writeln;
                                        write('HAS TECLEADO ',jugador,',');
                                        writeln(' EMPIEZAS TU.');
                                        writeln;
                                        jugador:='A';
                                   end;

                          'B','b': begin
                                        writeln;
                                        write('HAS TECLEADO ',jugador,',');
                                        writeln(' EMPIEZO YO.');
                                        writeln;
                                        jugador:='B';
                                   end;


           end; {CIERRA EL "CASE...OF"}

     until (jugador='A') or (jugador='a') or (jugador='B') or (jugador='b');
end;


{Lanzar el dado}

Function LanzarDado (var dado:byte):byte;
var
   i:integer;
begin

     dado:=1+random(6); {aleatorio}
     writeln('El resultado de lanzar el dado es ',dado);
     LanzarDado:= dado;
end;

{Procedure finaliza}

procedure finaliza (posicionA, posicionB:integer);
var
   ganador:char;
begin
     if (posicionA=27) then
        begin
             ganador:='A';
             writeln('GANA EL USUARIO.')
        end;

     if (posicionB=27) then
        begin
             ganador:='B';
             writeln ('GANA LA MAQUINA.')
        end

end;


{Declaracion de variables}

var
   ContadorTurnosA,ContadorTurnosB:byte;
   jugador:char;
   posicionA, posicionB:byte;
   dado:byte; posada:byte;
   calavera:byte;
   test:integer;

begin
     clrscr;   {Limpia la pantalla}
     randomize; {Permite usar random}
     ContadorTurnosA:=0;  {Inicializamos contadores de turnos}
     ContadorTurnosB:=0;
     posicionA:=0;       {Inicializamos posiciones}
     posicionB:=0;
     writeln;
     writeln;
     Presentacion;
     PosPosada(posada);
     PosCalavera(calavera);

     {LLamada al procedimiento para preguntar al usuario si empieza A o B}
     QuienEmpieza(jugador);

     {Empezamos ajugar}

REPEAT

   begin

     If ((jugador='A') or (jugador='a')) then
        begin
             writeln;
             writeln('Juega el jugador A ');
             writeln;
             writeln('Pulsa enter para lanzar el dado.');
             readln;
             dado:=LanzarDado(dado);    {LLamamos a la funcion LanzarDado para lanzar el dado}
             test:=posicionA+dado;      {Comprobar llegada al final}
             If (test>=27) then
                       begin
                       posicionA:=posicionA-dado +2*(27-posicionA);
                       test:=0;
                       end
             else posicionA:=posicionA + dado;   {Nueva posicion del jugador}
             writeln;
             writeln('El jugador A est en la casilla: ',posicionA);
             end;

             jugador:='B';
             If ContadorTurnosB=1 then
                begin
                jugador:='A';
                ContadorTurnosB:=0
                end;
             {Casillas puente}

             If ((posicionA=6) or (posicionA=12)) then
             begin
                  writeln;
                  writeln('Has cado en un puente.');
                  posicionA:=posada;
                  writeln('Pasas a la casilla posada. Casilla: ',posicionA);
                  writeln;
                  ContadorTurnosA:=1;
                  jugador:='B'
             end;


             {Casilla posada}

             If posicionA=posada then
                begin
                     writeln;
                     writeln('Has cado en la POSADA. Pierdes un turno.');
                     writeln;
                     ContadorTurnosA:=1;  {El jugador A pierde un turno}
                     jugador:='B'
                end;

             {Casilla calavera}

             If posicionA=calavera then
                begin
                     writeln;
                     writeln('Has cado en la casilla CALAVERA.');
                     posicionA:=1;     {Vuelve a la casilla 1}
                     writeln('Vuelves a la casilla 1');
                     jugador:='B';
                     writeln
                end;
             {Oca}
             If  posicionA=5 then   {Si cae en la casilla 5 pasa a la 9}
                            begin
                            writeln;
                            writeln('HAS CAIDO EN OCA.');
                            writeln;
                            writeln('PASAS A LA SIGUIENTE OCA: 9');
                            posicionA:=9;
                            writeln;
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=LanzarDado(dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A est en la casilla: ',posicionA);
                            writeln;
                            end;
                            If ContadorTurnosB=0 then jugador:='B'
                      end;

             If posicionA=9 then    {Si cae en la casilla 9 pasa a la 14}
             begin
                            begin
                            writeln;
                            writeln('HAS CAIDO EN OCA.');
                            writeln;
                            writeln('PASAS A LA SIGUIENTE OCA.');
                            writeln;
                            posicionA:=14;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln;
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=LanzarDado(dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A esta en la casilla: ',posicionA);
                            writeln;
                      end;



             If ContadorTurnosB=0 then       {Cambia de turno}
                jugador:='B'
        end;




             If posicionA=14 then   {Si cae en la casilla 14 pasa a la 18}
             begin
                            begin
                            writeln;
                            writeln('HAS CAIDO EN OCA.');
                            writeln;
                            writeln('PASAS A LA SIGUIENTE OCA.');
                            posicionA:=18;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln;
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=LanzarDado(dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A esta en la casilla: ',posicionA);
                            writeln;
                      end;



             If ContadorTurnosB=0 then jugador:='B'
        end;

             If posicionA=18 then
             begin
                            begin
                            writeln;
                            writeln('HAS CAIDO EN OCA.');
                            writeln;
                            writeln('PASAS A LA SIGUIENTE OCA.');
                            posicionA:=23;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln;
                            writeln('Pulsa enter para volver a tirar.');
                            readln;
                            dado:=LanzarDado(dado);
                            writeln;
                            posicionA:=posicionA + dado;
                            writeln('El jugador A esta en la casilla: ',posicionA);
                            writeln
                      end;



             If ContadorTurnosB=0 then jugador:='B'
        end;


             If posicionA=23 then
             begin
                            begin
                            writeln;
                            writeln('HAS CAIDO EN OCA.');
                            writeln;
                            writeln('PASAS A LA SIGUIENTE OCA.');
                            posicionA:=27;
                            writeln('La nueva posicion es la casilla: ',posicionA);
                            writeln;
                            writeln('HAS LLEGADO AL JARDIN DE LA OCA!!!.');
                            writeln('Has ganado el juego.');
                            writeln;


                      end;
        end;


     {Juega la maquina}

      If ((jugador='B') or (jugador='b')) then

              begin
                   writeln;
                   ContadorTurnosB:=ContadorTurnosB + 1;
                   writeln;
                   writeln('Juega el jugador B.');
                   writeln;
                   dado:=LanzarDado(dado);
                   test:=posicionB+dado;
                   If (test>=27) then
                       begin
                       posicionB:=posicionB-dado +2*(27-posicionB);
                       test:=0;
                       end
                   else posicionB:=posicionB + dado;

                   writeln;
                   writeln('El jugador B esta en la casilla: ',posicionB);

                   jugador:='A';
                   If ContadorTurnosA=1 then
                      begin
                      jugador:='B';
                      ContadorTurnosA:=0
                      end;

                   {Casillas puente}


                   If ((posicionB=6) or (posicionB=12)) then
                   begin
                        writeln;
                        writeln('Ha caido en PUENTE.');
                        writeln;
                        writeln('Pasa a la casilla posada: ',posada);
                        posicionB:=posada;
                        ContadorTurnosB:=1;
                        jugador:='A'
                   end;

                   {Casilla posada}

             If posicionB=posada then
                begin
                     writeln('Pierdes turno.');
                     ContadorTurnosB:=1;
                     jugador:='A'
                end;

                  {Casilla calavera}

             If posicionB=calavera then
                begin
                     writeln('Ha caido en casilla CALAVERA.');
                     writeln('Vuelve a la casilla 1');
                     posicionB:=1;
                     jugador:='A'
                 end;

              {Oca}

             If  posicionB=5 then
                      begin
                            writeln;
                            writeln('HA CAIDO EN OCA.');
                            writeln;
                            writeln('PASA A LA SIGUIENTE OCA: 9');
                            posicionB:=9;
                            writeln;
                            dado:=LanzarDado(dado);
                            writeln;
                            posicionB:=posicionB + dado;
                            writeln('El jugador B est en la casilla: ',posicionB);
                        end;

                        If ContadorTurnosA=1 then jugador:='B'
                            else jugador:='A';
                      end;

             If posicionB=9 then
             begin
                            begin
                            writeln;
                            writeln('HA CAIDO EN OCA.');
                            writeln;
                            writeln('PASA A LA SIGUIENTE OCA: 14');
                            posicionB:=14;
                            writeln('La nueva posicin es la casilla: ',posicionB);
                            writeln;
                            dado:=LanzarDado(dado);
                            writeln;
                            posicionB:=posicionB + dado;
                            writeln('El jugador B est en la casilla: ',posicionB);

                            end;

                            If ContadorTurnosA=1 then jugador:='B'
                            else jugador:='A';
        end;




             If posicionB=14 then
             begin
                            begin
                            writeln;
                            writeln('HA CAIDO EN OCA.');
                            writeln;
                            writeln('PASA A LA SIGUIENTE OCA: 18');
                            posicionB:=18;
                            writeln('La nueva posicin es la casilla: ',posicionB);
                            writeln;
                            dado:=LanzarDado(dado);
                            writeln;
                            posicionB:=posicionB + dado;
                            writeln('El jugador B est en la casilla: ',posicionB);

                            end;

                            If ContadorTurnosA=1 then jugador:='B'
                            else jugador:='A';
        end;

             If posicionB=18 then
             begin
                            begin
                            writeln;
                            writeln('HA CAIDO EN OCA.');
                            writeln;
                            writeln('PASA A LA SIGUIENTE OCA: 23');
                            posicionB:=23;
                            writeln('La nueva posicin es la casilla: ',posicionB);
                            dado:=LanzarDado(dado);
                            writeln;
                            posicionB:=posicionB + dado;
                            writeln('El jugador B est en la casilla: ',posicionB);

                      end;

                      If ContadorTurnosA=1 then jugador:='B'
                      else jugador:='A';
        end;


             If posicionB=23 then
             begin
                            begin
                            writeln;
                            writeln('HA CAIDO EN OCA.');
                            writeln;
                            writeln('PASA A LA SIGUIENTE OCA: 27');
                            posicionB:=27;
                            writeln('La nueva posicion es la casilla: ',posicionB);
                            writeln('HA LLEGADO AL JARDIN DE LA OCA!!!');
                            writeln('Ha ganado el juego.');
                            writeln;
                            end;

        end;





until ((posicionA=27) or (posicionB=27)) ;

   {Llamamos al procedimiento "finaliza" que nos muestra quien gana}

finaliza(posicionA,posicionB);

readln;

end.
