
Program Juego_De_La_Oca;  {Vctor Mndez Arnal y Jorge Salas Ortega}
Uses
  crt,dos;
Const
  UltimaCasilla=27;

procedure Presentacion;

begin
  textcolor(white);
  writeln;
  writeln;
  writeln('                BIENVENIDO AL JUEGO DE LA OCA');
  writeln('                -----------------------------');
  writeln;
  writeln;
  write('  |-------------------------------------------------------|');  writeln('  * INSTRUCCIONES *');
  write('  |      -12-|       -11-|      -10-|       -9-|       -8-|');  writeln;
  write('  |  Puente  |           |          |   Oca    |          |');  writeln(' Casillas Oca: Va');
  write('  |          |           |          |          |          |');  writeln(' hasta la siguiente');
  write('  |__________|___________|__________|__________|__________|');  writeln(' oca, vuelve a tirar');
  write('  |      -13-|       -24-|      -23-|      -22-|       -7-|');  writeln;
  write('  |          |           |   Oca    |          |          |');  writeln(' Casillas Puente:');
  write('  |          |           |          |          |          |');  writeln(' Salta a la posada y');
  write('  |__________|___________|__________|__________|__________|');  writeln(' pierde un turno');
  write('  |      -14-|       -25-|      -27-|      -21-|       -6-|');  writeln;
  write('  |   Oca    |           |          |          |  Puente  |');  writeln(' Casilla Posada:');
  write('  |          |           |  JARDIN  |          |          |');  writeln(' Elegida por usted,');
  write('  |__________|___________|  DE LA   |__________|__________|');  writeln(' si cae pierde turno');
  write('  |      -15-|       -26-|   OCA    |      -20-|       -5-|');  writeln;
  write('  |          |           |          |          |   Oca    |');  writeln(' Casilla Calavera:');
  write('  |          |           |          |          |          |');  writeln(' Elegida por usted,');
  write('  |__________|___________|__________|__________|__________|');  writeln(' si cae vuelve a la');
  write('  |      -16-|       -17-|      -18-|      -19-|       -4-|');  writeln(' casilla nmero 1');
  write('  |          |           |   Oca    |          |          |');  writeln;
  write('  |          |           |          |          |          |');  writeln(' Casilla Jardn de');
  write('  |__________|___________|__________|__________|__________|');  writeln(' la Oca: El primero');
  write('  |                   -0-|       -1-|       -2-|       -3-|');  writeln(' que llega con el');
  write('  |        INICIO        |          |          |          |');  writeln(' nmero exacto gana,');
  write('  |                      |          |          |          |');  writeln(' sino retrocede las');
  write('  |______________________|__________|__________|__________|');  writeln(' casillas sobrantes');
  writeln;
  writeln;
  writeln;
  writeln('  Instrucciones durante el juego: Para ir avanzando en el juego debe presionar');
  writeln('  la tecla "enter"  la tecla "intro", as mismo tambin tendra que hacerlo');
  writeln('  para lanzar el dado de su jugador y el dado de la computadora.');
  writeln('  __________________________');
  writeln;
  writeln;
  writeln;
end;

{Procedimiento de presentacin del juego, donde se muestra el tablero y unas
pequeas instrucciones de como jugar.}

Procedure posada_y_calavera(var posada,calavera:integer);
begin
  {$I-}
   repeat
      write('  Indique la casilla de la posada (superior a la casilla 12): ');
      readln(posada);
      writeln;
   until (IOResult=0) and (posada>12) and (posada<UltimaCasilla) and (posada<>14)
         and (posada<>18) and (posada<>23);
   {$I+}


   {$I-}
   repeat
      write('  Indique la casilla de la calavera: ');
      readln(calavera);
      writeln;
   until (IOResult=0) and (calavera>0) and (calavera<UltimaCAsilla) and (calavera<>5)
         and (calavera<>6) and (calavera<>9) and (calavera<>12) and (calavera<>14)
         and (calavera<>18) and (calavera<>23) and (calavera<>posada)
   {$I+}
end;

{Procedimiento donde se preguntan dos variables del juego, las casillas de la
posada y de la calavera.}

Procedure Inicializacion(var turno:char; var casillaA,casantA,casillaB,casantB,turnoDobleA,turnoDobleB:integer);
begin
  turno:='A';
  casillaA:=0;
  casantA:=0;
  casillaB:=0;
  casantB:=0;
  turnoDobleA:=3;
  turnoDobleB:=3;
end;

{Procedimiento que inicializa las casillas de los jugadores y el turno antes de
empezar a jugar}

procedure Tablero(turno:char;casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera:integer;ganador:string);

begin
  textcolor(white);
  writeln;
  writeln;
  writeln('                BIENVENIDO AL JUEGO DE LA OCA');
  writeln('                -----------------------------');
  writeln;
  writeln;
  write('  |-------------------------------------------------------|');  writeln('  * PARTIDA *');
  write('  |      -12-|       -11-|      -10-|       -9-|       -8-|');  writeln;
  write('  |          |           |          |          |          |');  writeln(' Turno: ',turno);
  write('  |          |           |          |          |          |');  writeln;
  write('  |__________|___________|__________|__________|__________|');  writeln(' Casilla posada: ',posada);
  write('  |      -13-|       -24-|      -23-|      -22-|       -7-|');  writeln(' Casilla calavera:',calavera);
  write('  |          |           |          |          |          |');  writeln;
  write('  |          |           |          |          |          |');  writeln(' JUGADOR (A)');
  write('  |__________|___________|__________|__________|__________|');  writeln;
  write('  |      -14-|       -25-|      -27-|      -21-|       -6-|');  writeln(' Numero dado: ',dadoA);
  write('  |          |           |          |          |          |');  writeln(' Casilla vieja: ',casantA);
  write('  |          |           |          |          |          |');  writeln(' Casilla nueva: ',casillaA);
  write('  |__________|___________|          |__________|__________|');  writeln;
  write('  |      -15-|       -26-|          |      -20-|       -5-|');  writeln(' MAQUINA (B)');
  write('  |          |           |          |          |          |');  writeln;
  write('  |          |           |          |          |          |');  writeln(' Numero dado: ',dadoB);
  write('  |__________|___________|__________|__________|__________|');  writeln(' Casilla vieja: ',casantB);
  write('  |      -16-|       -17-|      -18-|      -19-|       -4-|');  writeln(' Casilla nueva: ',casillaB);
  write('  |          |           |          |          |          |');  writeln;
  write('  |          |           |          |          |          |');  writeln(' Ficha Jugador: ');
  write('  |__________|___________|__________|__________|__________|');  writeln(' Ficha Mquina: ');
  write('  |                   -0-|       -1-|       -2-|       -3-|');  writeln;
  write('  |        INICIO        |          |          |          |');  writeln;
  write('  |                      |          |          |          |');  writeln('    ',ganador);
  write('  |______________________|__________|__________|__________|');  writeln;
  writeln;
  writeln;
  writeln;
  gotoxy (76,26); textcolor(red); writeln('X');
  gotoxy (76,27); textcolor(blue); writeln('O');

end;

{Procedimiento principal del juego, donde se van mostrando las casillas de los
jugadores, las tiradas que realizan, las fichas, etc.}

Procedure casillas_especiales;

begin
  gotoxy (50,21); textcolor(yellow); writeln('OCA');
  gotoxy (39,9); textcolor(yellow); writeln('OCA');
  gotoxy (5,17); textcolor(yellow); writeln('OCA');
  gotoxy (28,25); textcolor(yellow); writeln('OCA');
  gotoxy (28,13); textcolor(yellow); writeln('OCA');
  gotoxy (50,17); textcolor(green); writeln('PUENTE');
  gotoxy (5,9); textcolor(green); writeln('PUENTE');
  gotoxy (29,18); textcolor(brown); writeln('JARDIN');
  gotoxy (29,19); textcolor(brown); writeln('DE LA');
  gotoxy (30,20); textcolor(brown); writeln('OCA');
end;

{Procedimiento que muestra mediante colores las casillas especiales en el tablero.}

procedure coordenadas(casilla_jugador,casilla_maquina:integer);

begin

   case casilla_jugador of
          0:  begin
                 gotoxy (24,30); textcolor(red);
                 writeln('X');

              end;
          1:   begin
                 gotoxy (35,30); textcolor(red);
                 writeln('X');

              end;
           2:  begin
                 gotoxy (46,30); textcolor(red);
                 writeln('X');

              end;
           3:  begin
                 gotoxy (55,30); textcolor(red);
                 writeln('X');

              end;
           4:  begin
                 gotoxy (55,26); textcolor(red);
                 writeln('X');

              end;
           5:  begin
                 gotoxy (55,22); textcolor(red);
                 writeln('X');

              end;
           6:  begin
                 gotoxy (55,18); textcolor(red);
                 writeln('X');

              end;
           7:begin
                 gotoxy (55,14); textcolor(red);
                 writeln('X');

              end;

           8:begin
                 gotoxy (55,10); textcolor(red);
                 writeln('X');

              end;
           9:begin
                 gotoxy (46,10); textcolor(red);
                 writeln('X');

              end;
          10:begin
                 gotoxy (35,10); textcolor(red);
                 writeln('X');

              end;
          11:begin
                 gotoxy (24,10); textcolor(red);
                 writeln('X');

              end;
          12:begin
                 gotoxy (13,10); textcolor(red);
                 writeln('X');

              end;
          13:begin
                 gotoxy (13,14); textcolor(red);
                 writeln('X');

              end;
          14:begin
                 gotoxy (13,18); textcolor(red);
                 writeln('X');

              end;
          15: begin
                 gotoxy (13,22); textcolor(red);
                 writeln('X');

              end;
          16: begin
                 gotoxy (13,26); textcolor(red);
                 writeln('X');

              end;
          17: begin
                 gotoxy (24,26); textcolor(red);
                 writeln('X');

              end;
          18: begin
                 gotoxy (35,26); textcolor(red);
                 writeln('X');

              end;
          19: begin
                 gotoxy (46,26); textcolor(red);
                 writeln('X');

              end;
          20: begin
                 gotoxy (46,22); textcolor(red);
                 writeln('X');

              end;
          21: begin
                 gotoxy (46,18); textcolor(red);
                 writeln('X');

              end;
          22: begin
                 gotoxy (46,14); textcolor(red);
                 writeln('X');

              end;
          23: begin
                 gotoxy (35,14); textcolor(red);
                 writeln('X');

              end;
          24: begin
                 gotoxy (24,14); textcolor(red);
                 writeln('X');

              end;
          25: begin
                 gotoxy (24,18); textcolor(red);
                 writeln('X');

              end;
          26: begin
                 gotoxy (24,22); textcolor(red);
                 writeln('X');

              end;
          27: begin
                 gotoxy (35,22); textcolor(red);
                 writeln('X');

              end;
         else readln;
       end;

   case casilla_maquina of
          0:  begin
                 gotoxy (21,30); textcolor(blue);
                 writeln('O');

              end;
          1:   begin
                 gotoxy (32,30); textcolor(blue);
                 writeln('O');

              end;
           2:  begin
                 gotoxy (43,30); textcolor(blue);
                 writeln('O');

              end;
           3:  begin
                 gotoxy (52,30); textcolor(blue);
                 writeln('O');

              end;
           4:  begin
                 gotoxy (52,26); textcolor(blue);
                 writeln('O');

              end;
           5:  begin
                 gotoxy (52,22); textcolor(blue);
                 writeln('O');

              end;
           6:  begin
                 gotoxy (52,18); textcolor(blue);
                 writeln('O');

              end;
           7:begin
                 gotoxy (52,14); textcolor(blue);
                 writeln('O');

              end;

           8:begin
                 gotoxy (52,10); textcolor(blue);
                 writeln('O');

              end;
           9:begin
                 gotoxy (43,10); textcolor(blue);
                 writeln('O');

              end;
          10:begin
                 gotoxy (32,10); textcolor(blue);
                 writeln('O');

              end;
          11:begin
                 gotoxy (21,10); textcolor(blue);
                 writeln('O');

              end;
          12:begin
                 gotoxy (10,10); textcolor(blue);
                 writeln('O');

              end;
          13:begin
                 gotoxy (10,14); textcolor(blue);
                 writeln('O');

              end;
          14:begin
                 gotoxy (10,18); textcolor(blue);
                 writeln('O');

              end;
          15: begin
                 gotoxy (10,22); textcolor(blue);
                 writeln('O');

              end;
          16: begin
                 gotoxy (10,26); textcolor(blue);
                 writeln('O');

              end;
          17: begin
                 gotoxy (21,26); textcolor(blue);
                 writeln('O');

              end;
          18: begin
                 gotoxy (32,26); textcolor(blue);
                 writeln('O');

              end;
          19: begin
                 gotoxy (43,26); textcolor(blue);
                 writeln('O');

              end;
          20: begin
                 gotoxy (43,22); textcolor(blue);
                 writeln('O');

              end;
          21: begin
                 gotoxy (43,18); textcolor(blue);
                 writeln('O');

              end;
          22: begin
                 gotoxy (43,14); textcolor(blue);
                 writeln('O');

              end;
          23: begin
                 gotoxy (32,14); textcolor(blue);
                 writeln('O');

              end;
          24: begin
                 gotoxy (21,14); textcolor(blue);
                 writeln('O');

              end;
          25: begin
                 gotoxy (21,18); textcolor(blue);
                 writeln('O');

              end;
          26: begin
                 gotoxy (21,22); textcolor(blue);
                 writeln('O');

              end;
          27: begin
                 gotoxy (32,22); textcolor(blue);
                 writeln('O');

              end;
         else readln;
       end;
end;

{Procedimiento que muestra donde estan las fichas de cada jugador en el tablero
durante toda la partida}

function tiradaA:integer;
begin
  tiradaA:=0;
  tiradaA:=random(6)+1;

end;

{Funcin que hace la funcin del dado y devuelve un nmero aleatorio entre
0 y 6, se utiliza para el jugador A, el usuario.}


function tiradaB:integer;
begin
  tiradaB:=0;
  tiradaB:=random(6)+1;

end;

{Funcin que hace la funcin del dado y devuelve un nmero aleatorio entre
0 y 6, se utiliza para el jugador B, la computadora.}


Procedure Calcula_Casilla_Nueva(var casilla:integer);
Var
  resto:integer;
begin
          gotoxy (5,35); textcolor(white);
          writeln('Hay que retroceder las casillas sobrantes');
          readln;
          clrscr;
          resto:=casilla-UltimaCasilla;
          casilla:=UltimaCasilla-resto;
end;

{Procedimiento que calcula la casilla si en la tirada se ha sobrepasado la ltima.}

Procedure Comprueba_posada(var turn:char;turnoDobleA,turnoDobleB:integer);
var
  aux:char;
begin
   textcolor(white);
   aux:=turn;
   gotoxy (5,35); textcolor(white);
   writeln('  Has cado en la posada, pierdes un turno');
   readln;
   clrscr;
      if aux='A' then
         begin
             turn:='B';
             turnoDobleA:=3;
             turnoDobleB:=4;
         end;

      if aux='B' then
         begin
             turn:='A';
             turnoDobleA:=4;
             turnoDobleB:=3;
         end;
end;

{Procedimiento que al caer en la posada le da el un turno doble al oponente.}

Procedure Comprueba_calavera(var casilla,casant,turnoDobleA,turnoDobleB:integer; var turn:char; cala:integer);
var
  aux:char;
begin
    textcolor(white);
    aux:=turn;
    gotoxy (5,35); textcolor(white);
    writeln('  Has cado en la calavera, retrocedes hasta la casilla 1');
    readln;
    clrscr;
    casilla:=1;
    casant:=cala;

          if (aux='A') and (turnoDobleA=5) then
             begin
                  turn:='A';
                  turnoDobleA:=3;
                  turnoDobleB:=3;
             end;
          if (aux='A') and (turnoDobleA=4) then
             begin
                  turn:='B';
                  turnoDobleA:=3;
                  turnoDobleB:=3;
             end;

          if (aux='B') and (turnodobleB=5) then
             begin
                  turn:='B';
                  turnoDobleB:=3;
                  turnoDobleA:=3;
             end;
          if (aux='B') and (turnoDobleB=4) then
             begin
                  turn:='A';
                  turnoDobleA:=3;
                  turnoDobleB:=3;
             end;
 
end;

{Procedimiento que si se cae en la calavera actualiza las casillas de los
jugadores y los turnos.}

Procedure Comprueba_casilla(var casilla,casant,turnoDobleA,turnoDobleB:integer; var turn:char; var ganad:string; posa:integer);
var
  aux:char;
begin
  textcolor(white);
  aux:=turn;

      case casilla of

                  5:   begin
                         gotoxy (5,35); textcolor(white);
                         writeln('  Casilla de una oca, avanza hasta la siguiente casilla de una oca (9)');
                         writeln('  y vuelve a tirar');
                         readln;
                         clrscr;
                         casilla:=9;
                         casant:=5;
                         turnoDobleA:=3;
                         turnoDobleB:=3;
                          if aux='A' then
                                turn:='A'
                          else
                                turn:='B';

                       end;


                  6:   begin
                         gotoxy (5,35); textcolor(white);
                         writeln('  Casilla de un puente, ve a la posada y pierdes un turno');
                         readln;
                         clrscr;
                         casilla:=posa;
                         casant:=6;

                           if aux='A' then
                              begin
                               turn:='B';
                               turnoDobleA:=3;
                               turnoDobleB:=4;
                              end;
                           if aux='B' then
                              begin
                               turn:='A';
                               turnoDobleA:=4;
                               turnoDobleB:=3;
                              end;
                       end;

                  9:   begin
                         gotoxy (5,35); textcolor(white);
                         writeln('  Casilla de una oca, avanza hasta la siguiente casilla de una oca (14)');
                         writeln('  y vuelve a tirar');
                         readln;
                         clrscr;
                         casilla:=14;
                         casant:=9;
                         turnoDobleA:=3;
                         turnoDobleB:=3;
                           if aux='A' then
                              turn:='A'
                           else
                              turn:='B';

                       end;


                 12:   begin
                         gotoxy (5,35); textcolor(white);
                         writeln('  Casilla de un puente, ve a la posada y pierdes un turno');
                         readln;
                         clrscr;
                         casilla:=posa;
                         casant:=12;
                           if aux='A' then
                              begin
                                turn:='B';
                                turnoDobleA:=3;
                                turnoDobleB:=4;
                              end;
                           if aux='B' then
                              begin
                                turn:='A';
                                turnoDobleA:=4;
                                turnoDobleB:=3;
                              end;
                       end;

                 14:   begin
                         gotoxy (5,35); textcolor(white);
                         writeln('  Casilla de una oca, avanza hasta la siguiente casilla de una oca (18)');
                         writeln('  y vuelve a tirar');
                         readln;
                         clrscr;
                         casilla:=18;
                         casant:=14;
                         turnoDobleA:=3;
                         turnoDobleB:=3;
                           if aux='A' then
                               turn:='A'
                           else
                               turn:='B';

                       end;

                 18:   begin
                         gotoxy (5,35); textcolor(white);
                         writeln('  Casilla de una oca, avanza hasta la siguiente casilla de una oca (23)');
                         writeln('  y vuelve a tirar');
                         readln;
                         clrscr;
                         casilla:=23;
                         casant:=18;
                         turnoDobleA:=3;
                         turnoDobleB:=3;
                           if aux='A' then
                               turn:='A'
                           else
                               turn:='B';

                       end;

                 23:   begin
                         gotoxy (5,35); textcolor(white);
                         writeln('  Casilla de una oca, avanza hasta la siguiente casilla de una oca (27)');
                         readln;
                         clrscr;
                         casilla:=UltimaCasilla;
                         casant:=23;
                         turnoDobleA:=3;
                         turnoDobleB:=3;
                         if turn='A' then
                            ganad:='HAS GANADO'
                         else
                            ganad:='HE GANADO';
                       end;

       UltimaCasilla:  begin
                         readln;
                         clrscr;
                         turnoDobleA:=3;
                         turnoDobleB:=3;
                         if turn='A' then
                            ganad:='HAS GANADO'
                         else
                            ganad:='HE GANADO';

                       end;

                else   begin
                           readln;
                           clrscr;

                           if (aux='A') and (turnoDobleA=5) then
                             begin
                               turn:='A';
                               turnoDobleA:=3;
                               turnoDobleB:=3;
                             end;
                           if (aux='A') and (turnoDobleA=4) then
                              begin
                               turn:='B';
                               turnoDobleA:=3;
                               turnoDobleB:=3;
                              end;

                           if (aux='B') and (turnodobleB=5) then
                             begin
                               turn:='B';
                               turnoDobleB:=3;
                               turnoDobleA:=3;
                             end;
                           if (aux='B') and (turnoDobleB=4) then
                              begin
                               turn:='A';
                               turnoDobleA:=3;
                               turnoDobleB:=3;
                              end;
                       end;
       end;
end;

{Procedimiento que realiza las operaciones necesarias dependiendo de la casilla
donde se hayan quedado los jugadores.}

var
  turnoDobleA,turnoDobleB,posada,casillaA,casantA,casillaB,casantB,dadoA,dadoB,calavera:integer;
  turno:char;
  ganador:string;

begin
  clrscr;
  presentacion;
  posada_y_calavera(posada,calavera);
  clrscr;
  randomize;
  Inicializacion(turno,casillaA,casantA,casillaB,casantB,turnoDobleA,turnoDobleB);
  tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
  casillas_especiales;
  coordenadas(casillaA,casillaB);

    repeat
        begin
         turnoDobleA:=turnoDobleA+1;
         turnoDobleB:=turnoDobleB+1;

            if (turno='A') and (turnoDobleA>3) then
              begin
               gotoxy (5,35); textcolor(white);
               writeln('  Pulse la tecla "enter"  "intro" para lanzar el dado');
               readln;
               clrscr;
               dadoA:=tiradaA;
               casillaA:=casillaA+dadoA;
               casantA:=casillaA-dadoA;
               tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
               casillas_especiales;
               coordenadas(casillaA,casillaB);

               if (turno='A') and (casillaA>UltimaCasilla) then
                  begin
                    Calcula_Casilla_Nueva(casillaA);
                    tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                    casillas_especiales;
                    coordenadas(casillaA,casillaB);

                  end;

                if (turno='A') and (casillaA=posada) then
                   begin
                     Comprueba_posada(turno,turnoDobleA,turnoDobleB);
                     tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                     casillas_especiales;
                     coordenadas(casillaA,casillaB);
                     readln;
                     clrscr;
                   end;

                 if (turno='A') and (casillaA=calavera) then
                   begin
                     Comprueba_calavera(casillaA,casantA,turnoDobleA,turnoDobleB,turno,calavera);
                     tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                     casillas_especiales;
                     coordenadas(casillaA,casillaB);
                     readln;
                     clrscr;
                   end;

                   if (turno='A') then
                          Comprueba_casilla(casillaA,casantA,turnoDobleA,turnoDobleB,turno,ganador,posada);
                            if (turno='A') and (casillaA=UltimaCasilla) then
                                 begin
                                     tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                                     casillas_especiales;
                                     coordenadas(casillaA,casillaB);
                                     readln;
                                     clrscr;
                                 end
                    else

               tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
               casillas_especiales;
               coordenadas(casillaA,casillaB);

             end

            else

              begin
               gotoxy (5,35); textcolor(white);
               writeln('  Pulse la tecla "enter"  "intro" para que lanze el dado la mquina');
               readln;
               clrscr;
               dadoB:=tiradaB;
               casillaB:=casillaB+dadoB;
               casantB:=casillaB-dadoB;
               tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
               casillas_especiales;
               coordenadas(casillaA,casillaB);

                   if (turno='B') and (casillaB>UltimaCasilla) then
                     begin
                        Calcula_Casilla_Nueva(casillaB);
                        tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                        casillas_especiales;
                        coordenadas(casillaA,casillaB);

                     end;

                   if (turno='B') and (casillaB=posada) then
                      begin
                           Comprueba_posada(turno,turnoDobleA,turnoDobleB);
                           tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                           casillas_especiales;
                           coordenadas(casillaA,casillaB);
                           readln;
                           clrscr;
                      end;

                   if (turno='B') and (casillaB=calavera) then
                      begin
                           Comprueba_calavera(casillaB,casantB,turnoDobleA,turnoDobleB,turno,calavera);
                           tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                           casillas_especiales;
                           coordenadas(casillaA,casillaB);
                           readln;
                           clrscr;
                      end;

                   if (turno='B') then
                        Comprueba_casilla(casillaB,casantB,turnoDobleA,turnoDobleB,turno,ganador,posada);

                        if (turno='B') and (casillaB=UltimaCasilla) then
                                  begin
                                      tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
                                      casillas_especiales;
                                      coordenadas(casillaA,casillaB);
                                      readln;
                                      clrscr;
                                  end
                    else

               Tablero(turno,casillaA,casantA,casillaB,casantB,dadoA,dadoB,posada,calavera,ganador);
               casillas_especiales;
               coordenadas(casillaA,casillaB);

              end;

     end;
    until (casillaA=UltimaCasilla) or (casillaB=UltimaCasilla)

end.

