Program Juego_oca;

Uses
   Crt;

Const
   cas_oca=5;
   cas_puente=6;

{Procedure que tira el dado y va actualizando la casilla de los jugadores}
Procedure empezarjuego (var casilla:integer);
   Var
      dados,antes:integer;
   Begin
      antes:=casilla;
      dados:=Random(6)+1;
      casilla:=dados+antes;
      writeln('El valor del dado es: ',dados);
      writeln('Se encuentra en la casilla: ' ,casilla);
      writeln;
   end;

{Procedure que pasa al jugador de oca a oca}
Procedure oca (var usuario:integer);
   Begin
      If usuario=cas_oca then
         Begin
            usuario:=cas_oca+4;
            writeln('Ocaaa!!!Estas en la casilla: ',usuario);
            writeln('Vuelve a lanzar los dados');
            writeln;
            empezarjuego(usuario);
         end;
      If usuario=(cas_oca+4) then
         Begin
            usuario:=(2*cas_oca+4);
            writeln('Ocaaa!!!Estas en la casilla: ',usuario);
            writeln('Vuelve a lanzar los dados');
            writeln;
            empezarjuego(usuario);
         end;
      If usuario=(2*cas_oca+4) then
         Begin
            usuario:=(3*cas_oca+3);
            writeln('Ocaaa!!!Estas en la casilla: ',usuario);
            writeln('Vuelve a lanzar los dados');
            writeln;
            empezarjuego(usuario);
         end;
      If usuario=(3*cas_oca+3) then
         Begin
            usuario:=(4*cas_oca+3);
            writeln('Ocaaa!!!Estas en la casilla: ',usuario);
            writeln('Vuelve a lanzar los dados');
            writeln;
            empezarjuego(usuario);
         end;
      If usuario=(4*cas_oca+3) then
         Begin
            usuario:=(5*cas_oca+2);
            writeln('Ocaaa!!!Estas en la casilla: ',usuario);
            writeln;
          end;
   end;

{Te enva a la posada si caes en el puente. Pierdes el turno}
Procedure puente (var usuario, casilla_posada:integer);
   Begin
      If ((usuario=cas_puente) OR (usuario=(cas_puente*2))) then
         Begin
            usuario:=casilla_posada;
            writeln('Estas en la posada por caer en el puente');
            writeln('Pierdes el turno');
            writeln;
          end;
   end;

{Procedure que te mantiene en la posada si caes en ella}
Procedure posada (var usuario,casilla_posada:integer);
   Begin
      If usuario=casilla_posada then
         Begin
            usuario:=casilla_posada;
            writeln('Estas en la casilla: ',usuario);
            writeln('Pierdes turno por caer en la posada');
            writeln;
         end;
   end;

{Te manda a la casilla 1 si caes en la calavera}
Procedure calavera (var usuario:integer; casilla_calavera:integer);
   Begin
      If usuario=casilla_calavera then
         Begin
            usuario:=1 ;
            writeln('Ha caido en la calavera, vuelve a la casilla numero 1');
            writeln('Estas en la casilla: ',usuario);
            writeln;
          end;
   end;

{Procedure que te permite elegir las casillas calavera y posada}
Procedure elegircasilla (var casilla_posada, casilla_calavera:integer);
   Var
      usuario:integer;
   Begin
      {$I-}
      write('Cual quieres que sea la casilla calavera?: ');
      readln(casilla_calavera);
      while ((IOResult<>0) OR (casilla_calavera<=0) OR (casilla_calavera=cas_oca)
         OR (casilla_calavera=cas_puente) OR (casilla_calavera=(cas_oca+4))
         OR (casilla_calavera=(cas_puente*2)) OR (casilla_calavera=(2*cas_oca+4))
         OR (casilla_calavera=(3*cas_oca+3)) OR (casilla_calavera=(4*cas_oca+3))
         OR (casilla_calavera>=(5*cas_oca+2))) do
         Begin
            write('Valor erroneo. Vuelve a introducir la casilla calavera: ');
            readln(casilla_calavera)
         end;
      {$I+}
      {$I-}
      writeln('Cual quieres que sea la casilla posada?');
      write('La casilla posada tiene que ser mayor de 12: ');
      readln(casilla_posada);
      while ((IOResult<>0) OR (casilla_posada<=(cas_puente*2))
         OR (casilla_posada=(2*cas_oca+4)) OR (casilla_posada=(3*cas_oca+3))
         OR (casilla_posada=(4*cas_oca+3)) OR (casilla_posada>=(5*cas_oca+2))
         OR (casilla_posada=casilla_calavera)) do
         Begin
            write('Valor erroneo. Vuelve a introducir la casilla posada: ');
            readln(casilla_posada)
         end;
      {$I+}
   end;

{Llama a los procedimientos anteriores para que se cumplan las normas del juego}
Procedure reglas (var usuario,casilla_posada,casilla_calavera:integer);
   Begin
      oca(usuario);
      calavera(usuario, casilla_calavera);
      puente(usuario,casilla_posada);
      posada(usuario, casilla_posada);
   end;

{Procedure que resta las casillas correspondientes si te pasas de la casilla 27}
Procedure resta (var usuario:integer);
   Var
      resultado,casilla:integer;
   Begin
   If (usuario>(5*cas_oca+2)) then
      Begin
         resultado:=usuario;
         casilla:=resultado-27;
         usuario:=27-casilla;
         writeln('Como has superado las 27 casillas del tablero ');
         writeln('tienes que volver hacia atras:' ,casilla);
         writeln;
      end;
   If (usuario=(4*cas_oca+3)) then
      Begin
         usuario:=(5*cas_oca+2);
         writeln('Ocaaa!!!')
      end
   end;

{Muestra por pantalla la informacin y posicin relevante del juego: posicion
 del usuario,la mquina y las casillas posada y calavera}
Procedure tablero(usuario,maquina,casilla_posada,casilla_calavera:integer);
   Var
      i:integer;
   Begin
      Textcolor(10);
      writeln('--------------------------------------------------------------------------------');
      writeln(' 1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 ');
      Textcolor(1);
      For i:=1 to (5*cas_oca+2) do begin
         If i=casilla_posada then write('POS') else write('   ') end;
         writeln;
         Textcolor(5);
         For i:=1 to (5*cas_oca+2) do begin
         If i=casilla_calavera then write('CAL') else write('   ') end;
         writeln;
         Textcolor(4);
         write('            OCA');
         Textcolor(11);
         write(' PU');
         Textcolor(4);
         write('      OCA');
         Textcolor(11);
         write('      PU');
         Textcolor(4);
         write('    OCA         OCA            OCA');
         Textcolor(6);
         writeln('        FIN');
         Textcolor(14);
         Begin
            For i:=1 to (5*cas_oca+2) do begin
               If i=usuario then write(' U ') else write('   ') end;
               writeln;
               For i:=1 to (5*cas_oca+2) do begin
                  If i=maquina then write(' M ') else write('   ') end;
                  writeln;
         end;
         Textcolor(10);
         writeln(' 1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 ');
         writeln('--------------------------------------------------------------------------------');
         Textcolor(7);
   end;

{Funcion que te permite salir o continuar en el juego}
Function JugarMas:char;
   Var
      respuesta:char;
   Begin
      Repeat
         writeln('Desea jugar otra vez (S/N)?: ');
         readln(respuesta);
         respuesta:=upCase(respuesta);
      until ((respuesta='S') or (respuesta='N'));
      JugarMas:=respuesta
   end;

{Variables del programa principal}
VAR

   casilla_posada,casilla_calavera:integer;
   usuario,maquina:integer;
   n:integer;

{Programa principal}
BEGIN
   Randomize;
   n:=0;
   Repeat
      Clrscr;
      usuario:=0;
      maquina:=0;
      elegircasilla(casilla_posada, casilla_calavera);
      writeln;
      writeln('Comienza lanzando los dados el usuario');
      Repeat
         writeln;
         writeln('Lanza los dados el usuario');
         writeln;
         empezarjuego(usuario);
         reglas(usuario,casilla_posada,casilla_calavera);
         resta (usuario);
         tablero(usuario,maquina,casilla_posada,casilla_calavera);
         readln;
         If (usuario=casilla_posada)  then
            Begin
               writeln('Pasamos el turno a la maquina');
               empezarjuego(maquina);
               reglas(maquina,casilla_posada,casilla_calavera);
               resta (maquina);
               tablero(usuario,maquina,casilla_posada,casilla_calavera);
               readln;
               If (maquina=casilla_posada)  then
                  For n:=0 to 1 do
                     Begin
                        writeln('Pasamos el turno al usuario');
                        empezarjuego(usuario);
                        reglas(usuario,casilla_posada,casilla_calavera);
                        resta (usuario);
                        tablero(usuario,maquina,casilla_posada,casilla_calavera);
                        readln;
                     end;
            end;
         If (usuario=(5*cas_oca+2)) OR (maquina=(5*cas_oca+2)) then
         writeln('Enhorabuena!!') else
            Begin
               writeln;
               writeln('Lanza los dados la maquina');
               writeln;
               empezarjuego(maquina);
               reglas(maquina,casilla_posada,casilla_calavera);
               resta (maquina);
               tablero(usuario,maquina,casilla_posada,casilla_calavera);
               readln;
               If (maquina=casilla_posada) then
                  Begin
                     writeln('Pasamos el turno al usuario');
                     empezarjuego(usuario);
                     reglas(usuario,casilla_posada,casilla_calavera);
                     resta (usuario);
                     tablero(usuario,maquina,casilla_posada,casilla_calavera);
                     readln;
                     If (usuario=casilla_posada)  then
                         For n:=0 to 1 do
                            Begin
                               writeln('Pasamos el turno a la maquina');
                               empezarjuego(maquina);
                               reglas(maquina,casilla_posada,casilla_calavera);
                               resta (maquina);
                               tablero(usuario,maquina,casilla_posada,casilla_calavera);
                               readln;
                            end;
                  end;
            end;
         If maquina=(5*cas_oca+2) then writeln('Lo siento pero la maquina ha ganado!!');
         If usuario=(5*cas_oca+2) then writeln('Enhorabuena. El usuario ha ganado!!');
      until ((usuario=(5*cas_oca+2)) or (maquina=(5*cas_oca+2)));
   until JugarMas='N';
   writeln
END.


