Program Juego_de_la_Oca;

uses crt;

type
  tpsimbolo=char;
  tpjugador=string[30];

{Este procedimiento es introductorio antes de empezar a jugar donde se le pide
al usuario el nombre y el simbolo de la ficha}

Procedure simbolo(var jug1,jug2:tpjugador; var fjug1,fjug2:tpsimbolo);
  begin
    writeln('Introduce tu nombre de usuario para iniciar la partida: ');
    readln(jug1);
    jug2:='maquina';
    writeln(' ');
    writeln(jug1,' escriba por pantalla el simbolo que quiera de su ficha: ');
    readln(fjug1);
    if (fjug1='X') or (fjug1='x') then
      begin
        writeln('Introduzca otro simbolo que no sea X: ');
        readln(fjug1);
      end;
    fjug2:='X';
    writeln('El simbolo de la ',jug2,' es: ',fjug2);
  end;

{En este procedimiento el usuario tiene la propiedad de elegir donde quiere
que este situada la posada y la calavera}

Procedure posacala (var posada:integer; var calavera:integer);
  begin
    {$I-}
    writeln('Elige en que posicion de acuerdo a las condiciones del tablero,');
    writeln('quieres que este situada la posada: ');
    readln(posada);
    while (IOResult<>0) or (posada<13) or (posada>27) or ((posada=14) or (posada=18) or (posada=23) or (posada=27)) do
      begin
        writeln('La casilla de la posada que has elegido no es valida');
        writeln('Elige un numero vlido entre el 1 y el 27: ');
        readln(posada);
      end;
    writeln('La posada esta situada en la casilla: ',posada);
    writeln(' ');
    {$I+}
    {$I-}
    writeln('Elige en que posicion de acuerdo a las condiciones del tablero,');
    writeln('quieres que este situada la calavera: ');
    readln(calavera);
    while (IOResult<>0) or (calavera<1) or (calavera>27) or ((calavera=5) or
          (calavera=6) or (calavera=9) or (calavera=12) or (calavera=14)
          or (calavera=18) or (calavera=23) or (calavera=27) or (calavera=posada)) do
      begin
        writeln('La casilla de la calavera que has elegido no es valida');
        writeln('Elige un numero vlido entre el 1 y el 27: ');
        readln(calavera);
      end;
    writeln('La calavera esta situada en la casilla: ',calavera);
    writeln(' ');
    {$I+}
  end;

{Es la unica funcion que existe en el programa pero es la mas importante ya que
indica el ganador de la partida}

Function ganador(pos1,pos2:integer):boolean;
  begin
    if (pos1 = 27) or (pos2 = 27) then
      ganador:=true
    else
      ganador:=false;
  end;

{Procedimiento que dibuja el tablero inicial donde se va a jugar}

Procedure dibujamitablero;
  begin
    writeln('    |-----|-----|-----|-----|-----|-----|-----|-----|-----|');
    writeln('    |     |     |     |     |     |     |     |     |     |');
    writeln('    |  1  |  2  |  3  |  4  |  5  |  6  |  7  |  8  |  9  |');
    writeln('    |     |     |     |     |     |     |     |     |     |');
    writeln('    |-----|-----|-----|-----|-----|-----|-----|-----|-----|');
    writeln('    |-----|-----|-----|-----|-----|-----|-----|-----|-----|');
    writeln('    |     |     |     |     |     |     |     |     |     |');
    writeln('    |  10 |  11 |  12 |  13 |  14 |  15 |  16 |  17 |  18 |');
    writeln('    |     |     |     |     |     |     |     |     |     |');
    writeln('    |-----|-----|-----|-----|-----|-----|-----|-----|-----|');
    writeln('    |-----|-----|-----|-----|-----|-----|-----|-----|-----|');
    writeln('    |     |     |     |     |     |     |     |     |     |');
    writeln('    |  19 |  20 |  21 |  22 |  23 |  24 |  25 |  26 |  27 |');
    writeln('    |     |     |     |     |     |     |     |     |     |');
    writeln('    |-----|-----|-----|-----|-----|-----|-----|-----|-----|');
  end;

{Procedimiento que realiza las restricciones}

Procedure condiciones (var turno,fjug1,fjug2:char; posada,calavera:integer; var pos1,pos2:integer; var turnodoble:integer);
  begin
  {Jugador 1}

  If turno=fjug1 then
  Begin
     {Esta condicion indica que si el jugador 1 no cae en la posada, en la calavera y en ninguna oca
     entonces cambia el turno y le toca tirar a la maquina}
    if (turno=fjug1) and (pos1<>calavera) and (pos1<>posada) and (pos1<>6) and (pos1<>12) and
    (pos1<>5) and (pos1<>9) and (pos1<>14) and (pos1<>18) and (pos2<>posada) then
        turno:=fjug2;

    if (turno=fjug1) then
     begin
       {Estos son los numeros donde estan situadas las ocas en el tablero}
       case pos1 of
         5: begin pos1:=9; writeln('Ha caido en la casilla 5, que es una oca, y de oca a oca y tiro porque me toca'); end;
         9: begin pos1:=14; writeln('Ha caido en la casilla 9, que es una oca, y de oca a oca y tiro porque me toca'); end;
         14: begin pos1:=18; writeln('Ha caido en la casilla 14, que es una oca, y de oca a oca y tiro porque me toca'); end;
         18: begin pos1:=23; writeln('Ha caido en la casilla 18, que es una oca, y de oca a oca y tiro porque me toca'); end;
       end;
     end;

     {Esta es la condicion de la calavera, casilla que el usuario ha introducido
     al principio de la partida y que te lleva al inicio}
    if (turno=fjug1) and (pos1=calavera) then
      begin
        writeln('Lo siento, ha caido en la calavera que le hace dirigirse a la casilla 1');
        pos1:=1;
        turno:=fjug2;
      end;

     {Esta es la condicion de la posada, no solo en la casilla que el usuario ha introducido
     previamente, sino tambien en la casilla numero 6 y 12, y que te hace perder un turno}
    if (turno=fjug1) and ((pos1=6) or (pos1=12) or (pos1=posada)) then
      begin
        pos1:=posada;
        writeln('Lo siento, ha caido en la posada, lo que le hace perder un turno');
        turno:=fjug2;
        turnodoble:=1;
      end;
      end



  {Jugador 2}
  else
  if turno=fjug2 then
    begin
       {Esta condicion indica que si el jugador 1 no cae en la posada, en la calavera y en ninguna oca
      entonces cambia el turno y le toca tirar a la maquina}
      if (turno=fjug2) and (pos2<>calavera) and (pos2<>posada) and (pos2<>6) and (pos2<>12) and
      (pos2<>5) and (pos2<>9) and (pos2<>14) and (pos2<>18) and (pos1<>posada) then
        turno:=fjug1;
      if (turno=fjug2) then
        begin
         {Estos son los numeros donde estan situadas las ocas en el tablero}
          case pos2 of
            5: begin pos2:=9; writeln ('Ha caido en la casilla 5, que es una oca, y de oca a oca y tiro porque me toca'); end;
            9: begin pos2:=14; writeln ('Ha caido en la casilla 9, que es una oca, y de oca a oca y tiro porque me toca'); end;
            14:begin pos2:=18; writeln('Ha caido en la casilla 14, que es una oca, y de oca a oca y tiro porque me toca'); end;
            18: begin pos2:=23; writeln('Ha caido en la casilla 18, que es una oca, y de oca a oca y tiro porque me toca');end;
          end;
        end;

     {Esta es la condicion de la calavera, casilla que el usuario ha introducido
     al principio de la partida y que te lleva al inicio}
      if (turno=fjug2) and (pos2=calavera) then
        begin
          writeln('La maquina ha caido en la calavera que le manda a la posicion 1, esta partida no se te puede escapar');
          pos2:=1;
          turno:=fjug1;
        end;

      {Esta es la condicion de la posada, no solo en la casilla que el usuario ha introducido
      previamente, sino tambien en la casilla numero 6 y 12, y que te hace perder un turno}
      if (turno=fjug2) and ((pos2=6) or (pos2=12) or (pos2=posada)) then
        begin
          writeln('La maquina, pierde un turno por situarse en la posada, afina bien el dado');
          writeln('para tomar ventaja');
          pos2:=posada;
          turno:=fjug1;
          turnodoble:=2;
        end;


    end;
  end;

{En este procedimiento realizamos la partida teniendo en cuenta todas las condiciones
descritas anteriormente}

Procedure moverficha(var pos1,pos2,posada,calavera,castilla:integer; var fjug1,fjug2:tpsimbolo; var turno:char;
                     var jug1,jug2:tpjugador;var turnodoble:integer);
  var
  i:integer;

  begin
     {Tiramos el dado}
    castilla:=random(6)+1;
    writeln('Al tirar el dado ha salido un ',castilla);

     {Esta condicion solo se realiza si el jugador 1 esta situado en la posada
     y le toca tirar a la maquina}
    if (turno=fjug2) and (turnodoble=1) then
      begin
        for i:=1 to 2 do
          begin
            pos2:=castilla+pos2;
            turno:=fjug2;
            {En el caso de pasarse de 27, tiene que rebotar}
            if (pos2>27) and not ganador (pos1,pos2) then
              pos2:=27-(pos2-27);

            writeln('La ',jug2,' ha avanzado ', castilla,' casillas');

            {En el caso de caer en una oca, tirara dos veces mas el numero de veces
            que caiga en la oca}
            if (pos2=5) or (pos2=9) or (pos2=14) or (pos2=18) then
              i:=i-1;

            condiciones(turno,fjug1,fjug2,posada,calavera,pos1,pos2,turnodoble);
            writeln('La ',jug2 ,' esta en la posicion ', pos2);
            readln;

             {En caso de caer en la posada el jugador 2 automaticamente el jugador 1 sale de ella}
            if (pos2=posada) then
              begin
                turnodoble:=2;
                i:=2;
                turno:=fjug1;
              end;

             {Cuando tira el numero de veces correspondiente el jugador 1 vuelve a jugar}
            if (i=2) and (pos2<>posada) then
              begin
                turnodoble:=0;
                turno:=fjug1;
              end;
              If ganador (pos1,pos2)  then
                begin
              i:=2;
              turnodoble:=0;
              turno:=fjug2;
            end;


            castilla:=random(6)+1;
          end;
      end

    else
    begin
     {Esta condicion solo se realiza si el jugador 2 esta situado en la posada
     y le toca tirar al usuario}
    if (turno=fjug1) and (turnodoble=2) then
      begin
        for i:=1 to 2 do
          begin
            pos1:=castilla+pos1;
            turno:=fjug1;
             {En el caso de pasarse de 27, tiene que rebotar}
            if (pos1>27) and not ganador(pos1,pos2) then
              pos1:=27-(pos1-27);

            writeln(jug1,' ha avanzado ', castilla,' casillas');

             {En el caso de caer en una oca, tirara dos veces mas el numero de veces
             que caiga en la oca}
            if (pos1=5) or (pos1=9) or (pos1=14) or (pos1=18) then
              i:=i-1;

            condiciones(turno,fjug1,fjug2,posada,calavera,pos1,pos2,turnodoble);
            writeln(jug1 ,' esta situado en la posicion ', pos1);
            readln;

            {En caso de caer en la posada el usuario, automaticamente la maquina sale de ella}
            if (pos1=posada) then
              begin
              turnodoble:=1;
                i:=2;
                turno:=fjug2;
              end;
            {Cuando tira el numero de veces correspondiente la maquina vuelve a jugar}
            if (i=2) and  (pos1<>posada) then
              begin
                turnodoble:=0;
                turno:=fjug2;
              end;

            If ganador (pos1,pos2)  then
            begin
              i:=2;
              turnodoble:=0;
              turno:=fjug1;
            end;

            castilla:=random(6)+1;
          end;
      end;
    end;

     {Turno del usuario en condiciones normales}
    if (turno=fjug1) and (pos2<>posada) then
      begin
        pos1:=castilla+pos1;

         if (pos1>27) then
           begin
             pos1:=27-(pos1-27);
           end;

        writeln(jug1,' ha avanzado ',castilla,' casillas');
        condiciones(turno,fjug1,fjug2,posada,calavera,pos1,pos2,turnodoble);
        writeln(jug1 ,' esta en la posicion ', pos1);
        readln;
      end

    else
    begin
     {Turno de la maquina en condiciones normales}
    if  (turno=fjug2) and (pos1<>posada) then
      begin
        pos2:=castilla+pos2;

        if (pos2>27) then
          begin
            pos2:=27-(pos2-27);
          end;

        writeln('La ',jug2,' ha avanzado ',castilla,' casillas');
        condiciones(turno,fjug1,fjug2,posada,calavera,pos1,pos2,turnodoble);
        writeln('La ',jug2 ,' esta en la posicion ',pos2);
        writeln;
        readln;

      end;
    end;
  end;



{---------------------------Programa Principal------------------------------}

var
posata,calata,pos1,pos2,turnodoble,casilla:integer;
nomjug1,nomjug2:tpjugador;
turno,ficha1,ficha2:tpsimbolo;
decision:char;

begin

  clrscr;
  Repeat
  writeln('                     BIENVENIDO AL JUEGO DE LA OCA!!!             ');
  writeln(' ');
  writeln('El primero que llegue al jardin de la oca gana la partida');
  writeln('Inicialmente los dos jugadores se encuentran en la posicion 0');
  writeln(' ');
  randomize;
  Textbackground(blue);
  Begin
  dibujamitablero;
  writeln('Las ocas estn en las posiciones 5,9,14,18 y 23; los puentes en la 6 y 12;');
  writeln('mientras que la posada y la calavera sern elegidos por el usuario');

  writeln('Cada vez que quiera tirar el dado deber pulsar la tecla enter');
  writeln(' ');
  simbolo(nomjug1,nomjug2,ficha1,ficha2);
  writeln(' ');
  posacala(posata,calata);
  pos1:=0;
  pos2:=0;
  turno:=ficha1;
  turnodoble:=0;
  casilla:=0;


  while not ganador(pos1,pos2) do
    begin
      moverficha(pos1,pos2,posata,calata,casilla,ficha1,ficha2,turno,nomjug1,nomjug2,turnodoble);
    end;

  if (pos1=27) then
    writeln('FELICIDADES ',nomjug1,' HAS GANADO LA PARTIDA');
  if (pos2=27) then
    writeln('LO SENTIMOS, HA GANADO LA MAQUINA');
  writeln('PULSE 1 PARA JUGAR OTRA VEZ O CUALQUIER OTRA TECLA PARA SALIR');
  Writeln('VAMOS ANIMATE Y S VALIENTE');
  readln(decision);
  end;
  until decision<>'1'
end.
{----------------------Fin del programa principal---------------------------}