 PROGRAM Diseno1JuegoOca;

  USES CRT;

  CONST  TotalCas=27;


  FUNCTION  DescartarPosada(Posad:integer):boolean;
        {Funcin para impedir que se elija un valor de casilla no permitido}
        {para la posada.}
      BEGIN
            CASE Posad OF

             5,6,9,12,14,18,23,27: DescartarPosada:=TRUE;

            END;

      END;


  FUNCTION  DescartarCalavera(Calav:integer):boolean;
        {Funcin para impedir que se elija un valor de casilla no permitido}
        {para la calavera.}
      BEGIN
            CASE Calav OF

             5,6,9,12,14,18,23,27: DescartarCalavera:=TRUE;

            END;

      END;


  PROCEDURE ElegirCasillasInicio(VAR Posad,Calav:integer);
      {Procedimiento para que el usuario elija los valores de las casillas}
      {posada y calavera , con las restricciones impuestas por las normas}
      {de este juego.}
   BEGIN

    {$I-}
      TextColor(0);
      TextBackground(7);
      writeLn('  Elige un valor,para el nmero de casilla de la     ');
      write('  posada,comprendido entre 1 y 27,y mayor que 12: ');
      readLn(Posad);
      TextColor(0);
      TextBackground(7);
      writeLn('                                                    ');

      WHILE    ((IOresult<>0)OR(Posad<1)OR(Posad<13)OR(Posad>27)
                OR(DescartarPosada(Posad)=TRUE)) DO

            BEGIN


              writeLn('  Elige un valor,para el nmero de casilla de la    ');
              write('  posada,comprendido entre 1 y 27,y mayor que 12: ');
              readLn(Posad);
              TextColor(0);
              TextBackground(7);
              writeLn('                                               ');

            END;
     {$I+}

     {$I-}

      writeLn('  Elige un valor,para el nmero de casilla de la       ');
      write('  calavera,comprendido entre 1 y 27:  ',' ');
      readLn(Calav);
      TextColor(0);
      TextBackground(7);
      writeLn('                                                      ');

      WHILE   ((IOresult<>0)OR(Calav<1)OR(Calav>27)
                OR(DescartarCalavera(Calav)=TRUE)OR(Calav=Posad)) DO
             {Se aade la restriccin de que no pueden coincidir la}
             {posada y la calavera en una misma casilla .}
             BEGIN
                writeLn('  Elige un valor,para el nmero de casilla de la  ');
                write('  calavera,comprendido entre 1 y 27:  ');
                readLn(Calav);
                TextColor(0);
                TextBackground(7);
                writeLn('                                                  ');

             END;
     {$I+}

    END;



  PROCEDURE TipoDeCasillaUsuario(Posad,Calav,NumCas,PosU:integer);
      {Procedimiento para determinar el contenido de texto de una casilla}
      {del usuario , cuando cae en ella la ficha del usario en su turno}
      {de juego.}

    VAR
        CasEsp:string;

    BEGIN

       IF NumCas=PosU THEN

         BEGIN

           IF PosU=Posad THEN CasEsp:='      POSADA      ' ELSE

             BEGIN

               IF PosU=Calav THEN CasEsp:='     CALAVERA     ' ELSE

                 BEGIN

                      CASE PosU OF

                          0: CasEsp:='      ******      ';
                          5,9,14,18,23: CasEsp:='       OCA        ';
                          6,12: CasEsp:='      PUENTE      ';
                          27: CasEsp:=' JARDIN DE LA OCA '
                          ELSE CasEsp:='      ******      '

                      END; {Fin de CASE .}

                 END; {Fin del BEGIN de ELSE .}

             END;  {Fin del BEGIN de ELSE .}


         END {Fin del BEGIN de THEN .} ELSE  CasEsp:='                  ';

             write(CasEsp:18);

     END; {Fin del BEGIN de este procedimiento .}


  PROCEDURE TipoDeCasillaMaquina(Posad,Calav,NumCas,PosM:integer);
       {Procedimiento para determinar el contenido de texto de una casilla}
       {de la mquina , cuando cae en ella la ficha de la mquina en su turno}
       {de juego.}

    VAR CasEsp:string;

    BEGIN

       IF NumCas=PosM THEN

         BEGIN

           IF PosM=Posad THEN CasEsp:='      POSADA      ' ELSE

            BEGIN

              IF PosM=Calav THEN CasEsp:='     CALAVERA     ' ELSE

                 BEGIN

                    CASE PosM OF

                       0: CasEsp:='      ******      ';
                       5,9,14,18,23: CasEsp:='       OCA        ';
                       6,12: CasEsp:='      PUENTE      ';
                       27: CasEsp:=' JARDIN DE LA OCA '
                       ELSE CasEsp:='      ******      ';

                     END; {Fin de CASE .}

                  END;  {Fin del BEGIN de ELSE .}

             END;  {Fin del BEGIN de ELSE .}

          END {Fin del BEGIN de THEN .}   ELSE  CasEsp:='                  ';

              write(CasEsp:18);

    END;  {Fin del BEGIN de este procedimiento .}




  PROCEDURE DibujaLinea(Posad,Calav,NumCas:integer;VAR PosU,PosM:integer;
                                                               turno:char);
    {Procedimiento para dibujar toda una lnea del tablero de juego;}
    {incluye: nmero de lnea , casilla del usuario , casilla de la mquina.}
      VAR  textU,textM,color:byte;

      BEGIN

          IF NumCas=Posad THEN Color:=5 ELSE

              BEGIN

                 IF NumCas=Calav THEN Color:=3 ELSE

                    BEGIN

                         CASE NumCas OF

                              0: Color:=7;
                              5,9,14,18,23: Color:=9;
                              6,12: Color:=6;
                              27: Color:=2
                              ELSE Color:=10;

                         END; {Fin de CASE .}

                    END; {Fin del BEGIN de ELSE .}


               END;  {Fin del BEGIN de ELSE .}


                TextColor(0);
                TextBackground(7);

               IF NumCas<10 THEN write('             ',NumCas,':')
                             ELSE write('            ',NumCas,':');

               IF turno='U' THEN
                             BEGIN
                               textU:=128;
                               textM:=4;
   {Fin del BEGIN de THEN .} END        ELSE
                                            BEGIN
                                                   textU:=0;
                                                   textM:=132;
                                            END; {Fin del BEGIN de ELSE .}



                TextColor(textU);
                TextBackground(color);
                TipoDeCasillaUsuario(Posad,Calav,NumCas,PosU);

                TextColor(textM);
                TextBackground(color);
                TipoDeCasillaMaquina(Posad,Calav,NumCas,PosM);

                TextColor(0);
                TextBackground(7);
                writeLn('           ');


        END; {Fin del BEGIN de este procedimiento .}



  PROCEDURE DibujaTablero(Posad,Calav:integer;VAR NumCas,PosU,PosM:integer;
                                                                 turno:char);
     {Procedimiento para dibujar todo el tablero de juego ; dibuja}
     {lnea tras lnea , empezando por la nmero 27 y acabando en la}
     {nmero 0 ; esta ltima lnea (la 0) corresponde al estado anterior}
     {al inicio del juego (ambos jugadores tienen 0 puntos) ; a continuacin}
     {escribe una lnea indicando la vertical de las casillas}
     {correspondientes al usuario o a la mquina.}
        BEGIN

                NumCas:=TotalCas;

                WHILE NumCas>(-1) DO

                  BEGIN

                       DibujaLinea(Posad,Calav,NumCas,PosU,PosM,turno);

                       NumCas:=NumCas-1;

                  END;

                  TextColor(0);
                  TextBackground(7);
                  write('                     USUARIO     ');

                  TextColor(4);
                  TextBackground(7);
                  writeLn('      MAQUINA     ');

                  TextColor(0);
                  TextBackground(7);

                  writeLn;

         END;  {Fin del BEGIN de este procedimiento .}


  PROCEDURE Puntos(VAR punts:integer);
           {Procedimiento para determinar los puntos correspondientes}
           {a cada tirada del dado;los puntos (punts) sern nmeros enteros}
           {del intervalo : 1<= punts <=6 }
           VAR Aleat:word;

           BEGIN

              Aleat:=Random(6);

              CASE Aleat OF

                     0: punts:=1;
                     1: punts:=2;
                     2: punts:=3;
                     3: punts:=4;
                     4: punts:=5;
                     5: punts:=6;

              END;  {Fin de CASE .}

           END; {Fin del BEGIN de este procedimiento .}




  PROCEDURE DibujaCaraDado(punts:integer);
    {Procedimiento para representar el resultado , de cada tirada del dado ,}
    {en forma de un cuadrado que representa la cara visible del dado ,}
    {con marcas del carcter '*' indicado los puntos obtenidos .}
         BEGIN


             CASE punts OF

                 1: BEGIN
                             TextColor(0);  TextBackground(7);
                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('    *    ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                     END;

                 2: BEGIN
                             TextColor(0);  TextBackground(7);
                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('       * ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write(' *       ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');





                     END;

                  3: BEGIN
                             TextColor(0);  TextBackground(7);
                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('       * ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('    *    ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write(' *       ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');



                      END;

                  4: BEGIN
                             TextColor(0);  TextBackground(7);
                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write(' *     * ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write(' *     * ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');



                      END;

                   5: BEGIN
                             TextColor(0);  TextBackground(7);
                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write(' *     * ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('    *    ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write(' *     * ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');



                       END;

                    6: BEGIN
                             TextColor(0);  TextBackground(7);
                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write(' *     * ');
                             TextColor(0);  TextBackground(7);
                             writeLn('           ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write(' *     * ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write(' *     * ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');

                             write('      ');
                             TextColor(0);  TextBackground(6);
                             write('         ');
                             TextColor(0);  TextBackground(7);
                             writeLn('          ');



                        END;

               END;  {Fin de CASE .}

          END;  {Fin del BEGIN de este procedimiento .}




  PROCEDURE TiraDado(VAR punts:integer;turno:char);
      {Procedimiento que determina todo el proceso de la tirada del dado :}
      {obtencin de puntos , tener en cuenta las diferencias del proceso}
      {segn quien sea el jugador (usuario , mquina) , representar la cara}
      {visible del dado con el resultado , escribir los puntos obtenidos .}
      BEGIN

          Puntos(punts);

          CASE turno OF

             'U': BEGIN

                      writeLn('    Le toca jugar al USUARIO.');
                      writeLn('    Para tirar el dado pulsa la tecla INTRO');
                      readLn;
                      TextColor(0);
                      TextBackground(7);
                      writeLn('                                        ');
                      DibujaCaraDado(punts);
                      TextColor(0);
                      TextBackground(7);
                      writeLn('                                        ');
                      writeLn('    Has sacado ',punts,' puntos.');

                   END;


              'M': BEGIN

                      Delay(3000);
                      write('    Le toca jugar a la MAQUINA  ');
                      writeLn('(espera 3 segundos los puntos).');
                      TextColor(0);
                      TextBackground(7);
                      writeLn('                                       ');;
                      DibujaCaraDado(punts);
                      TextColor(0);
                      TextBackground(7);
                      writeLn('                                          ');
                      writeLn('    La mquina ha sacado ',punts,' puntos.');



                   END;

           END;   {Fin de CASE .}

       END;  {Fin del BEGIN de este procedimiento .}


  PROCEDURE PosicionPreviaUsuario(VAR PosU:integer;punts:integer);
        {Procedimiento para determinar el nmero de casilla del}
        {usuario , despus de efectuar la correspondiente tirada del dado ;}
        {"pero sin aplicar la correccin del caso de caer en casilla }
        {especial" ; si no , nicamente , sumando los puntos obtenidos }
        {en la tirada al nmero de casilla previo a dicha tirada .}
            BEGIN

                PosU:=PosU+punts;

                IF PosU>27 THEN PosU:=54-PosU;

            END;


  PROCEDURE PosicionPreviaMaquina(VAR PosM:integer;punts:integer);
        {Procedimiento para determinar el nmero de casilla de la }
        {mquina , despus de efectuar la correspondiente tirada del dado ;}
        {"pero sin aplicar la correccin del caso de caer en casilla }
        {especial" ; si no , nicamente , sumando los puntos obtenidos }
        {en la tirada al nmero de casilla previo a dicha tirada .}
            BEGIN

                PosM:=PosM+punts;

                IF PosM>27 THEN PosM:=54-PosM;

            END;

  Procedure  CasosPosibles(turno:char;penaU,penaM:integer;VAR caso:integer);
       {Procedimiento para obtener las condiciones que determinan a que }
       {jugador le corresponde jugar en funcin de : su turno de juego , }
       {el valor de la penalizacin correspondiente (derivada de caer en }
       {casillas especiales a las que se aplica penalizacin) .}

           BEGIN
                    {Al final de cada fila figura , entre llaves , a quien }
                    {le corresponde jugar: usuario (U) , mquina (M) .}
                 IF ((turno='U')AND(penaU=0)AND(penaM=0))THEN caso:=1 ELSE {U}

                 IF ((turno='U')AND(penaU=0)AND(penaM>0))THEN caso:=2 ELSE {U}

                 IF ((turno='U')AND(penaU>0)AND(penaM=0))THEN caso:=3 ELSE {M}

                 IF ((turno='U')AND(penaU>0)AND(penaM>0))THEN caso:=4 ELSE {U}

                 IF ((turno='M')AND(penaU=0)AND(penaM=0))THEN caso:=5 ELSE {M}

                 IF ((turno='M')AND(penaU=0)AND(penaM>0))THEN caso:=6 ELSE {U}

                 IF ((turno='M')AND(penaU>0)AND(penaM=0))THEN caso:=7 ELSE {M}

                 IF ((turno='M')AND(penaU>0)AND(penaM>0))THEN caso:=8;     {M}

          END;


  PROCEDURE  IrProximaOcaUsuario(VAR PosU:integer);
        {Procedimiento para corregir la posicin del usuario , en caso}
        {de que haya cado su ficha en una casilla especial , llevando}
        {su ficha hasta la casilla de usuario correspondiente a la}
        {nueva posicin , ya corregida .}

          BEGIN

                 CASE PosU OF

                   5,9,14,18,23: BEGIN
                                        REPEAT Posu:=PosU+1
                                        UNTIL (PosU=9)OR(PosU=14)OR
                                              (PosU=18)OR(PosU=23)OR(PosU=27);
                                 END;

                  END;  {Fin de CASE .}

           END; {Fin del BEGIN de este procedimiento .}


  PROCEDURE  IrProximaOcaMaquina(VAR PosM:integer);
        {Procedimiento para corregir la posicin de la mquina , en caso}
        {de que haya cado su ficha en una casilla especial , llevando}
        {su ficha hasta la casilla de mquina correspondiente a la}
        {nueva posicin , ya corregida .}

            BEGIN

                 CASE PosM OF

                   5,9,14,18,23: BEGIN
                                       REPEAT PosM:=PosM+1
                                       UNTIL (PosM=9)OR(PosM=14)OR
                                             (PosM=18)OR(PosM=23)OR(PosM=27);

                                 END;

                  END;  {Fin de CASE .}

             END;  {Fin del BEGIN de este procedimiento .}


  PROCEDURE JuegaUsuario(VAR Posad,Calav,NumCas,punts,PosU,PosM,
                       penaU,penaM:integer;caso:integer;VAR turno:char);
         {Procedimiento que realiza todas las operaciones relativas}
         {a cada jugada del usuario , cuando se den las condiciones }
         {para que le toque el turno de juego : cambia las penalizaciones ,}
         {tira el dado y muestra la posicin previa , aplica las}
         {correcciones de casilla especial y muestra la nueva posicin ;}
         { y , por ltimo , cambia el turno a mquina . }

         BEGIN
               IF caso=6 THEN penaM:=penaM-1;

               writeLn;

               TiraDado(punts,turno);

               writeLn;

               PosicionPreviaUsuario(PosU,punts);

               writeLn('  La posicin del usuario despues,nicamente,de');
               writeLn('  sumarle los puntos obtenidos en esta tirada es: ');
               writeLn;

               DibujaTablero(Posad,Calav,NumCas,PosU,PosM,turno);

               writeLn;

               writeLn('  Para continuar con el programa pulsa INTRO.');
               readLn;

               writeLn;

               IF ((PosU=Posad)OR(PosU=Calav)OR(PosU=5)OR(PosU=6)OR(PosU=9)
                  OR(PosU=12)OR(PosU=14)OR(PosU=18)OR(PosU=23))  THEN

                BEGIN

                   IF PosU=Posad THEN penaU:=penaU+1 ELSE

                      BEGIN

                       IF PosU=Calav THEN PosU:=1 ELSE

                       BEGIN

                         CASE PosU OF

                               5,9,14,18,23: BEGIN

                                                 IrProximaOcaUsuario(PosU);

                                                 penaM:=penaM+1;

                                             END;


                                6,12: BEGIN
                                            PosU:=Posad;

                                            penaU:=penaU+1;

                                      END;


                          END; {Fin de CASE .}

                       END;   {Fin del BEGIN de ELSE .}

                      END;  {Fin del BEGIN de ELSE .}

                      Delay(3000);
                      writeLn('  La posicin del usuario despues de aplicar');
                      writeLn('  la correccin de casilla especial es: ');
                      writeLn;

                      DibujaTablero(Posad,Calav,NumCas,PosU,PosM,turno);

                   END;  {Fin del BEGIN de THEN .}

                 turno:='M';

         END;  {Fin del BEGIN de este procedimiento .}



  PROCEDURE JuegaMaquina(VAR Posad,Calav,NumCas,punts,PosU,PosM,
                        penaU,penaM:integer;caso:integer;VAR turno:char);
         {Procedimiento que realiza todas las operaciones relativas}
         {a cada jugada de la mquina , cuando se den las condiciones }
         {para que le toque el turno de juego : cambia las penalizaciones ,}
         {tira el dado y muestra la posicin previa , aplica las}
         {correcciones de casilla especial y muestra la nueva posicin ;}
         { y , por ltimo , cambia el turno a usuario . }

         BEGIN
               IF caso=3 THEN  penaU:=penaU-1;

               writeLn;

               TiraDado(punts,turno);

               writeLn;

               PosicionPreviaMaquina(PosM,punts);

               writeLn('  La posicin de la mquina despus,nicamente,de');
               writeLn('  sumarle los puntos obtenidos en esta tirada es: ');
               writeLn;

               DibujaTablero(Posad,Calav,NumCas,PosU,PosM,turno);

               writeLn;

               writeLn('  Para continuar con el programa pulsa INTRO.');
               readLn;

               writeLn;

               IF ((PosM=Posad)OR(PosM=Calav)OR(PosM=5)OR(PosM=6)OR(PosM=9)
                  OR(PosM=12)OR(PosM=14)OR(PosM=18)OR(PosM=23))  THEN

                  BEGIN

                     IF PosM=Posad THEN penaM:=penaM+1 ELSE

                        BEGIN

                          IF PosM=Calav THEN PosM:=1 ELSE


                          BEGIN

                            CASE PosM OF

                               5,9,14,18,23: BEGIN

                                                 IrProximaOcaMaquina(PosM);

                                                 penaU:=penaU+1;

                                             END;

                                6,12: BEGIN

                                           PosM:=Posad;

                                           penaM:=penaM+1;

                                      END;


                            END; {Fin de CASE .}

                          END; {Fin del BEGIN de ELSE .}

                        END;  {Fin del BEGIN de ELSE .}

                    Delay(3000);
                    writeLn('  La posicin de la mquina despues de aplicar');
                    writeLn('  la correccin de casilla especial es: ');
                    writeLn;

                    DibujaTablero(Posad,Calav,NumCas,PosU,PosM,turno);

                  END;  {Fin del BEGIN de THEN .}



                  turno:='U';

         END;   {Fin del BEGIN de este procedimiento .}



  PROCEDURE  QuienJuega(VAR Posad,Calav,NumCas,punts,PosU,PosM,
                         penaU,penaM:integer;caso:integer;VAR turno:char);
        {Procedimiento para determinar a que jugador le toca jugar y , en }
        { funcin de esto , aplicar el procedimiento correspondiente :}
        { JuegaUsuario , JuegaMaquina .}
       BEGIN
              CasosPosibles(turno,penaU,penaM,caso);

              CASE caso OF

                   1,2,4,6:

                        BEGIN
                            turno:='U';

                            JuegaUsuario(Posad,Calav,NumCas,punts,
                                         PosU,PosM,penaU,penaM,caso,turno);

                        END;

                   3,5,7,8:

                        BEGIN
                            turno:='M';

                            JuegaMaquina(Posad,Calav,NumCas,punts,
                                         PosU,PosM,penaU,penaM,caso,turno);

                        END;

           END; {Fin de CASE .}

       END; {Fin del BEGIN de este procedimiento .}


  FUNCTION  PartidaAcabada(PosU,PosM:integer):boolean;
        {Procedimiento para establecer la condicin que determina el}
        {final de la partida .}
            BEGIN
                  IF ((PosU=27)OR(PosM=27)) THEN  PartidaAcabada:=TRUE

                       ELSE  PartidaAcabada:=FALSE;

            END;


  PROCEDURE GanadorPartida(PosU,PosM:integer);
          {Procedimiento para mostrar que jugador ha ganado la partida .}
             BEGIN

                   IF PosU=27 THEN

                      writeLn('  Ha ganado esta partida el USUARIO.') ELSE

                         writeLn('  Ha ganado esta partida la MAQUINA.');

             END;


  PROCEDURE Jugar(VAR Posad,Calav,NumCas,punts,PosU,PosM,
                       penaU,penaM,caso:integer;VAR turno:char);
         {Procedimiento que permite ejecutar el juego .}
    BEGIN
         DibujaTablero(Posad,Calav,NumCas,PosU,PosM,turno);

         writeLn('  Para continuar con el programa pulsa INTRO.');
         readLn;

         turno:='U';

         WHILE PartidaAcabada(PosU,PosM)=FALSE DO

              BEGIN

                   QuienJuega(Posad,Calav,NumCas,punts,
                         PosU,PosM,penaU,penaM,caso,turno);

              END;

         GanadorPartida(PosU,PosM);

     END; {Fin del BEGIN de este procedimiento .}

  VAR  {Variables en el programa principal .}
       a,b,c,d,e,f,g,h,i:integer;

       j:char;

  BEGIN
        {Cuerpo del programa principal .}
        Randomize;

        e:=0; f:=0;

        g:=0; h:=0; j:='U';

        ElegirCasillasInicio(a,b);

        Jugar(a,b,c,d,e,f,g,h,i,j);

        writeLn('  Para salir del programa pulsa INTRO.');

        readLn;

  END.  {Fin del programa principal .}


    Datos del alumno:

    Nombre: Alfonso
    Apellidos: Hernndez Heras
    NIA: 330424
    Grupo: G-14
    Puesto: 08