{Prctica de diseo n 1. Fundamentos de Informtica.
Alumnos: Gimena Bacaicoa Elias y Eduardo Cebollero Campo.
G14, Puesto 9}

Program OCA;
uses crt;

Procedure ComprobarCasilla (var casilla,cambiojugador:word;a,b:integer);
 {Finalidad:comprueba si el jugador a caido en una casilla especial
 Parmetros: casilla, cambiojugador parmetro entrada-salida. Tipo referencia.
             a,b parmetros de entrada. Tipo referencia}

Begin
     case casilla of
     5:begin
       writeln ('OCA');
       casilla:=9;
       cambiojugador:=0;
       end;
     6,12:begin         {Se ponen las dos casillas juntas porque tenen el mismo destino final}
       writeln ('PUENTE');
       casilla:=a;
       cambiojugador:=2;
       end;
     9:begin
       writeln ('OCA');
       casilla:=14;
       cambiojugador:=0;
       end;
     14:begin
       writeln ('OCA');
       casilla:=18;
       cambiojugador:=0;
       end;
     18:begin
       writeln ('OCA');
       casilla:=23;
       cambiojugador:=0;
       end;
     23:begin
       writeln ('OCA');
       casilla:=27;
       cambiojugador:=0;
       end;
     27:writeln ('GANADOR');
     else
         begin
         if casilla=a then
            begin
            writeln ('POSADA');
            cambiojugador:=2
            end
         else if casilla=b then
              begin
                writeln ('CALAVERA');
                casilla:=1;
                cambiojugador:=2
              end
              else
                 cambiojugador:=1;
              end;
         end;
end;

Procedure Jugada (var posicion,cambiojugador,activo,turno_castigo:word;a,b:integer;contrincante:word);
 {Finalidad: realizar el proceso de tirar los dados, calcular la posicion llamando a ComprobarCasilla.
 Parmetros: posicion,cambiojugador,activo,turno_castigo parmetro entrada-salida. Tipo referencia.
             a,b,contrincante parmetros de entrada. Tipo referencia}

Var
dado:word;

Begin
     writeln('Jugador',activo);
     dado:=Random(6)+1;
     writeln('el dado es:',dado);
     posicion:=posicion+dado;

     if posicion>27 then
         posicion:=27-(posicion-27);  {condicion de rebote en la OCA}
     writeln('La posicion del jugador', activo,'es:',posicion);
     ComprobarCasilla (posicion,cambiojugador,a,b);
     writeln('La posicion del jugador', activo,'despues de comprobar casilla es:',posicion);

     case cambiojugador of
             0: {salga OCA, implica volver a tirar.}
                begin
                      if activo=1 then activo:=1
                      else activo:=2;
                end;

             1: {caer en casilla normal,
             implica cambio turno siempre y cuando el contrincante no este en penalizacin por caer en posada o calavera.}
                begin
                      if((turno_castigo=2) and (activo =1)) then activo:=1;
                      if((turno_castigo=1) and (activo=2)) then activo:=2;
                      if((activo=1) and (turno_castigo=0)) then activo:=2
                      else activo:=1;
                      turno_castigo:=0;
                end;

             2: {caer en puente, posada, calavera, implica perder turno. (tira dos veces el otro jugador)}
                begin
                       if activo=1 then
                       begin
                         activo:=2;
                         turno_castigo:=1;
                       end
                       else
                       begin
                         activo:=1;
                         turno_castigo:=2;
                       end;
                  writeln('Castigo!!!')
                end;
       end;
end;


Procedure DibujaTablero (pos_usuario,pos_maq:word;p,c:integer);
 {Finalidad:Saca por pantalla el dibujo del tablero.
 Parmetros: pos_usuario,pos_maq,p,c parmetro entrada. Tipo referencia}

var
  cont_tablero,filas:word;
Begin
  cont_tablero:=0;
  for cont_tablero:=0 to 27 do
     begin

  {Estabecemos el color para las fichas y para las casillas}
        if cont_tablero=pos_usuario then TextColor(Red)
        else if cont_tablero=pos_maq then TextColor(Blue)
        else if((cont_tablero=5) or (cont_tablero=9) or (cont_tablero=14) or (cont_tablero=18)) then TextColor(Yellow)
        else if((cont_tablero=23) or (cont_tablero=27)) then TextColor(Yellow)
        else if ((cont_tablero=6) or (cont_tablero=12)) then TextColor(Green)
        else if ((cont_tablero=p) or (cont_tablero=c)) then TextColor(Brown)
        else TextColor(White);

  {Dibujamos el tablero en pantalla}
        if (cont_tablero<9) then write(' ',cont_tablero)
        else if ((cont_tablero mod 9)=0) then writeln(' ',cont_tablero)
        else write(' ',cont_tablero);
     end;
end;


Procedure Funcion_Menu (var opcion:char);
{Finalidad: muestra en pantalla el menu de inicio.
 Parmetros: opcion parmetro de entrada-salida. Tipo referencia.}

begin
    ClrScr;
    TextColor(Blue);
    writeln('**********************************************');
    writeln('***********Welcome to The OCAs GAME***********');
    writeln('**********************************************');
    {$I-}
    repeat
    TextColor(Red);
    writeln('Seleccione una de las opciones disponibles');
    writeln('a.- Jugar al Juego');
    writeln('b.- Salir del Juego');
    readln(opcion);
    until (((opcion='a') or (opcion='b')) and (IOResult=0));
    {$I+}
end;


Procedure Jugar;
 {Finalidad:  desarrollo del juego, llamadas a Jugada y DibujaTablero
 Parmetros:las variables son todas locales.}
var
  posM,posU,resultadojugada,jugadoractivo,turno_castigo:word;
  continuar,p,c:integer;

begin
  randomize;
  posM:=0; {inicializar variables}
  posU:=0;
  resultadojugada:=0;
  jugadoractivo:=1; {1 es el usuario, 2 es la mquina}
  continuar:=1;
  turno_castigo:=0;
   {$I-}
  Writeln ('Elige una casilla para la calavera. No puede ser ni 5, 9, 14, 18, 23, 6, 12');
  Readln (c);
        While not ((IOResult=0) and (c>1) and (c<>5) and (c<>9) and (c<>14)
                                and (c<>18) and (c<>23) and (c<27) and (c<>6) and (c<>12)) DO
            begin
              writeln ('Casilla no permitida,vuelvelo a intentar.');
              readln (c);
            end;
  Writeln ('Casilla para la posada? Mayor de 12, que no sean ni 14, 18, 23,27,ni la elegida como calavera');
  Readln (p);
        While ( (IOResult<>0) OR (p<=12) OR (p=14) OR (p=18) OR(p=23) OR(p>=27) OR (p=c)) DO
            begin
              writeln ('Casilla no permitida, vuelvelo a intentar');
              readln(p);
            end;
  Writeln ('El usuario llevar la ficha ROJA y la mquina ficha AZUL');
  Writeln ('Las casillas OCA van en AMARILLO, los puentes en VERDE y la posada-calavera en MARRON');
  Readln;

{$I+}
       ClrScr;
       While ((posM<>27) and (posU<>27)) DO
             begin
             ClrScr;
             DibujaTablero(posU,posM,p,c);
             TextColor(white);
             if jugadoractivo=1 then
             Jugada(posU,resultadojugada,jugadoractivo,turno_castigo,p,c,posM);
             if jugadoractivo=2 then
             Jugada (posM,resultadojugada,jugadoractivo,turno_castigo,p,c,posU);
             readln;
             end;

             readln;
end;

Procedure Salir;
{Finalidad: pone final al juego}

begin
    ClrScr;
    writeln('Gracias por jugar con nosotros! Hasta la prxima.');
    readln;
end;

{-----------------Cuerpo del programa----------------------------}

Var
continuar,s:word;
opcion:char;

Begin

    TextColor(white);
    continuar:=1;

        While (continuar=1) do
            Begin
            ClrScr;
            Funcion_Menu(opcion);
              case opcion of
              'a': begin
                 Jugar;
                 end;

             'b': begin
                 Salir;
                 break; {Sale de la iteracin.}
                 end;
              end;
            end;
End.

