 {Inicio del programa principal del Juego de la Oca}

Program LA_OCA;
  Uses crt;

 {Declaracin de las variables utilizadas para el funcionamiento del programa,
 tenemos diferentes variables en nombre y en tipo (Entero y Caracter).
 Variables para identificar el jugador del ordenador (Jugador, Pc).
 Variables para el cambio de turno (Turno).
 Variable para asignar la funcin Dado,(Dado2) declarada ms adelante.
 Variables para la casilla Posada, Puente y Calavera (Posada, Puente, Calavera).
 Variable para mostrar las instrucciones del juego (Inst).}

  Var
  Jugador,Pc,Turno,Dado2,Posada,Puente,Calavera,Inst:integer;

 {Para mostrar el tablero con las situacin de los jugadores, elegimos la opcin
 de crear un procedimiento con la ventaja de poder utilizarlo en cualquier
 otro programa.
 Utilizamos variables tipo entero para la colocacin de la casilla Posada (Po),
 la casilla Calavera (C), y la posicin que irn teniendo el jugador (J),
 y el ordenador (P).}

    procedure tablero (Po,C,J,P:Integer);
    begin
   clrscr;
   gotoxy (1,1);
   writeln ('                            ++TABLERO++');
   gotoxy (1,2);
   writeln ('            |00|01|02|03|04|05|06|07|08|09|10|11|12|13|');
   gotoxy (1,5);
   writeln ('            |14|15|16|17|18|19|20|21|22|23|24|25|26|27|');
   textcolor(9);
   gotoxy (29,2); write ('05');
   gotoxy (41,2); write ('09');
   gotoxy (14,5); write ('14');
   gotoxy (26,5); write ('18');
   gotoxy (41,5); write ('23');
   normvideo;
   textcolor(22);
   gotoxy (53,5); write ('27');
   normvideo;
   textcolor(14);
   gotoxy (32,2); write ('06');
   gotoxy (50,2); write ('12');
   normvideo;
   textcolor (2);
   Case Po of
   13:begin
   gotoxy (53,2); write (Po);
      end;
   15,16,17,19,20,21,22,24,25,26:begin
   gotoxy ((Po-14)*3+14,5); write (Po);
                                 end;
    end;
   normvideo;
   textcolor (4);
   Case C of
   2,3,4,7,8:begin
   gotoxy ((C*3-2)+16,2); write ('0',C);
             end;
   10,11,13:begin
   gotoxy ((C*3-2)+16,2); write (C);
            end;
   15,16,17,19,20,21,22,24,25,26:begin
   gotoxy ((C-14)*3+14,5); write (C);
                                 end;
    end;
   normvideo;
   Case P of
   0:begin
   gotoxy (14,3); write ('Pc');
     end;
   1,2,3,4,5,6,7,8,9,10,11,12,13:begin
   gotoxy ((P*3-2)+16,3); write ('Pc');
                                 end;
   14,15,16,17,18,19,20,21,22,23,24,25,26,27:begin
   gotoxy ((P-14)*3+14,6); write ('Pc');
                                             end;
    end;
   Case J of
   0:begin
   gotoxy (14,4); write ('Ju');
     end;
   1,2,3,4,5,6,7,8,9,10,11,12,13:begin
   gotoxy ((J*3-2)+16,4); write ('Ju');
                                 end;
   14,15,16,17,18,19,20,21,22,23,24,25,26,27:begin
   gotoxy ((J-14)*3+14,7); write ('Ju');
                                             end;
   end;
   writeln (' ');
   end;

   {Al igual que en el tablero, por ms comodidad y aclaracin, para el
   funcionamiento del dado elegimos crear una Funcin que nos devuelva un entero
   y que tenga por variable tambin un entero.}

    Function Dado:integer;
     var dad:integer;
    Begin
         dad:=random(6);
         dad:=dad+1;
         Dado:=dad;
    End;

   {Damos inicio al cuerpo del programa principal.}

BEGIN
   randomize;
   clrscr;
   textcolor (19);
   writeln ('*****************************************');
   writeln ('***BIENVENIDO AL JUEGO DE LA OCA!!!***');
   writeln ('*****************************************');
   writeln;
   normvideo;

   {Se repetir el mensaje siguiente hasta que el usuario introduzca lo que se pide.
   Te da dos opciones, la de si quieres leer las instrucciones bsicas del juego,
   y otra, la de si quieres empezar directamente a jugar.}

   Repeat
   writeln ('Si desea leer las instrucciones bsicas del juego, pulse 1');
   writeln ('y a continuacin la tecla enter.');
   writeln ('Si desea comenzar a jugar ya, pulse 2 y a continuacin la tecla enter.');
   {$I-}
   readln (Inst);
   {$I+}
   until (ioresult=0) and (Inst=1) or (Inst=2);
   clrscr;
   If Inst=1 then
   Begin
   writeln('Reglas del Juego de la Oca:');
   writeln;
   writeln('Objetivo: recorrer todo el tablero lo antes posible y acabarlo en la casilla 27.');
   writeln('Normas:');
   writeln('- El tablero tiene 27 casillas numeradas.');
   writeln('- Puede participar solamente un jugador frente al ordenador. Se dispondr de ');
   writeln('dos fichas y un dado. La ficha del ordenador se representa como Pc ');
   writeln('y la del jugador como Ju.');
   writeln('- Los jugadores tiran el dado por turnos y avanzan el nmero de casillas ');
   writeln('que marca el mismo.');
   writeln('- En el juego hay casillas especiales, cuyo funcionamiento se explica ');
   writeln('a continuacin:');
   writeln('- Pulse enter');
   readln;
   clrscr;
   writeln('Casillas para avanzar:');
  textcolor (9);
   writeln('-Casillas oca (5, 9, 14, 18, 23): cuando caemos en una de ellas, ');
   writeln('avanzamos hasta la siguiente oca, decimos: "de oca a oca y tiro porque me ');
   writeln('toca" y tiramos el dado otra vez.');
  normvideo;
   writeln('Casillas para avanzar o retroceder y de castigo:');
  textcolor (14);
   writeln('-Casillas puente (6 y 12): cuando caemos en una de ellas, avanzamos o');
   writeln('retrocedemos hasta donde se haya declarado la casilla Posada.');
  normvideo;
  textcolor (2);
   writeln('-Casilla posada (casilla elegida a nuestro antojo dentro de unos lmites):');
   writeln('cuando caemos en sta casilla perdemos un turno.');
  normvideo;
   writeln('Casillas para retroceder:');
  textcolor (4);
   writeln('-Casilla calavera (casilla elegida a nuestro antojo dentro de unos lmites):');
   writeln('nos hace retroceder a la casilla nmero 1.');
  normvideo;
   writeln('Casilla ganadora:');
  textcolor (6);
   writeln('-La casilla ganadora es el Jardn de la Oca, situada en la ltima casilla (27).');
  normvideo;
   writeln('- Pulse enter para comenzar la partida');
  readln;
   Inst:=2;
   end;

   {Comenzamos a jugar.}

   If Inst=2 then
   clrscr;
   writeln ('Comienza la partida!!! MUCHA SUERTE!!!!!');
   writeln;
   writeln ('Indique en el tablero la posicin de las casillas');
   writeln ('Posada y Calavera. ');

   {Se repetir el mensaje siguiente hasta que el usuario introduzca lo que se pide.}

   Repeat
   writeln ('Escriba un nmero de los siguientes para la casilla');
   writeln ('Posada: 13 15 16 17 19 20 21 22 24 25 26: ');

   {$I-}

   readln (Posada);

   {$I+}

   until (ioresult=0) and ((Posada>12) and (Posada<27) and not (Posada=14)
   and not (Posada=18) and not (Posada=23));
   clrscr;

   {Se repetir el siguiente mensaje hasta que el usuario introduzca lo que se le pide.}

   Repeat
   writeln ('Escriba un nmero de los siguientes para la casilla');
   writeln ('Calavera: 2 3 4 7 8 10 11 13 15 16 17 19 20 21 22 24 25 26: ');

   {$I-}

   readln (Calavera);

   {$I+}

   until (ioresult=0) and ((Calavera>1) and (Calavera<27) and not (Calavera=5) and not (Calavera=6)
   and not (Calavera=9) and not (Calavera=12)
   and not (Calavera=14) and not (Calavera=18) and not (Calavera=23)
   and not (Calavera=Posada));
   clrscr;

   {Se repetir el mensaje siguiente hasta que el usuario introduzca lo que se pide.}

   Repeat
   writeln ('Elige quien juega primero, pulsa 1 para que empiece el ordenador ');
   writeln ('o 2 para empezar t ');

   {$I-}

   readln (Turno);

   {$I+}

   until (ioresult=0) and ((Turno=1) or (Turno=2));
   Pc:=0;
   Jugador:=0;
   clrscr;
   while (Pc<>27) and (Jugador<>27) do

   {Una vez introducidos todos los datos anteriores, nos disponemos a lanzar el dado.}

   Begin
   While (Turno=1) and (Jugador<>27) do
   Begin
   tablero (Posada,Calavera,Jugador,Pc);
   readln;
   clrscr;
   Dado2:=Dado;
   writeln ('Es el turno de la mquina que ha sacado ', Dado2);
   Pc:=Pc+Dado2;
   writeln ('La mquina esta en la casilla ', Pc);
   readln;

   {Recursos necesarios por si el ordenador cae en alguna casilla especial,
   Calavera, Puente o Posada}

   Case Pc of
         5:Begin
   writeln ('La mquina ha caido en oca, avanza hasta la casilla 9 y tira otra vez!');
   readln;
   Pc:=9;
   Turno:=1
           end;
      6,12:Begin
   writeln ('La mquina ha caido en puente y va hasta la casilla Posada!');
   Pc:=Posada;
           end;
         9:Begin
   writeln ('La mquina ha caido en oca, avanza hasta la casilla 14 y tira otra vez!');
   readln;
   Pc:=14;
   Turno:=1
           end;
        14:Begin
   writeln ('La mquina ha caido en oca, avanza hasta la casilla 18 y tira otra vez!');
   readln;
   Pc:=18;
   Turno:=1
           end;
        18:Begin
   writeln ('La mquina ha caido en oca, avanza hasta la casilla 23 y tira otra vez!');
   readln;
   Pc:=23;
   Turno:=1
           end;
        23:Begin
   writeln ('La mquina ha caido en oca y llega hasta el jardn');
  textcolor (22);
   writeln ('               La mquina gana la partida!!!!');
   readln;
  normvideo;
   Pc:=27;
   Turno:=2;
           end;
        27:Begin
   writeln ('La mquina ha llegado al jardn de la oca');
  textcolor (22);
   writeln ('               La mquina gana la partida!!!!');
   readln;
  normvideo;
   Turno:=2;
           end;
   28,29,30,31,32:Begin
   Pc:=27-(Pc-27);
   writeln ('La mquina se ha pasado del jardn y rebota hasta la casilla ' , Pc);
   readln;
   If Pc=23 then
   begin
   writeln ('La mquina ha caido en oca y llega hasta el jardn');
  textcolor (22);
   writeln ('               La mquina gana la partida!!!!');
   readln;
  normvideo;
   Pc:=27;
   Turno:=2;
   end
         else
   Turno:=2
         end
         else
   Turno:=2;
                  End;
   If Pc=Calavera then
   Begin
   writeln ('La mquina ha caido en la casilla Calavera.Retrocede hasta la casilla 1!!');
   readln;
   Pc:=1;
   Turno:=2;
   writeln ('La mquina esta en la casilla ', Pc);
   end
   else
   If Pc=Posada then
   Begin
   writeln ('La mquina ha caido en la casilla Posada. Pierde un turno!!');
   writeln ('La mquina est en la casilla ', Pc);
   readln;
   Turno:=4;
   end;
   End;
   while (Turno=2) and (Pc<>27) do
   Begin
   tablero (Posada,Calavera,Jugador,Pc);
   readln;
   clrscr;
   Dado2:=Dado;
   writeln ('Es tu turno, pulsa enter para tirar el dado');
   readln;
   writeln ('Has sacado ', Dado2);
   Jugador:=Jugador+Dado2;
   writeln ('Estas en la casilla ', Jugador);
   writeln ('');
   readln;

   {Recursos necesarios por si el jugador cae en alguna casilla especial,
   Calavera, Puente o Posada}

   Case Jugador of
         5:Begin
   writeln ('Has caido en oca, avanzas hasta la casilla 9 y tiras otra vez');
   readln;
   Jugador:=9;
   Turno:=2
           end;
      6,12:Begin
   writeln ('Has caido en puente, vas hasta la casilla Posada!');
   Jugador:=Posada;
           end;
         9:Begin
   writeln ('Has caido en oca, avanzas hasta la casilla 14 y tiras otra vez');
   readln;
   Jugador:=14;
   Turno:=2
           end;
        14:Begin
   writeln ('Has caido en oca, avanzas hasta la casilla 18 y tiras otra vez');
   readln;
   Jugador:=18;
   Turno:=2
           end;
        18:Begin
   writeln ('Has caido en oca, avanzas hasta la casilla 23 y tiras otra vez');
   readln;
   Jugador:=23;
   Turno:=2
           end;
        23:Begin
   writeln ('Has caido en oca, avanzas hasta el jardn de la oca');
  textcolor (22);
   writeln ('               Ganas la partida!!!!');
   readln;
  normvideo;
   Jugador:=27;
   Turno:=1;
           end;
        27:Begin
   writeln ('Has llegado al jardn de la oca');
  textcolor (22);
   writeln ('               Ganas la partida!!!!');
   readln;
  normvideo;
   Turno:=1;
           end;
   28,29,30,31,32:Begin
   Jugador:=27-(Jugador-27);
   writeln ('Te has pasado del jardn, rebotas hasta la casilla ' , Jugador);
   readln;
   If Jugador=23 then
   Begin
   writeln ('Has caido en oca, avanzas hasta el jardn de la oca');
  textcolor (22);
   writeln ('               Ganas la partida!!!!');
   readln;
  normvideo;
   Jugador:=27;
   Turno:=1;
         end
         else
   Turno:=1;
         end
         else Turno:=1;
   End;
   If Jugador=Calavera then
   Begin
   writeln ('Has caido en la casilla Calavera.Retrocedes hasta la casilla 1!!');
   readln;
   Jugador:=1;
   Turno:=1;
   writeln ('Estas en la casilla ', Jugador);
   readln;
   end
   else
   If Jugador=Posada then
   Begin
   writeln ('Has caido en la casilla Posada. Pierdes un turno!!');
   writeln ('Estas en la casilla ', Jugador);
   readln;
   Turno:=3
   end;
   End;
   While (Turno=3) and (Jugador<>27) do
   Begin
   tablero (Posada,Calavera,Jugador,Pc);
   readln;
   clrscr;
   Dado2:=Dado;
   writeln ('Es el turno de la mquina que ha sacado ', Dado2);
   Pc:=Pc+Dado2;
   writeln ('La mquina esta en la casilla ', Pc);
   readln;
   Case Pc of
         5:Begin
   writeln ('La mquina ha caido en oca, avanza hasta la casilla 9 y tira otra vez!');
   readln;
   Pc:=9;
   Turno:=3
           end;
      6,12:Begin
   writeln ('La mquina ha caido en puente y va hasta la casilla Posada!');
   Pc:=Posada;
           end;
         9:Begin
   writeln ('La mquina ha caido en oca, avanza hasta la casilla 14 y tira otra vez!');
   readln;
   Pc:=14;
   Turno:=3
           end;
        14:Begin
   writeln ('La mquina ha caido en oca, avanza hasta la casilla 18 y tira otra vez!');
   readln;
   Pc:=18;
   Turno:=3
           end;
        18:Begin
   writeln ('La mquina ha caido en oca, avanza hasta la casilla 23 y tira otra vez!');
   readln;
   Pc:=23;
   Turno:=3
           end;
        23:Begin
   writeln ('La mquina ha caido en oca y llega hasta el jardn');
  textcolor (22);
   writeln ('               La mquina gana la partida!!!!');
   readln;
  normvideo;
   Pc:=27;
   Turno:=2;
           end;
        27:Begin
   writeln ('La mquina ha llegado al jardn de la oca');
  textcolor (22);
   writeln ('               La mquina gana la partida!!!!');
   readln;
  normvideo;
   Turno:=2;
           end;
   28,29,30,31,32:Begin
   Pc:=27-(Pc-27);
   writeln ('La mquina se ha pasado del jardn y rebota hasta la casilla ' , Pc);
   readln;
   If Pc=23 then
   Begin
   writeln ('La mquina ha caido en oca y llega hasta el jardn');
  textcolor (22);
   writeln ('               La mquina gana la partida!!!!');
   readln;
  normvideo;
   Pc:=27;
   Turno:=2;
         end
         else
   Turno:=1
   End;
         else
   Turno:=1
         end;
   If Pc=Calavera then
   Begin
   writeln ('La mquina ha caido en la casilla Calavera.Retrocede hasta la casilla 1!!');
   readln;
   Pc:=1;
   writeln ('La mquina esta en la casilla ', Pc);
   readln;
   Turno:=2;
   end
   else
   If Pc=Posada then
   Begin
   writeln ('La mquina ha caido en la casilla Posada. Pierde un turno!!');
   writeln ('La mquina esta en la casilla ', Pc);
   readln;
   Turno:=4;
   end;
   If Turno=1 then
   Begin
   writeln ('La mquina tira de nuevo porque estas en la posada');
   readln;
   End;
   End;
   while (Turno=4) and (Jugador<>27) do
   Begin
   tablero (Posada,Calavera,Jugador,Pc);
   readln;
   clrscr;
   Dado2:=Dado;
   writeln ('Es tu turno, pulsa enter para tirar el dado');
   readln;
   writeln ('Has sacado ', Dado2);
   Jugador:=Jugador+Dado2;
   writeln ('Estas en la casilla ', Jugador);
   writeln ('');
   readln;
   Case Jugador of
         5:Begin
   writeln ('Has caido en oca, avanzas hasta la casilla 9 y tiras otra vez');
   readln;
   Jugador:=9;
   Turno:=4
           end;
      6,12:Begin
   writeln ('Has caido en puente, vas hasta la casilla Posada!');
   Jugador:=Posada;
           end;
         9:Begin
   writeln ('Has caido en oca, avanzas hasta la casilla 14 y tiras otra vez');
   readln;
   Jugador:=14;
   Turno:=4
           end;
        14:Begin
   writeln ('Has caido en oca, avanzas hasta la casilla 18 y tiras otra vez');
   readln;
   Jugador:=18;
   Turno:=4
           end;
        18:Begin
   writeln ('Has caido en oca, avanzas hasta la casilla 23 y tiras otra vez');
   readln;
   Jugador:=23;
   Turno:=4
           end;
        23:Begin
   writeln ('Has caido en oca, avanzas hasta el jardn de la oca');
  textcolor (22);
   writeln ('               Ganas la partida!!!!');
   readln;
  normvideo;
   Jugador:=27;
   Turno:=1;
           end;
        27:Begin
   writeln ('Has llegado al jardn de la oca');
  textcolor (22);
   writeln ('               Ganas la partida!!!!');
   readln;
  normvideo;
   Jugador:=27;
   Turno:=1;
           end;
   28,29,30,31,32:Begin
   Jugador:=27-(Jugador-27);
   writeln ('Te has pasado del jardn, rebotas hasta la casilla ' , Jugador);
   readln;
   If Jugador=23 then
   Begin
   writeln ('Has llegado al jardn de la oca');
  textcolor (22);
   writeln ('               Ganas la partida!!!!');
   readln;
  normvideo;
   Jugador:=27;
   Turno:=1;
         end
         else
   Turno:=2;
                  End;
         else
   Turno:=2;
   End;
   If Jugador=Calavera then
   Begin
   writeln ('Has caido en la casilla Calavera.Retrocedes hasta la casilla 1!!');
   readln;
   Jugador:=1;
   writeln ('Estas en la casilla ', Jugador);
   readln;
   Turno:=1;
   end
   else
   If (Jugador=Posada) Then
   Begin
   writeln ('Has caido en la casilla Posada. Pierdes un turno!!');
   writeln ('Estas en la casilla ', Jugador);
   readln;
   Turno:=3
   End;
   If Turno=2 then
   Begin
   writeln ('Tiras de nuevo porque la mquina esta en la posada');
   readln;
   end;
   end;
   End;
END.


