Program oca;
Uses
Crt;
Const
   {No quedaba claro en el enunciado la casilla en que situar la casilla
   inicial,por lo que se ha considerado ponerla en la casilla 1 y no en la 0}

     Casilla_inicial=1;
     Casillaoca1=5;
     Casillaoca2=9;
     Casillaoca3=14;
     Casillaoca4=18;
     Casillaoca5=23;
     Puente1=6;
     Puente2=12;
     Jardin_de_la_Oca=27;
Type
    {Los valores para casilla deberan estar comprendidos entre 0 y 27}
    casilla=0..27;

Procedure MostrarInstrucciones;
{Mostrar las instrucciones del juego al usuario}
Begin
     writeln;
     writeln('                 Bienvenido al juego de la Oca!!!');
     writeln('                   Vas a jugar contra el ordenador.');
     writeln('           El tablero consta de 27 casillas, empiezas en la 0.');
     writeln('        Tu objetivo es llegar al jardn de la Oca, en la casilla 27.');
     writeln('           Hay casillas especiales como las de la Oca, Puente,');
     writeln('                           Posada y Calavera.');
     writeln('                Si caes en la Posada, pierdes un turno.');
     writeln('           Si caes en la Calavera, vuelves a la primera casilla.');
     writeln('       Tu elegirs las casillas donde estarn la Posada y la Calavera.');
     writeln;
     writeln('                             SUERTE!');
     writeln('INICIO');
     writeln('=======');
     writeln;
     writeln
End;

Procedure PosicionPosada (var posada:casilla);
{Procedure para que el usuario eliga la casilla donde ir la posada,
la posada no puede estar ni en las casillas especiales ni antes de las
casillas de puente}
Var
   posd:integer;

Begin
     Repeat
     writeln('Escribe la casilla donde va la Posada, puedes seleccionar');
     writeln('cualquiera de las casillas entre la 13 y la 26, exceptuando');
     write('las casillas especiales que son la 14, 18 y 23: ');
     read(posd);
     writeln
     Until ((posd>12) and (posd<27)) and ((posd<>14) and (posd<>18) and (posd<>23));
     posada:=posd;
     writeln('La posada est en la casilla: ',posada);
     writeln
end;

Procedure PosicionCalavera(posada:casilla;var Calavera:casilla);
{Procedure para que el usuario eliga la casilla donde ir la calavera,
la calavera no puede estar ni en las casillas especiales ni en la salida ni
en el jardn de la Oca}
Var
   cal:integer;
Begin
     Repeat
     writeln('Escribe la posicion donde va la Calavera, puedes seleccionar');
     writeln('cualquiera de las casillas entre la 2 y la 26, exceptuando');
     write('las casillas especiales que son la 5, 6, 9, 12, 14, 18 y 23: ');
     read(cal);
     writeln;
     Until
     ((cal>casilla_inicial) and (cal<jardin_de_la_Oca)) and ((cal<>casillaOca1)
     and (cal<>puente1) and (cal<>casillaOca2) and (cal<>puente2) and (cal<>casillaOca3)
     and (cal<>casillaOca4) and (cal<>casillaOca5)and(cal<>posada));
     Calavera:=cal;
     writeln('La Calavera est en la casilla: ',Calavera);
     readln;
     readln
end;

Procedure POSICION(posicionJ,posicionM:casilla);
{Procedimiento para mostrar el tablero con la situacion del jugador
 y de la mquina}

var
i:integer;
begin
     writeln(' _____________________________________________________________________ ');
     writeln('|17      |16       |15      |14 OCA   |13        |12 PUENTE |11       |');
     writeln('|        |         |        |         |          |          |         |');
     writeln('|________|_________|________|_________|__________|__________|_________|');
     writeln('|18 OCA  |                                                  |10       |');
     writeln('|        |                                                  |         |');
     writeln('|________|          _______________________________         |_________|');
     writeln('|19      |         | 27                            |        |9  OCA   |');
     writeln('|        |         |    Jardn de la Oca           |        |         |');
     writeln('|________|         |_______________________________|        |         |');
     writeln('|20      |                              |26        |        |_________|');
     writeln('|        |                              |          |        |8        |');
     writeln('|________|______________________________|__________|        |         |');
     writeln('|21      |22      |23  OCA   |24        |25        |        |         |');
     writeln('|        |        |          |          |          |        |_________|');
     writeln('|________|________|__________|__________|__________|        |7        |');
     writeln('                                                            |         |');
     writeln(' ___________________________________________________________|_________|');
     writeln('|1         |2         |3         |4           |5   OCA      |6 PUENTE |');
     writeln('|          |          |          |            |             |         |');
     writeln('|__________|__________|__________|____________|_____________|_________|');


   {Diferentes valores que puede tomar la posicin del jugador,
   con su respectiva posicin en el tablero}

      Case posicionJ of
      1:  Begin gotoxy(5,23); writeln('J'); gotoxy(1,25); end;
      2:  Begin gotoxy(17,23); writeln('J'); gotoxy(1,25); end;
      3:  Begin gotoxy(28,23); writeln('J'); gotoxy(1,25); end;
      4:  Begin gotoxy(39,23); writeln('J'); gotoxy(1,25); end;
      5:  Begin gotoxy(52,23); writeln('J'); gotoxy(1,25); end;
      6:  Begin gotoxy(65,23); writeln('J'); gotoxy(1,25); end;
      7:  Begin gotoxy(65,20); writeln('J'); gotoxy(1,25); end;
      8:  Begin gotoxy(65,17); writeln('J'); gotoxy(1,25); end;
      9:  Begin gotoxy(65,13); writeln('J'); gotoxy(1,25); end;
      10: Begin gotoxy(65,9);  writeln('J'); gotoxy(1,25); end;
      11: Begin gotoxy(65,6);  writeln('J'); gotoxy(1,25); end;
      12: Begin gotoxy(53,6);  writeln('J'); gotoxy(1,25); end;
      13: Begin gotoxy(43,6);  writeln('J'); gotoxy(1,25); end;
      14: Begin gotoxy(33,6);  writeln('J'); gotoxy(1,25); end;
      15: Begin gotoxy(23,6);  writeln('J'); gotoxy(1,25); end;
      16: Begin gotoxy(14,6);  writeln('J'); gotoxy(1,25); end;
      17: Begin gotoxy(5,6);  writeln('J'); gotoxy(1,25); end;
      18: Begin gotoxy(5,9);  writeln('J'); gotoxy(1,25); end;
      19: Begin gotoxy(5,12);  writeln('J'); gotoxy(1,25); end;
      20: Begin gotoxy(5,15);  writeln('J'); gotoxy(1,25); end;
      21: Begin gotoxy(5,18);  writeln('J'); gotoxy(1,25); end;
      22: Begin gotoxy(13,18);  writeln('J'); gotoxy(1,25); end;
      23: Begin gotoxy(22,18);  writeln('J'); gotoxy(1,25); end;
      24: Begin gotoxy(34,18);  writeln('J'); gotoxy(1,25); end;
      25: Begin gotoxy(45,18);  writeln('J'); gotoxy(1,25); end;
      26: Begin gotoxy(45,15);  writeln('J'); gotoxy(1,25); end;
      27: Begin gotoxy(45,12);  writeln('J'); gotoxy(1,25); end;
      end;

   {Diferentes valores que puede tomar la posicin de la mquina,
   con su respectiva posicin en el tablero}

      Case posicionM of
      1:  Begin gotoxy(6,23); writeln('M'); gotoxy(1,25); end;
      2:  Begin gotoxy(18,23); writeln('M'); gotoxy(1,25); end;
      3:  Begin gotoxy(29,23); writeln('M'); gotoxy(1,25); end;
      4:  Begin gotoxy(40,23); writeln('M'); gotoxy(1,25); end;
      5:  Begin gotoxy(53,23); writeln('M'); gotoxy(1,25); end;
      6:  Begin gotoxy(66,23); writeln('M'); gotoxy(1,25); end;
      7:  Begin gotoxy(66,20); writeln('M'); gotoxy(1,25); end;
      8:  Begin gotoxy(66,17); writeln('M'); gotoxy(1,25); end;
      9:  Begin gotoxy(66,13); writeln('M'); gotoxy(1,25); end;
      10: Begin gotoxy(66,9);  writeln('M'); gotoxy(1,25); end;
      11: Begin gotoxy(66,6);  writeln('M'); gotoxy(1,25); end;
      12: Begin gotoxy(54,6);  writeln('M'); gotoxy(1,25); end;
      13: Begin gotoxy(44,6);  writeln('M'); gotoxy(1,25); end;
      14: Begin gotoxy(34,6);  writeln('M'); gotoxy(1,25); end;
      15: Begin gotoxy(24,6);  writeln('M'); gotoxy(1,25); end;
      16: Begin gotoxy(15,6);  writeln('M'); gotoxy(1,25); end;
      17: Begin gotoxy(6,6);   writeln('M'); gotoxy(1,25); end;
      18: Begin gotoxy(6,9);   writeln('M'); gotoxy(1,25); end;
      19: Begin gotoxy(6,12);  writeln('M'); gotoxy(1,25); end;
      20: Begin gotoxy(6,15);  writeln('M'); gotoxy(1,25); end;
      21: Begin gotoxy(6,18);  writeln('M'); gotoxy(1,25); end;
      22: Begin gotoxy(14,18); writeln('M'); gotoxy(1,25); end;
      23: Begin gotoxy(23,18); writeln('M'); gotoxy(1,25); end;
      24: Begin gotoxy(35,18); writeln('M'); gotoxy(1,25); end;
      25: Begin gotoxy(46,18); writeln('M'); gotoxy(1,25); end;
      26: Begin gotoxy(46,15); writeln('M'); gotoxy(1,25); end;
      27: Begin gotoxy(46,12); writeln('M'); gotoxy(1,25); end;
      end;

end;

Function Dados:integer;
{Funcin para tirar los dados}
var
   x:integer;

Begin
     x:=random(6);
             Case x of
             0:Dados:=1;
             1:Dados:=2;
             2:Dados:=3;
             3:Dados:=4;
             4:Dados:=5;
             5:Dados:=6
             end;
end;

Procedure Jugador(posicionM:casilla; var PosicionJ:casilla);
{Procedimiento para indicar que es el turno del jugador,
 el valor obtenido en los dados y la posicin que pasa a ocupar.
 Despus muestra el tablero.}
var
   tirada:integer;

Begin
     readln;
     writeln('Es tu turno, tira el dado!');
     readln;
     tirada:=dados;
     writeln('Has sacado un ',tirada);
     if (posicionJ+tirada)<=27 then
        posicionJ:=posicionJ+tirada
     else
         posicionJ:=(27-(posicionJ+tirada-27));

     readln;
     POSICION(posicionJ,posicionM)

end;

Procedure Maquina(posicionJ:casilla; var posicionM:casilla);
{Procedimiento para indicar que es el turno de la mquina,
 el valor obtenido en los dados y la posicin que pasa a ocupar.
 Despus muestra el tablero.}
var
   tirada:integer;
Begin
     writeln('Es turno de la mquina');
     readln;
     tirada:=dados;
     writeln('La mquina ha sacado un ',tirada);

     if (posicionM+tirada)<=27 then
        posicionM:=posicionM+tirada
     else
         posicionM:=(27-(posicionM+tirada-27));

     readln;
     POSICION(posicionJ,posicionM);

end;
{Mdulo para mostrar quien a cado en alguna casilla especial e indicar
el turno, tirar y mostrar el tablero tras la tirada.}
Procedure DeOcaAOca(humano:boolean; var posicionJ,posicionM:casilla);
 Begin
   If (humano) and (posicionJ<>27) then
   Begin
   writeln('Has cado en la oca, saltas a la casilla ',posicionJ);
   readln;
   POSICION(posicionJ,posicionM);
   writeln;
   Jugador(posicionM,posicionJ);
   writeln
   end
   else if (not humano) and (posicionM<>27) then
   Begin
   write('La maquina ha cado en la oca, salta a la casilla ',posicionM);
   readln;
   POSICION(posicionJ,posicionM);
   writeln;
   Maquina(posicionJ,posicionM);
   writeln
   end;

  If posicionJ=27 then
   Begin
   writeln('Has cado en la oca, saltas al jardn de la oca');
   readln;
   POSICION(posicionJ,posicionM)
   end
  else if posicionM=27 then
   Begin
   writeln('La mquina ha cado en la oca, salta al jardn de la oca');
   readln;
   POSICION(posicionJ,posicionM)
   end;

 end;
{Mdulo para cuando la mquina o el jugador esten en alguna casilla oca o puente. Mientras
la posicin sea de oca o puente se seguira ejecutando el mdulo.}
Procedure casillas_especiales(posada:casilla;humano:boolean; var posicionJ,posicionM:casilla);

begin
   If humano then
    Begin
     repeat
        case posicionJ of

        CasillaOca1:begin posicionJ:=9;
                          DeOcaAOca(true,posicionJ,posicionM)
                    end;

        CasillaOca2:begin posicionJ:=14;
                          DeOcaAOca(true,posicionJ,posicionM)
                    end;

        CasillaOca3:begin posicionJ:=18;
                          DeOcaAOca(true,posicionJ,posicionM)
                    end;

        CasillaOca4:begin posicionJ:=23;
                          DeOcaAOca(true,posicionJ,posicionM)
                    end;

        CasillaOca5:begin posicionJ:=27;
                          DeOcaAOca(true,posicionJ,posicionM)
                    end;

        Puente1,Puente2: begin posicionJ:=posada;
                               writeln('Has cado en el puente, vas a la Posada');
                               readln;
                               POSICION(posicionJ,posicionM)
                         end
        end;

     Until ((posicionJ<>5) and (posicionJ<>9) and (posicionJ<>14)
                  and (posicionJ<>18) and (posicionJ<>23))

    end
  else Begin
       repeat
        case posicionM of

        CasillaOca1:begin posicionM:=9;
                          DeOcaAOca(false,posicionJ,posicionM)
                    end;

        CasillaOca2:begin posicionM:=14;
                          DeOcaAOca(false,posicionJ,posicionM)
                    end;

        CasillaOca3:begin posicionM:=18;
                          DeOcaAOca(false,posicionJ,posicionM)
                    end;

        CasillaOca4:begin posicionM:=23;
                          DeOcaAOca(false,posicionJ,posicionM)
                    end;

        CasillaOca5:begin posicionM:=27;
                          DeOcaAOca(false,posicionJ,posicionM)
                    end;

        Puente1,Puente2: begin posicionM:=posada;
                               writeln('La mquina ha cado en el puente, va a la Posada');
                               readln;
                               POSICION(posicionJ,posicionM)
                         end
        end;

     Until  ((posicionM<>5) and (posicionM<>9) and (posicionM<>14)
           and (posicionM<>18) and (posicionM<>23))

end
end;

{Mdulo para cuando la posicin del jugador y/o la mquina sea la de la posada.}
Procedure turno_posada(humano: boolean; var posada,posicionJ,posicionM:casilla);
Begin
        If humano then
        begin
        If (posicionJ=posada) and (posicionM<>posada) then
                begin
                writeln;
                writeln('Has cado en la posada, pierdes un turno');
                readln;
                POSICION(posicionJ,posicionM);
                writeln;
                Maquina(posicionJ,posicionM);
                Casillas_especiales(posada,false,posicionJ,posicionM);
                If (posicionM=posada) and (posicionJ<>posada) then
                  begin
                  writeln;
                  writeln('La mquina ha cado en la posada, pierde un turno');
                  readln;
                  POSICION(posicionJ,posicionM);
                  writeln;
                  Jugador(posicionM,posicionJ)
                  end
                else
                  if (posicionM=posada) and (posicionJ=posada) then
                  begin
                  writeln('La mquina ha cado en la posada, pierde un turno');
                  readln;
                  POSICION(posicionJ,posicionM);
                  Writeln('El jugador sale de la posada')

                  end;

                end
        else
                if (posicionJ=posada) and (posicionM=posada) then
                 begin
                 writeln('Has cado en la posada, pierdes un turno');
                 readln;
                 POSICION(posicionJ,posicionM);
                 Writeln('la mquina sale de la posada');
                 Maquina(posicionJ,posicionM)
                 end
        end
        else
        begin
        If (posicionM=posada) and (posicionJ<>posada) then
                  begin
                  writeln;
                  writeln('La mquina ha cado en la posada, pierde un turno');
                  readln;
                  POSICION(posicionJ,posicionM);
                  writeln;
                  Jugador(posicionM,posicionJ);
                  Casillas_especiales(posada,true,posicionJ,posicionM);
                  If (posicionJ=posada) and (posicionM<>posada) then
                     begin
                     writeln;
                     writeln('Has cado en la posada, pierdes un turno');
                     readln;
                     POSICION(posicionJ,posicionM);
                     writeln;
                     Maquina(posicionJ,posicionM)
                     end
                  else
                  if (posicionJ=posada) and (posicionM=posada) then
                  begin
                  writeln('Has cado en la posada, pierdes un turno');
                  readln;
                  POSICION(posicionJ,posicionM);
                  Writeln('La mquina sale de la posada')
                  end;

                  end
     else
                  if (posicionM=posada) and (posicionJ=posada) then
                  begin
                  writeln('La mquina ha cado en la posada, pierde un turno');
                  readln;
                  POSICION(posicionJ,posicionM);
                  Writeln('El jugador sale de la posada');
                  Jugador(posicionM,posicionJ)
                  end
        end
end;
{Mdulo para utilizar cuando puedan caer en la calavera tanto la mquina como el jugador}
Procedure turno_calavera(calavera:casilla; var posicionJ,posicionM:casilla);
Begin
 {si el jugador cae en la calavera}
 If posicionJ=calavera then
                begin
                writeln('Has cado en la calavera, vas a la casilla inicial');
                readln;
                posicionJ:=casilla_inicial;
                POSICION(posicionJ,posicionM);
                writeln
                end;
 {si la mquina cae en la calavera}
 If posicionM=calavera then
                 begin
                 writeln('La maquina ha cado en la calavera, va a la casilla inicial');
                 readln;
                 posicionM:=casilla_inicial;
                 POSICION(posicionJ,posicionM);
                 writeln
                 end
end;

Var
    posicionJ,posicionM, posada, calavera:casilla;
    cont:integer;
Begin
     {color de fondo}
     TextBackground(3);
     {color de texto}
     TextColor(5);
     {para hacer uso de la funcin random}
     randomize;
     MostrarInstrucciones;
     {Introducir el procedimiento posada}
     PosicionPosada(posada);
     readln;
     {Introducir el procedimiento calavera}
     PosicionCalavera(posada,calavera);
     {inicializar las variables}
     posicionJ:=0;
     posicionM:=0;
     {Al contador le asigno un nmero par para que empieze tirando el jugador}
     cont:=2;
     {proceso de juego}

     While (posicionJ<27) and (posicionM<27) do
     begin
           {si el contador es par juegua el jugador}
           If (cont mod 2)=0 then
               Begin
               Jugador(posicionM,PosicionJ);
               readln;
               {Si el jugador cae en alguna casilla de oca o puente...}
               Casillas_especiales(posada,true,posicionJ,posicionM);
               {Si el jugador cae en la posada}
               turno_posada(true,posada,posicionJ,posicionM);
               {Si el jugador cae en la calavera}
               turno_calavera(calavera,posicionJ,posicionM);
               cont:=cont+1
               end
           else
               Begin
               Maquina(posicionJ,PosicionM);
               readln;
               {si la mquina cae en alguna casilla de oca o puente...}
               Casillas_especiales(posada,false,posicionJ,posicionM);
               {si la mquina cae en la posada...}
               turno_posada(false,posada,posicionJ,posicionM);
               {si la mquina cae en la calavera...}
               turno_calavera(calavera,posicionJ,posicionM);
               cont:=cont+1
               end;
     end;

     If posicionJ=27 then
      begin
        writeln('Has ganado!');
        Delay(3000)
      end
     else
         writeln('La maquina ha ganado');
         Delay(3000)


end.
