Program juegoOca;  {PROGRAMA D1Bis}

USES

{Con esta unidad podemos utilizar textcolor para fondos de texto
y clrscr para limpiar pantalla}

CRT;

CONST

{Se usan las constantes para identificar los distintos colores que
se muestran en el programa y para las casillas especiales de puente}

     Blanco = 7;
     Verde = 10;
     Dorado = 6;
     Rojo = 4;
     Azul = 9;
     Rosa = 12;
     Morado = 5;
     Amarillo = 14;
     AzulClaro = 11;
     Negro = 0;
     puente6 = 6;
     puente12 = 12;

Procedure PasoAPaso;

{Con este procedimiento se va mostrando por pantalla paso por paso la
ejecucion}

Begin

        Textcolor(Blanco);
        writeln;
        write(' Presione Intro para continuar con el juego');
        readln
end;

Procedure PedirDatos(var posa,cala: integer);

{Se pide al usuario las posiciones de la casilla posada y
de la casilla calavera}

Begin
     clrscr;
     textcolor(Blanco);
     {$I-}
     REPEAT

           writeln;
           writeln(' Cual es la posicion de la casilla Posada?');
           writeln;
           writeln(' No pueden ser 1,2,3,4,5,6,9,12,14,18,23,27');
           write(' ');
           readln(posa);

     UNTIL (IOResult = 0) and (posa > 5) and (posa <> 6) and (posa <> 9) and
     (posa <> 12) and (posa <> 14 ) and (posa <> 18 ) and (posa <> 23 ) and
     (posa < 27 );
     writeln;
     {$I+}

     {$I-}
     REPEAT

           writeln(' Cual es la posicion de la casilla Calavera?');
           writeln;
           writeln(' No pueden ser 1,5,6,9,12,14,18,23,27, ni la de la Posada');
           write(' ');
           readln(cala)

     UNTIL (IOResult = 0) and (cala > 1) and (cala <> 5) and (cala <> 6)
     and (cala <> 9) and (cala <> 12) and (cala <> 14 ) and (cala <> 18 )
     and (cala <> 23 ) and (cala < 27 ) and  (cala <> posa);
         writeln;
         PasoAPaso
     {$I+}

end;

Procedure Pinta(cas,posadas:integer);

{Pinta casillas}

Begin
        textcolor(Verde);
        writeln;

        If cas < 10 then
        begin
                writeln('     _______ ');
                writeln('    |',cas,'      |');
                writeln('    |       |');
                If (cas = 5) or (cas = 9) then
                writeln('    | OCA   |')
                else if (cas = puente6) then
                writeln('    |PUENTE |')
                else if (cas = posadas) then
                writeln('    |POSADA |')
                Else
                writeln('    |       |');
                writeln('    |_______|');
        end;

        If cas > 9 then
        begin
                writeln('     _______ ');
                writeln('    |',cas,'     |');
                writeln('    |       |');
                If (cas = 14) or (cas = 18) or (cas = 23) then
                writeln('    | OCA   |')
                else  if (cas = puente12) then
                writeln('    |PUENTE |')
                else if (cas = posadas) then
                writeln('    |POSADA |')
                Else if (cas = 27) then
                writeln('    |  META |')
                Else
                writeln('    |       |');
                writeln('    |_______|');
                writeln;
        end;

        PasoAPaso

End;


Procedure DibujaTablero;

{Muestra por pantalla el tablero de la oca}

Begin
        clrscr;
        textcolor(Rosa);
        writeln('              ----------*************----------');
        writeln('                      TABLERO DE LA OCA        ');
        writeln('              ----------*************----------');

        textcolor(Blanco);
        writeln;
        writeln('   _______  _______  _______  _______  _______  _______  _______ ');

        write('  |17     ||16     ||15     ||');textbackground(Morado);
        TextColor(Amarillo);write('14     ');textColor(Blanco);
        textbackground(Negro);write('||13     ||');
        textbackground(AzulClaro);textcolor(Amarillo);
        write('12     ');textbackground(Negro);textcolor(Blanco);
        writeln('||11     |');

        write('  |       ||       ||       ||');textbackground(Morado);
        write('       ');textColor(Blanco);textbackground(Negro);
        write('||       ||');textbackground(AzulClaro);write('       ');
        textbackground(Negro);writeln('||       |');

        write('  |       ||       ||       ||');textbackground(Morado);
        TextColor(Amarillo);write('  OCA  ');textColor(Blanco);
        textbackground(Negro);write('||       ||');
        textbackground(AzulClaro);textcolor(Amarillo);write('PUENTE ');
        textbackground(Negro);textcolor(Blanco);writeln('||       |');

        write('  |_______||_______||_______||');textbackground(Morado);
        write('_______');textbackground(Negro);write('||_______||');
        textbackground(AzulClaro);write('_______');textbackground(Negro);
        writeln('||_______|');

        writeln('   _______                    _______  _______           _______ ');

        write('  |');textbackground(Morado);TextColor(Amarillo);write('18     ');
        textcolor(Blanco);textbackground(Negro);write('|');
        writeln('                  |27     ||26     |         |10     |');

        write('  |');textbackground(Morado);write('       ');textbackground(Negro);
        writeln('|                  |       ||       |         |       |');

        write('  |');textbackground(Morado);TextColor(Amarillo);
        write('  OCA  ');textbackground(Negro);TextColor(Blanco);
        writeln('|                  |  META ||       |         |       |');

        write('  |');textbackground(Morado);write('_______');textbackground(Negro);
        writeln('|                  |_______||_______|         |_______|');

        writeln('   _______                             _______           _______ ');

        write('  |19     |                           |25     |         |');
        textbackground(Morado);textcolor(Amarillo);write('9      ');
        textbackground(Negro);TextColor(Blanco);writeln('|');

        write('  |       |                           |       |         |');
        textbackground(Morado);write('       ');textbackground(Negro);writeln('|');

        write('  |       |                           |       |         |');
        textbackground(Morado);TextColor(Amarillo);write('  OCA  ');textbackground(Negro);
        Textcolor(Blanco);writeln('|');

        write('  |_______|                           |_______|         |');
        textbackground(Morado);write('_______');textbackground(Negro);writeln('|');

        writeln('   _______  _______  _______  _______  _______           _______ ');

        write('  |20     ||21     ||22     ||');textbackground(Morado);textcolor(Amarillo);
        write('23     ');textbackground(Negro);textcolor(Blanco);writeln('||24     |         |8      |');

        write('  |       ||       ||       ||');textbackground(Morado);write('       ');
        textbackground(Negro);writeln('||       |         |       |');

        write('  |       ||       ||       ||');textbackground(Morado);textcolor(Amarillo);
        write('  OCA  ');textbackground(Negro);textcolor(Blanco);writeln('||       |         |       |');

        write('  |_______||_______||_______||');textbackground(Morado);
        write('_______');textbackground(Negro);writeln('||_______|         |_______|');
        writeln('                                                         _______');
        writeln('                                                        |7      |');
        writeln('                                                        |       |');
        writeln('                                                        |       |');
        writeln('                                                        |_______|');
        writeln('   _______  _______  _______  _______  _______  _______  _______ ');

        write('  |0      ||1      ||2      ||3      ||4      ||');textbackground(Morado);
        textcolor(Amarillo); write('5      ');textbackground(Negro);textcolor(Blanco);
        write('||');textbackground(AzulClaro);textcolor(Amarillo);write('6      ');
        textbackground(Negro);textcolor(Blanco);writeln('|');

        write('  |       ||       ||       ||       ||       ||');textbackground(Morado);
        write('       ');textbackground(Negro);write('||');textbackground(AzulClaro);
        write('       ');textbackground(Negro);writeln('|');

        write('  | Inicio||       ||       ||       ||       ||');
        textbackground(Morado);textcolor(Amarillo);write('  OCA  ');
        textbackground(Negro);textcolor(Blanco);write('||');textbackground(AzulClaro);
        textcolor(Amarillo);write('PUENTE ');textcolor(Blanco);textbackground(Negro);
        writeln('|');

        write('  |_______||_______||_______||_______||_______||');textbackground(Morado);
        write('_______');textbackground(Negro);write('||');textbackground(AzulClaro);
        write('_______');textbackground(Negro);writeln('|');


        PasoAPaso

end;

Procedure Tira(var cnt:integer);

{Se saca aleatoriamente el numero de un dado y lo va almacenando en
un contador que va guardando la posicion actual del usuario y de la
maquina}

Var

        dad:integer;

Begin

        textColor(Verde);
        writeln;
        dad:=Random(6)+1;
        writeln;
        writeln('  Has sacado un ', dad);
        writeln;
        cnt:=cnt+dad;
        PasoAPaso;
        DibujaTablero;
        writeln
end;

Procedure Calavera (var c1,ca1:integer);

{Se muestra por pantalla la casilla especial de la calavera}

BEGIN

If (c1 = ca1) then

        begin
                textcolor(Dorado+128);
                c1:=1;
                writeln;
                write('  Has caido en la calavera, retrocedes a la casilla ');
                writeln('numero 1');
                textcolor(Verde);
                If (ca1 < 10) then
                begin
                        writeln('     _______        _______    ');
                        writeln('    |',c1,'      |      |',ca1,'      |   ');
                        writeln('    |       | <--- |CALA   |   ');
                        writeln('    |       |      |  VERA |   ');
                        writeln('    |_______|      |_______|   ');
                        writeln;
                end;

                If (ca1 > 9) then
                begin
                        writeln('     _______        _______    ');
                        writeln('    |',c1,'      |      |',ca1,'     |   ');
                        writeln('    |       | <--- |CALA   |   ');
                        writeln('    |       |      |  VERA |   ');
                        writeln('    |_______|      |_______|   ');
                        writeln
                end;
         PasoAPaso;
        end
END;

Procedure Oca(var c,po:integer);

{Se muestra por pantalla las casillas especiales de la oca}

BEGIN

        CASE c OF

        5,9,14,18,23: begin
                textcolor(Verde);
                writeln('  Has caido en la casilla ',c);
                Pinta(c,po);
                textcolor(Dorado+128);
                writeln;
                writeln(' Has caido en una oca');
                writeln(' De oca a oca ');
                Pinta(c,po);
                If (c = 5) then c:=9
                Else If (c = 9) then c:=14
                Else IF (c =14) then c:=18
                Else If (c =18) then c:=23
                Else If (c = 23) then c:=27;
                textcolor(Verde);
                writeln('        |    ');
                writeln('        |    ');
                writeln('        v    ');
                Pinta(c,po);
                writeln;
                If (c = 9) or (c = 14) or (c =18) or (c = 23) then
                begin
                textcolor(Dorado+128);
                writeln('             Tiras de nuevo');
                PasoAPaso;
                Tira(c);
                        If (c = 14) or (c = 18) or (c = 23) then
                           begin
                           textcolor(Verde);
                           writeln('  Has caido en la casilla ',c);
                           Pinta(c,po);
                           textcolor(Dorado+128);
                           writeln;
                           writeln(' Has caido en una oca');
                           writeln(' De oca a oca ');
                           Pinta(c,po);
                           IF (c =14) then c:=18
                           Else If (c =18) then c:=23
                           Else If (c = 23) then c:=27;
                           textcolor(Verde);
                           writeln('        |    ');
                           writeln('        |    ');
                           writeln('        v    ');
                           Pinta(c,po);
                           writeln;
                           If (c = 14) or (c =18) or (c = 23) then
                              begin
                              textcolor(Dorado+128);
                              writeln('             Tiras de nuevo');
                              PasoAPaso;
                              Tira(c);
                              If (c = 23) then
                                 begin
                                 textcolor(Verde);
                                 writeln('  Has caido en la casilla ',c);
                                 Pinta(c,po);
                                 textcolor(Dorado+128);
                                 writeln;
                                 writeln(' Has caido en una oca');
                                 writeln(' De oca a oca ');
                                 Pinta(c,po);
                                 If (c = 23) then c:=27;
                                 textcolor(Verde);
                                 writeln('        |    ');
                                 writeln('        |    ');
                                 writeln('        v    ');
                                 Pinta(c,po);
                                 writeln;
                                 PasoAPaso;
                                 end;
                              end;
                        end;
                end;
              end;
        end
END;

Procedure DibujaCasilla(var cont,pos,calav:integer);

{Se dibuja varias casillas y el jardin de la oca}

BEGIN

        Case cont of

        puente6,puente12: begin
                textcolor(Verde);
                writeln('  Has caido en la casilla ',cont);
                Pinta(cont,pos);
                textcolor(Dorado+128);
                writeln;
                writeln(' Has caido en un puente, eso te lleva a la posada');
                If cont = 6 then
                        Pinta(cont,pos);
                If cont = 12 then
                        Pinta(cont,pos);
                cont:=pos;
                If cont < 10 then
                begin
                        textcolor(Verde);
                        writeln('        |    ');
                        writeln('        |    ');
                        writeln('        v    ');
                        Pinta(cont,pos);
                        writeln;
                        textcolor(Dorado+128);
                        writeln(' Has caido en la posada, pierdes un turno ');
                        PasoAPaso;
                        writeln;
                end;
                If cont > 9 then
                begin
                        textcolor(Verde);
                        writeln('        |    ');
                        writeln('        |    ');
                        writeln('        v    ');
                        Pinta(cont,pos);
                        writeln;
                        textcolor(Dorado+128);
                        writeln(' Has caido en la posada, pierdes un turno ');
                        PasoAPaso;
                        writeln
                end
                end;
        1,2,3,4,7,8: begin
                textColor(Verde);
                writeln(' Has caido en la casilla ',cont);
                Pinta(cont,pos);
                If (cont = pos) then
                begin
                        textcolor(Dorado+128);
                        writeln;
                        writeln(' Has caido en la posada, pierdes un turno ');
                        PasoAPaso;
                        writeln;
                end;
                If (cont = calav) then
                Calavera(cont,calav);
                end;

        10,11,13,15,16,17,19,20,21,22,24,25,26,27: begin
                textColor(Verde);
                writeln(' Has caido en la casilla ',cont);
                Pinta(cont,pos);
                If (cont = pos) then
                begin
                        textcolor(Dorado+128);
                        writeln;
                        writeln(' Has caido en la posada, pierdes un turno ');
                        PasoAPaso;
                        writeln;
                end;
                If (cont = calav) then
                Calavera(cont,calav);
                end;

        28,29,30,31,32: Begin
                textcolor(Dorado+128);
                If (cont = 28) then
                   begin
                        cont:= 26;
                        writeln('  Retrocedes hasta la casilla 26');
                        Calavera(cont,calav);
                        Pinta(cont,pos);
                   end;
                If (cont = 29) then
                   begin
                        cont:= 25;
                        writeln('  Retrocedes hasta la casilla 25');
                        Calavera(cont,calav);
                        Pinta(cont,pos);
                   end;
                If (cont = 30) then
                   begin
                        cont:= 24;
                        writeln('  Retrocedes hasta la casilla 24');
                        Calavera(cont,calav);
                        Pinta(cont,pos);
                   end;
                If (cont = 31) then
                   begin
                        cont:= 23;
                        writeln('  Retrocedes hasta la casilla 23');
                        Calavera(cont,calav);
                        Pinta(cont,pos);
                        Oca(cont,pos);
                   end;
                If (cont = 32) then
                   begin
                        cont:= 22;
                        writeln('  Retrocedes hasta la casilla 22');
                        Calavera(cont,calav);
                        Pinta(cont,pos);
                   end;

                If (cont = pos) then
                begin
                        textcolor(Dorado+128);
                        writeln;
                        writeln(' Has caido en la posada, pierdes un turno ');
                        writeln;
                        PasoAPaso;
                end;


                end;
        end

END;

Procedure CasillaActual(var ca,pa:integer);

{Muestra la posicion actual dibujando por pantalla la casilla}

Begin

        DibujaTablero;
        textColor(Verde);
        writeln;
        writeln('  La posicion actual es la casilla numero:');
        Pinta(ca,pa)

end;


Procedure TiradaUsuario (var cj,posad,calavera:integer);

{Turno de usuario y va entrando en los distintos procedimientos para que
muestre por pantalla todas las situaciones posibles}

Begin
        clrscr;
        textcolor(Azul);
        writeln;
        writeln(' TURNO DE USUARIO: ');
        Tira(cj);
        Oca(cj,posad);
        DibujaCasilla(cj,posad,calavera);
        CasillaActual(cj,posad)
end;

Procedure TiradaMaquina (var cm,posa,cala:integer);

{Turno de maquina y va entrando en los distintos procedimientos para que
muestre por pantalla todas las situaciones posibles}

Begin
        clrscr;
        textcolor(Rojo);
        writeln;
        writeln(' TURNO DE MAQUINA: ');
        Tira(cm);
        Oca(cm,posa);
        DibujaCasilla(cm,posa,cala);
        CasillaActual(cm,posa)
end;


Procedure CambioTurno(var cambj,cambm,cpos,ccal:integer);

{Se cambia de turno en el caso que usuario o maquina caiga en
casillas especiales que se pierde turno, como en el caso de la
posada}

Begin

        If (cambj <> 27) and (cambm <> 27) then
        Begin
                If (cambj=6) or (cambj=12) or (cambj=cpos) then
                   If (cambm <> 6) and (cambm <> 12) and (cambm <> cpos)
                      then TiradaMaquina(cambm,cpos,ccal);
                If (cambm=6) or (cambm=12) or (cambm=cpos) then
                             TiradaUsuario(cambj,cpos,ccal);

        end
end;

Procedure Gana(var gj,gm:integer);

{Muestra por pantalla el ganador del juego}

Begin
        textcolor(Blanco);
        If (gj = 27) or (gm = 27) then

        Begin
                writeln;
                writeln(' Felicidades has alcanzado la meta');
                If (gj =27) then
                writeln(' El usuario ha ganado la partida')
                Else if (gm = 27) then
                writeln(' La maquina ha ganado la partida');
                writeln;
                textcolor(Rosa);
                writeln('       -------***------- ');
                writeln('         FIN DE JUEGO    ');
                writeln('       -------***------- ');
                PasoAPaso;
        end

end;

{PROGRAMA PRINCIPAL}

VAR
        x,y,j,m:integer;

BEGIN

        clrscr;
        j:=0;
        m:=0;

        Randomize;
        writeln;
        textcolor(Rosa);
        writeln('              ----------*************----------');
        writeln('                BIENVENIDO AL JUEGO DE LA OCA  ');
        writeln('              ----------*************----------');
        writeln;
        PasoAPaso;
        DibujaTablero;
        writeln;
        textcolor(Rosa);
        writeln('  El usuario y la maquina comenzaran en la casilla 0 del tablero.');
        writeln('  El primero en tirar el dado sera el usuario y luego la maquina.');
        writeln('  El usuario elegira las casillas posada y calavera por teclado.');
        writeln('  El primero que alcance la casilla 27 sera el ganador.');
        writeln;
        PasoAPaso;
        PedirDatos(x,y);
        writeln;

REPEAT
      Begin
        TiradaUsuario(j,x,y);

        If (j<>27) then
         Begin
                TiradaMaquina(m,x,y);

                CambioTurno(j,m,x,y);

         end


      End

UNTIL (m=27) or (j=27);

        If (j = 27) then

           Gana(j,m);

        If (m = 27) then

        Gana(j,m)

END.
