Program JuegoOca;
{IMPORTANTE! El tablero se muestra al inicio del turno de cada jugador, por
lo que si el jugador cae en cualquier casilla especial, no ser mostrado
en el tablero hasta el inicio del turno del siguiente jugador
Cuando ambas fichas coinciden en una misma casilla esto se marca con una D}
 uses crt;
 Type

   tpdado=1..6;
   tptablero=array[0..27] of char;


 Function casillaoca(cas1:integer):boolean;
 {indica un valor verdadero si la casilla es oca}

   Begin
     if (cas1=5) or (cas1=9) or (cas1=14) or  (cas1=18)
     or (cas1=23) then casillaoca:=true
     else casillaoca:=false;
   end;


 Function casillapuente(cas2:integer):boolean;
  {indica un valor verdadero si la casilla es puente}

   Begin
     if (cas2=6) or (cas2=12) then casillapuente:=true
     else casillapuente:=false;
   end;


 Function casillabuena(cas3:integer):boolean;
  {indica un valor verdadero si la casilla no es oca,puente
  y esta dentro del tablero}

   Begin
     if (cas3>1) and (cas3<27)
     and not casillaoca(cas3) and not casillapuente(cas3)
     then casillabuena:= true
     else casillabuena:=false;
   end;


 Procedure tirardado(var pos:integer; var ddo:tpdado; Jug:string);
 {le dice al jugador que tire el dado y suma su posicin
 actual el resultado del dado}

  var
   tirada:char;

  begin
    if Jug='JUGADOR' then
     begin
      repeat

        writeln('Pulse la tecla "d" para tirar el dado ',Jug);
        {$I-}
        readln(tirada);
        {$I+}
      until (tirada='d') and (IOResult=0);
     end

    else
     begin
      repeat
        writeln('Pulse la tecla "d" para tirar el dado la ',Jug);
        {$I-}
        readln(tirada);
        {$I+}
        writeln('La maquina ha tirado el dado');
      until (tirada='d') and (IOResult=0);
     end;

  ddo:=random(6)+1;
  writeln('Ha salido un ', ddo);
  pos:=pos+ddo;

  end;


 procedure reiniciardibujo(dib:tptablero);
 {reinicia las valores de las casillas del tablero}

  var
  j:integer;

  begin
   for j:=1 to 27 do dib[j]:=' ';
  end;



 procedure dibujo(c1,c2:integer; db:tptablero);
 {es el procedimiento que se encargade realizar el dibujo del tablero
 y las fichas.Dentro de el se llama al procedimento reiniciardibujo }

  begin

  reiniciardibujo(db);
  db[c1]:='J';
  db[c2]:='M';
  if c1=c2 then db[c1]:='D';
  writeln(' ------------------------------------ ');
  write('| ',db[13],'   | ',db[12],'   | ',db[11],'   |');
  writeln(' ',db[10],'   | ',db[9],'   | ',db[8],'   |');
  write('|   13|   ');
  Textcolor(blue);
  write('12');
  NORMVIDEO;
  write('|   11|');
  write('   10|    ');
  Textcolor(green);
  write('9');
  NORMVIDEO;
  writeln('|    8|');
  writeln(' ------------------------------------ ');
  write('| ',db[14],'   | ',db[25],'   | ',db[24],'   |');
  writeln(' ',db[23],'   | ',db[22],'   | ',db[7],'   |');
  write('|   ');
  Textcolor(green);
  write('14');
  NORMVIDEO;
  write('|   25|   24|');
  write('   ');
  Textcolor(green);
  write('23');
  NORMVIDEO;
  writeln('|   22|    7|');
  writeln(' ------------------------------------ ');
  write('| ',db[15],'   | ',db[26],'   |       ');
  writeln(' ',db[27],'  | ',db[21],'   | ',db[6],'   |');
  write('|   15|   26|      ');
  write('   27|   21|    ');
  Textcolor(blue);
  write('6');
  NORMVIDEO;
  writeln('|');
  writeln(' ------------------------------------ ');
  write('| ',db[16],'   | ',db[17],'   | ',db[18],'   |');
  writeln(' ',db[19],'   | ',db[20],'   | ',db[5],'   |');
  write('|   16|   17|   ');
  Textcolor(green);
  write('18');
  NORMVIDEO;
  write('|');
  write('   19|   20|    ');
  Textcolor(green);
  write('5');
  NORMVIDEO;
  writeln('|');
  writeln(' ------------------------------------ ');
  write('|             ',db[1],'   |');
  writeln(' ',db[2],'   | ',db[3],'   | ',db[4],'   |');
  write('|                1|');
  writeln('    2|    3|    4|');
  writeln(' ------------------------------------ ');
  end;

 procedure movimiento(var posicion1,posicion2:integer; var win,pt:boolean;
 pos,cal:integer; Jug1,Jug2:string; dd:tpdado);
 {se encarga de comprobar si la posicin en la que est el jugador
 es especial y realiza la accin correspondiente de esa casilla.
 Es uno de los procedimentos mas importante ya que se encarga del movimiento
 y los calculos}

  begin
  {nos indica lo que ocurre cuando sacamos un numero que haria a nuestra
  posicion mayor que 27}
  if (posicion1>27) then
     posicion1:=27-(posicion1-27);
  writeln(Jug1,' ha movido a la casilla ',posicion1);
  writeln(Jug2,' esta en la casilla ',posicion2);
  {esto es lo que ocurre si caemos en la casillas ocas}
  while casillaoca(posicion1) do
     begin
       case posicion1 of
        5:posicion1:=9;
        9:posicion1:=14;
       14:posicion1:=18;
       18:posicion1:=23;
       23:posicion1:=27;
       end;
       writeln(Jug1, ' ha saltado a la casilla ', posicion1);
       writeln;

       if posicion1<>27 then
         begin
         writeln('De oca a oca y tira porque t toca');
         writeln;
         tirardado(posicion1,dd,Jug1);
         end;

       if (posicion1>27) then posicion1:=27-(posicion1-27);
       writeln(Jug1, ' ha movido a la casilla ', posicion1);
       writeln(Jug2, ' esta en la casilla ', posicion2);

       if posicion1=27 then writeln('De oca a Jardin de la Oca');

    end;

   if posicion1=27 then win:=true;

   if posicion1=cal then
     begin
      write(Jug1, ' ha movido a la casilla calavera ',cal);
      posicion1:=1;
      writeln(' y retrocede a la casilla ',posicion1);
      writeln(Jug2,' esta en la casilla ',posicion2);
     end;
   {indica lo que hace en caso de caer en puente}
   if casillapuente(posicion1) then
     begin
      writeln(Jug1,' ha movido a la casilla puente ',posicion1);
      posicion1:=pos;
      writeln(' y avanza a la casilla posada ',pos);
      writeln(Jug2,' esta en la casilla ',posicion2);
     end;

   if posicion1=pos then
     begin
      write(Jug1,' esta en la casilla ',pos,' que es posada');
      writeln(' y pierde un turno');
      pt:=true;
     end;

 end;



  procedure preguntaposada(var pda:integer); { Se encarga de pedir al usuario que
  que colocque la casilla posada y compruba que se encuentra por delante de la
  casilla 12 y no sea una casilla especial}

  begin
    {$I-}

   repeat

    writeln('Indica la posicin de la casilla posada');
    readln(pda);
   until IOResult=0;

   if (pda<=12) or not casillabuena(pda) then
     Begin
      repeat
      TextColor(red);
       write('Posicin incorrecta. ');
       writeln('Introduzca otra posicion para la casilla posada');
       readln(pda);
       NORMVIDEO;
      until (IOResult=0) and (pda>12) and casillabuena(pda);
     end;
    {$I+}

  end;

 procedure preguntacalavera(var clvr:integer; psd:integer);
 {pregunta al usuario donde quiere colocar la calavera y comprueba que no sea ninguna
 casilla especial ni posada}
  begin
    repeat
    {$I-}
     writeln('Indica la posicin de la casilla calavera');
     readln(clvr);
    until IOResult=0;
      {$I+}
    if (clvr=psd) or not casillabuena(clvr) then
      Begin
       repeat
        TextColor(red);
        write('Posicin incorrecta. ');
        writeln('Introduzca otra posicin para la casilla calavera');
        {$I-}
        readln(clvr);
        {$I+}
        NORMVIDEO;
       until (clvr<>psd) and casillabuena(clvr) and (IOResult=0);
     End;

  End;


   {comminenza el programa principal en el se va llamando a los procedimientos
   y funciones anteriores hasta que el usuario o la maquina ganan entonces
   termina la partida}
 Var

  tablero:tptablero;
  posada,calavera,usuario,maquina:integer;
  J,PC:string;
  ganar,pierdeturnoJ,pierdeturnoPC:boolean;
  dado:tpdado;
  resp:char;
  i,n:integer;

 Begin

  repeat

  usuario:=0;
  maquina:=0;
  J:='JUGADOR';
  PC:='MAQUINA';
  ganar:=false;
  randomize;
  i:=0;
  n:=0;

  preguntaposada(posada);
  preguntacalavera(calavera,posada);

  while not ganar do
    begin
     if (i=2) or (i=0) then pierdeturnoJ:=false;
     if not pierdeturnoJ then begin
     writeln;
     writeln('TURNO',J);
     dibujo(usuario,maquina,tablero);
     tirardado(usuario,dado,J);
     movimiento(usuario,maquina,ganar,pierdeturnoJ,posada,calavera,J,PC,dado);
     if pierdeturnoPC then n:=n+1;
    end;
    if pierdeturnoJ
    then n:=0;
    if not ganar  then
     begin
      if (n=2) or (n=0) then pierdeturnoPC:=false;
      if not pierdeturnoPC then
       begin
        writeln;
        writeln('TURNO',PC);
        dibujo(usuario,maquina,tablero);
        tirardado(maquina,dado,PC);
        movimiento(maquina,usuario,ganar,pierdeturnoPC,posada,calavera,PC,J,dado);
        if pierdeturnoJ
        then i:=i+1;
       end;
     if pierdeturnoPC then i:=0;
    end;

 end;

 writeln;
 dibujo(usuario,maquina,tablero);

 if (usuario=27)
 then writeln('Ha ganado !!!',J)
 else writeln('Ha ganado la ',PC);
 writeln('Desea echar otra partida? Pulse "s" en caso afirmativo');
 {$I-}
 readln(resp);
 {$I+}
 {ofrece al usuario la posibilidad de hechar otra partida}

 until (resp<>'s') and (IOResult=0);

 End.

