
PROGRAM OCA;

uses crt;

CONST
oca1=5;
oca2=9;
oca3=14;
oca4=18;
oca5=23;
puente1=6;
puente2=12;
jardin=27;


procedure presentacion;
begin
 writeln('-- Bienvenido al JUEGO DE LA OCA --');
 writeln;writeln;
 write('Es una versin para dos jugadores (usuario y mquina). ');
 write('Se usa un tablero de 27 casillas. ');
 write('La posicin de inicio es la casilla 0. Tiran el dado por orden ');
 write('(primero el usuario), cada jugador avanzar tantas posiciones ');
 write('como indique el dado a excepcin de las casillas especiales, ');
 writeln('que se tendrn en cuenta a lo largo de la partida.');

end;


{asigna de manera robusta el valor elegido por el usuario a la casilla posada}
procedure pedir_posada(var posada:integer);
 begin
 {$I-}
  writeln; writeln;
  writeln('Elige la casilla para la posada, un nmero entre 13 y 26 inclusive,');
  writeln('excepto los nmeros 14, 18 y 23');
  readln(posada);
  while (IOResult<>0)or(posada<13)or(posada=oca3)
        or(posada=oca4)or(posada=oca5)or(posada>=jardin)do
   begin
   writeln;
   writeln('Error: elige un numero entre 13 y 26 inclusive,');
   writeln('excepto los numeros 14, 18 y 23');
   readln(posada);
   end;
 {$I+}
 end;



{asigna de manera robusta el valor elegido por el usuario a la casilla}
{calavera teniedo en cuenta la posicion de la posada}
procedure pedir_calavera(posada:integer; var calavera:integer);
 begin
 {$I-}
  writeln; writeln;
  writeln('Elige la casilla para la calavera, un nmero entre 2 y 26 inclusive,');
  writeln('excepto los nmeros 5, 6, 12, 9, 14, 18, 23 y ',posada);
  readln(calavera);
  while (IOResult<>0)or(calavera<2)or(calavera=oca1)or(calavera=puente1)
        or(calavera=oca2)or(calavera=puente2)or(calavera=oca3)
        or(calavera=oca4)or(calavera=oca5)or(calavera>=jardin)
        or(calavera=posada)do
   begin
   writeln;
   writeln('Error: elige un nmero entre 2 y 26 inclusive,');
   writeln('excepto los nmeros 5, 6, 12, 9, 14, 18, 23 y ',posada);
   readln(calavera);
   end;
 {$I+}
 end;



{calcula un numero aleatorio del 1 al 6}
function dado (n:integer):integer;
begin
  n:=random(6);
  dado:=n+1;
end;



{Procedimiento que indica el resultado de la tirada del dado
para cada jugador y calcula su posicin posterior}
procedure tirada(var pos:integer);
 var
  n,d:integer;
begin
  writeln; writeln;
  writeln('Presione enter para tirar el dado.');
  readln;
  d:=dado(n);
  writeln('Resultado tirada: ',d);
  pos:=pos+d;
  if pos>27 then
   pos:=27-(pos-27);
 end;



{si el turno es el del jugador le asignamos a opcion, jugador, y turno
 es true, si es de maquina ocurre analoga y opuestamente}
 function turno(var opcion:string):boolean;
 begin
  turno:= opcion= ('jugador');
 end;



{contiene las posibles respuestas del juego, cuando gana o pierde el usuario}
 procedure info_fin(var opcion :string);
 begin
  if turno(opcion)=false then
   writeln('Jardn. Es una lstima, has perdido :-(') else
   writeln('Jardn,enhorabuena, has ganado!!!;-)')
 end;



 {muestra la posicion posterior a la tirada y, escribe
 en caso de caer en casilla especial, las consecuencias.}
 procedure informacion(opcion:string;pos,c,p:integer);
 begin
 writeln; writeln;
 write('Cae en la casilla: ',pos,'.  ');
 if pos=c then writeln('Casilla calavera. vuelve a la casilla 1.') else
  if pos=p then writeln('Casilla posada. pierde un turno.') else
  case pos of
  oca1, oca2, oca3, oca4:writeln('De oca a oca y tira porque le toca!!');
  puente1,puente2: writeln('Puente, pasa un turno en la posada.');
  oca5:
  begin
  write('De oca a oca->');
  info_fin(opcion)
  end;
  jardin: info_fin(opcion)
  end
 end;



{actualiza la posicion en caso de alcanzar una casilla especial}
procedure casilla(var pos:integer; c,p:integer);
 begin
  if pos=c then pos:=1 else
   case pos of
   oca1, oca3, oca5:pos:=pos+4;
   oca2, oca4:pos:=pos+5;
   puente1,puente2:pos:=p;
   end;
 end;



{establece el color de las casillas especiales en el numero de casilla
correspondiente}
procedure color(var i:integer;c,p:integer);
 begin
  if i=c then textcolor(14) else
   if i=p then textcolor(4)else
   case i of
    oca1, oca2, oca3, oca4, oca5,jardin:textcolor(2);
    puente1,puente2:textcolor(9)
   else textcolor(15)
   end
 end;



{Procedimiento que pinta el tablero y la posicion en l, de los jugadores
en cada turno; contiene una pequea leyenda para distinguir los colores de
cada casilla especial y el simbolo de cada jugador }
procedure tablero(j,m,c,p:integer);
var
h,i,x:integer;
begin
 x:=0;
 writeln;writeln;
 textcolor(2); write('   OCA   '); textcolor(9);write('   PUENTE   ');
 textcolor(4);write('   POSADA   ');textcolor(14);writeln('   CALAVERA   ');
 textcolor(15);
 writeln;writeln('******************JUGADOR(J)-MAQUINA(M)******************');

 writeln;writeln;
 for h:=0 to 3 do
  begin
   for i:=x to x+6 do
    begin
     if i<10 then write(' ');
     {sirve para alinear las columnas en las que i no tiene decenas}
     if (i=j)and(i=m) then
      begin
       color(i,c,p); write('|',i,'(J)(M)|')
      end
      else
       if i=j then
        begin
         color(i,c,p); write('|',i,'(J)|   ')
        end
        else
        if i=m then
         begin
          color(i,c,p); write('|',i,'(M)|   ')
         end
         else
          begin
           color(i,c,p); write('|',i,'|      ')
           end;

     textcolor(15)
    end;
   x:=x+7;
   writeln;writeln
  end
end;


{Procedimiento que cacula el cambio de turno a lo largo de la
partida, teniendo en cuenta las variaciones de este en las
casillas especiales}


procedure cambio_turno(var t:string; pos,p:integer);
 begin
  if t='repetir_turno' then t:='cambio_turno'
   else
   if t='perder_turno' then  t:='repetir_turno'
    else
    if(pos=p)then t:='perder_turno'
     else
     if(pos=oca1)or(pos=oca2)or(pos=oca3)or(pos=oca4)or(pos=oca5)then
       t:='repetir_turno'
 end;



{Declaracin de variables del programa principal}
VAR
 posada,calavera,pos_jugador,pos_maquina: integer;
 t,opcion: string;

{Inicio del programa principal}

BEGIN

 randomize;
 t:='cambio_turno';{para que empiece el jugador}
 pos_jugador:=0;
 pos_maquina:=0;
 calavera:=28;   {<-inciados en valores imposibles para evitar la asignacion}
 posada:=29;       {0 por defecto y le de el color amarillo a la casilla 0  }
 writeln;writeln;  { al pintar el tablero por primera vez.                  }
 presentacion;
 tablero(pos_jugador,pos_maquina,calavera,posada);
 pedir_posada(posada);
 pedir_calavera(posada, calavera);
 clrscr;
  repeat

   begin
    cambio_turno(t,pos_maquina,posada);
    if(t='perder_turno')or(t='cambio_turno')then
     {<-regula si se ejecuta el turno del jugador(posteriormente
     de la maquina) segun el cambio de turno asignado a t}

     begin
      opcion:='jugador';
      writeln('                    - ES TU TURNO -');
      tirada(pos_jugador);
      informacion(opcion,pos_jugador,calavera,posada);
      casilla(pos_jugador,calavera,posada);
      tablero(pos_jugador,pos_maquina,calavera,posada);
      readln;
      clrscr
     end;

    cambio_turno(t,pos_jugador,posada);
     if((t='perder_turno')or(t='cambio_turno'))and(pos_jugador<>27)then
       begin
        opcion:='maquina';
        writeln; writeln; writeln('              - ES TURNO DE LA MAQUINA -');
        tirada(pos_maquina);
        informacion(opcion,pos_maquina,calavera,posada);
        casilla(pos_maquina,calavera,posada);
        tablero(pos_jugador,pos_maquina,calavera,posada);
        readln;
        clrscr
       end;
   end;
  until (pos_maquina=27)or(pos_jugador=27)
END.