PROGRAM Juego_de_la_Oca;

USES CRT;

CONST
     turnojugador='A';  turnomaquina='B';
     casillapuente1=6;  casillapuente2=12;
     casillaoca1=5;     casillaoca2=9;
     casillaoca3=14;    casillaoca4=18;
     casillaoca5=23;    jardinoca=27;


{PROCEDIMIENTO QUE SE ENCARGA DE DAR UN NUMERO ALEATORIO ENTRE 1 Y 6}
PROCEDURE LanzarDado (VAR numerodado:integer);
BEGIN
     numerodado:=random(6)+1;
     writeln(numerodado);
END;

{PROCEDIMIENTO QUE REALIZA LA SUMA DEL DADO Y RETROCEDE LA FICHA
EN CASO QUE EXCEDA LA TIRADA PARA LLEGAR AL JARDIN DE LA OCA}
PROCEDURE SumarPuntuacion (turno:char; numerodado:integer; VAR jugador1, maquina:integer);
VAR
   contador:integer;

BEGIN
     IF turno=turnojugador THEN
        BEGIN
             contador:=numerodado;
             jugador1:=jugador1+contador;
             IF (jugador1>jardinoca) THEN jugador1:=54-jugador1;
        END

     ELSE
         BEGIN
              contador:=numerodado;
              maquina:=maquina+contador;
              IF (maquina>jardinoca) THEN maquina:=54-maquina;
         END;
END;

{PROCEDIMIENTO QUE COMPRUEBA LA SITUACION DE CADA JUGADOR Y CAMBIA EL TURNO
SEGUN EN QUE CASILLAS HAYAN CAIDO}
PROCEDURE CambioTurno (casillaposada, jugador1, maquina:integer; VAR repeticion:integer; VAR turnodoble, turnooca:boolean;
                       VAR turno:char);

BEGIN
     IF (turno=turnojugador) AND (turnodoble=false) AND (turnooca=false)
     THEN turno:=turnomaquina

     ELSE IF (turno=turnomaquina) AND (turnodoble=false) AND (turnooca=false)
          THEN turno:=turnojugador

     ELSE IF (turno=turnojugador) AND (turnooca=true) AND (turnodoble=false)
     THEN
         BEGIN
              turno:=turnojugador;
              turnooca:=false;
         END

     ELSE IF (turno=turnomaquina) AND (turnooca=true) AND (turnodoble=false)
     THEN
         BEGIN
              turno:=turnomaquina;
              turnooca:=false;
         END

     ELSE IF (turno=turnojugador) AND (turnodoble=true) AND NOT (maquina=casillaposada)
     THEN turno:=turnomaquina

     ELSE IF (turno=turnomaquina) AND (turnodoble=true) AND NOT (maquina=casillaposada) AND (turnooca=false)
              AND NOT (repeticion=1)
          THEN
              BEGIN
                   turno:=turnomaquina;
                   repeticion:=1;
              END

     ELSE IF (turno=turnomaquina) AND (turnodoble=true) AND (repeticion=1)
          THEN
              BEGIN
                   turnodoble:=false;
                   turno:=turnojugador;
                   repeticion:=0;
              END

     ELSE IF (turno=turnomaquina) AND (turnodoble=true) AND NOT (jugador1=casillaposada)
     THEN turno:=turnojugador

     ELSE IF (turno=turnojugador) AND (turnodoble=true) AND NOT (jugador1=casillaposada) AND (turnooca=false)
              AND NOT (repeticion=1)
          THEN
              BEGIN
                   turno:=turnojugador;
                   repeticion:=1;
              END

     ELSE IF (turno=turnojugador) AND (turnodoble=true) AND (repeticion=1)
          THEN
              BEGIN
                   turnodoble:=false;
                   turno:=turnomaquina;
                   repeticion:=0;
              END

     ELSE IF (turno=turnojugador) AND (jugador1=casillaposada) AND (turnodoble=true)
     THEN turno:=turnomaquina

     ELSE IF (turno=turnomaquina) AND (maquina=casillaposada) AND (turnodoble=true)
     THEN turno:=turnojugador

     ELSE IF (turno=turnojugador) AND (turnodoble=true) AND (turnooca=true)
     THEN
         BEGIN
              turno:=turnojugador;
              turnodoble:=false;
              turnooca:=false;
              repeticion:=0;
         END

     ELSE IF (turno=turnomaquina) AND (turnodoble=true) AND (turnooca=true)
     THEN
         BEGIN
              turno:=turnomaquina;
              turnodoble:=false;
              turnooca:=false;
              repeticion:=0;
         END;
END;


{PROCEDIMIENTO QUE DA A ELEGIR DONDE COLOCAR LA POSADA}
PROCEDURE ColocarPosada (VAR casillaposada:integer);
BEGIN
     {$I-}
     REPEAT
          writeln;
          write('La casilla "Posada" sera la numero: ');
          readln(casillaposada);

          IF (IOResult<>0) OR (casillaposada<=casillapuente2) OR (casillaposada=casillaoca3)
             OR (casillaposada=casillaoca4) OR (casillaposada=casillaoca5) OR (casillaposada>=jardinoca) THEN
                 BEGIN
                 writeln('El numero de casilla es incorrecto, introduzcalo de nuevo');
                 END;

     UNTIL (IOResult=0) AND (casillaposada>casillapuente2) AND (casillaposada<>casillaoca3) AND (casillaposada<>casillaoca4)
           AND (casillaposada<>casillaoca5) AND (casillaposada<jardinoca);
     {$I+}
END;

{PROCEDIMIENTO QUE DA A ELEGIR DONDE COLOCAR LA CALAVERA}
PROCEDURE ColocarCalavera (VAR casillacalavera, casillaposada:integer);
BEGIN
     {$I-}
     REPEAT
          writeln;
          write('La casilla "Calavera" sera la numero: ');
          readln(casillacalavera);

          IF (IOResult<>0) OR (casillacalavera=casillaposada) OR (casillacalavera<1)
             OR (casillacalavera=casillaoca1) OR (casillacalavera=casillapuente1) OR (casillacalavera=casillaoca2) OR
             (casillacalavera=casillapuente2) OR (casillacalavera=casillaoca3) OR (casillacalavera=casillaoca4) OR
             (casillacalavera=casillaoca5) OR (casillacalavera>=jardinoca) THEN

             writeln('El numero de casilla es incorrecto, introduzcalo de nuevo');

     UNTIL (IOResult=0) AND (casillacalavera<>casillaposada) AND (casillacalavera>=1)
          AND (casillacalavera<>casillaoca1) AND (casillacalavera<>casillapuente1) AND (casillacalavera<>casillaoca2) AND
          (casillacalavera<>casillapuente2) AND (casillacalavera<>casillaoca3) AND (casillacalavera<>casillaoca4) AND
          (casillacalavera<>casillaoca5) AND (casillacalavera<jardinoca);
     {$I+}
END;

{PROCEDIMIENTO QUE ACTUALIZA LAS POSICIONES DE LOS JUGADORES EN EL TABLERO}
PROCEDURE DibCas (casilla, casillaposada, casillacalavera, jugador1, maquina:integer);
BEGIN
     IF (jugador1=casilla) AND (maquina=casilla) THEN
        BEGIN
             NormVideo; TextColor(13); write('%  '); NormVideo;
        END

     ELSE IF (jugador1=casilla) THEN
          BEGIN
               NormVideo; TextColor(3); write('x  '); NormVideo;
          END

     ELSE IF (maquina=casilla) THEN
          BEGIN
               NormVideo; TextColor(4); write('o  '); NormVideo;
          END

     ELSE IF (casilla=casillaoca1) OR (casilla=casillaoca2) OR (casilla=casillaoca3) OR (casilla=casillaoca4)
              OR (casilla=casillaoca5) OR (casilla=jardinoca) THEN
          BEGIN
               NormVideo; TextColor(9); write('OCA'); NormVideo;
          END

     ELSE IF (casilla=casillapuente1) OR (casilla=casillapuente2) THEN
          BEGIN
               NormVideo; TextColor(6); write('PUE'); NormVideo;
          END

     ELSE IF (casilla=casillaposada) THEN
          BEGIN
               NormVideo; TextColor(14); write('POS'); NormVideo;
          END

     ELSE IF (casilla=casillacalavera) THEN
          BEGIN
               NormVideo; TextColor(8); write('CAL'); NormVideo;
          END

     ELSE IF (casilla<=casillaoca1) THEN write(casilla,'  ')
     ELSE write(casilla,' ');
END;

{PROCEDIMIENTO QUE MUESTRA EL TABLERO POR PANTALLA}
PROCEDURE MostrarTablero (casillaposada,casillacalavera,jugador1,maquina:integer);

VAR
   i:integer;

BEGIN
     NormVideo; TextColor(10);
     writeln('         +------+------+------+------+------+------+'); NormVideo;
     NormVideo; TextColor(10); write('         |   '); NormVideo;
     FOR i:=0 TO 5 DO
         BEGIN
              DibCas(i,casillaposada,casillacalavera,jugador1,maquina);
              NormVideo; TextColor(10); write('|   '); NormVideo;
         END;
     writeln;
     NormVideo; TextColor(10);
     writeln('         +------+------+------+------+------+------+'); NormVideo;
     NormVideo; TextColor(10);
     writeln('         +------+------+------+------+------+------+'); NormVideo;
     NormVideo; TextColor(10); write('         |   '); NormVideo;
     DibCas(11,casillaposada,casillacalavera,jugador1,maquina);
     NormVideo; TextColor(10); write('|   '); NormVideo;
     DibCas(10,casillaposada,casillacalavera,jugador1,maquina);
     NormVideo; TextColor(10); write('|   '); NormVideo;
     DibCas(9,casillaposada,casillacalavera,jugador1,maquina);
     NormVideo; TextColor(10); write('|    '); NormVideo;
     DibCas(8,casillaposada,casillacalavera,jugador1,maquina);
     NormVideo; TextColor(10);  write('|    '); NormVideo;
     DibCas(7,casillaposada,casillacalavera,jugador1,maquina);
     NormVideo; TextColor(10); write('|   '); NormVideo;
     DibCas(6,casillaposada,casillacalavera,jugador1,maquina);
     NormVideo; TextColor(10); write('|'); NormVideo;
     writeln;
     NormVideo; TextColor(10);
     writeln('         +------+------+------+------+------+------+'); NormVideo;
     NormVideo; TextColor(10);
     writeln('         +------+------+------+------+------+------+'); NormVideo;
     NormVideo; TextColor(10); write('         |   '); NormVideo;
     FOR i:=12 TO 17 DO
         BEGIN
              DibCas(i,casillaposada,casillacalavera,jugador1,maquina);
              NormVideo; TextColor(10); write('|   '); NormVideo;
         END;
     writeln;
     NormVideo; TextColor(10);
     writeln('         +------+------+------+------+------+------+'); NormVideo;
     NormVideo; TextColor(10);
     writeln('         +------+------+------+------+------+------+'); NormVideo;
     NormVideo; TextColor(10); write('         |   '); NormVideo;
     FOR i:=23 DOWNTO 18 DO
         BEGIN
              DibCas(i,casillaposada,casillacalavera,jugador1,maquina);
              NormVideo; TextColor(10); write('|   '); NormVideo;
         END;
     writeln;
     NormVideo; TextColor(10);
     writeln('         +------+------+------+------+------+------+'); NormVideo;
     NormVideo; TextColor(10);
     writeln('         +------+------+------+------+------+------+'); NormVideo;
     NormVideo; TextColor(10); write('         |   '); NormVideo;
     FOR i:=24 TO 25 DO
         BEGIN
              DibCas(i,casillaposada,casillacalavera,jugador1,maquina);
              NormVideo; TextColor(10); write('|   '); NormVideo;
         END;
     DibCas(26,casillaposada,casillacalavera,jugador1,maquina);
     NormVideo; TextColor(10); write('|         '); NormVideo;
     DibCas(27,casillaposada,casillacalavera,jugador1,maquina);
     NormVideo; TextColor(10); write('        |'); NormVideo;
     writeln;
     NormVideo; TextColor(10);
     writeln('         +------+------+------+------+------+------+'); NormVideo;
     NormVideo; TextColor(11);
     write('--------------------------------------------------------------------------------');
     NormVideo;
     writeln('LEYENDA:');
     NormVideo; TextColor(9); write('OCA'); NormVideo; write(': casillas "Oca"         ');
     NormVideo; TextColor(6); write('PUE'); NormVideo; writeln(': casillas "Puente"');
     NormVideo; TextColor(14); write('POS'); NormVideo; write(': casilla "Posada"       ');
     NormVideo; TextColor(8); write('CAL'); NormVideo; writeln(': casilla "Calavera"');
     NormVideo; TextColor(11);
     write('--------------------------------------------------------------------------------');
     NormVideo;
END;

{PROCEDIMIENTO QUE COMPRUEBA SI EL JUGADOR HA CAIDO EN UNA CASILLA OCA}
PROCEDURE CasillasOca (VAR jugador1, maquina:integer; VAR turnooca:boolean);
BEGIN
     IF (jugador1=casillaoca1) OR (jugador1=casillaoca3) THEN
        BEGIN
              jugador1:=jugador1+4;
              writeln('De oca a oca y tiro porque me toca');
              turnooca:=true;
        END

     ELSE IF (maquina=casillaoca1) OR (maquina=casillaoca3) THEN
             BEGIN
                 maquina:=maquina+4;
                 writeln('De oca a oca y tiro porque me toca');
                 turnooca:=true;
             END

     ELSE IF (jugador1=casillaoca2) OR (jugador1=casillaoca4) THEN
             BEGIN
                 jugador1:=jugador1+5;
                 writeln('De oca a oca y tiro porque me toca');
                 turnooca:=true;
             END

     ELSE IF (maquina=casillaoca2) OR (maquina=casillaoca4) THEN
             BEGIN
                 maquina:=maquina+5;
                 writeln('De oca a oca y tiro porque me toca');
                 turnooca:=true;
             END

     ELSE IF (jugador1=casillaoca5) THEN
             BEGIN
                 jugador1:=jardinoca;
                 writeln('De oca a oca y he llegado al "Jardin de la Oca"');
                 turnooca:=false;
             END

     ELSE IF (maquina=casillaoca5) THEN
             BEGIN
                 maquina:=jardinoca;
                 writeln('De oca a oca y he llegado al "Jardin de la Oca"');
                 turnooca:=false;
             END

     ELSE turnooca:=false;
END;

{PROCEDIMIENTO EN EL QUE COMPRUEBA SI EL JUGADOR HA CAIDO EN UNA CASILLA PUENTE}
PROCEDURE CasillasPuente (casillaposada:integer; turno:char; VAR jugador1, maquina:integer);
BEGIN
     IF ((jugador1=casillapuente1) OR (maquina=casillapuente1))
         OR ((jugador1=casillapuente2) OR (maquina=casillapuente2))
     THEN
         BEGIN
              IF (turno='A') THEN
              BEGIN
                   jugador1:=casillaposada;
                   writeln('Del puente te vas a la posada y un turno sin tirar');
              END

              ELSE
              BEGIN
                   maquina:=casillaposada;
                   writeln('Del puente te vas a la posada y un turno sin tirar');
              END;
         END;
END;

{PROCEDIMIENTO EN EL QUE COMPRUEBA SI EL JUGADOR HA CAIDO EN LA CASILLA POSADA}
PROCEDURE CaerPosada(casillaposada, jugador1, maquina:integer; turno:char; VAR turnodoble:boolean);
BEGIN
     IF (jugador1=casillaposada) THEN turnodoble:=true

     ELSE IF (maquina=casillaposada) THEN turnodoble:=true

     ELSE turnodoble:=false;
END;

{PROCEDIMIENTO EN EL QUE COMPRUEBA SI EL JUGADOR HA CAIDO EN LA CASILLA CALAVERA}
PROCEDURE CaerCalavera (casillacalavera:integer; VAR jugador1, maquina:integer);
BEGIN
     IF (jugador1=casillacalavera)
     THEN
         BEGIN
         write('Que mala suerte, has caido en la casilla de la calavera, ');
         writeln('vuelves a la casilla 1');
         jugador1:=1;
         END;

     IF (maquina=casillacalavera)
     THEN
         BEGIN
         write('Que mala suerte, has caido en la casilla de la calavera, ');
         writeln('vuelves a la casilla 1');
         maquina:=1;
         END;
END;

{PROCEDIMIENTO EN EL QUE SE REALIZA LA ELECCION DE LAS CASILLAS ESPECIALES Y MUESTRA EL TABLERO}
PROCEDURE PrimeraJugada (VAR jugador1, maquina, repeticion, casillaposada, casillacalavera:integer;
                         VAR turno:char);
BEGIN
     jugador1:=0; maquina:=0; repeticion:=0;
     turno:=turnojugador;
     writeln;
     writeln('                  --- BIENVENIDO AL JUEGO DE LA OCA ---');
     writeln;
     write('Jugador 1, elija donde desea colocar las casillas "Posada" y');
     writeln(' "Calavera"');
     write('en el tablero. Le recordamos que no se pueden');
     writeln(' colocar en las casillas');
     write('especiales y en el caso de la "Posada"');
     writeln(' sera posterior de las casillas');
     writeln('"Puente" (a partir de la casilla 12)');
     ColocarPosada(casillaposada);
     ColocarCalavera(casillacalavera,casillaposada);
     ClrScr;
     writeln;
     MostrarTablero(casillaposada,casillacalavera,jugador1,maquina);
     writeln('Pulse "Enter" para continuar el juego');
     readln;
     ClrScr;
     writeln;
END;

{PROCEDIMIENTO EN EL CUAL SE VAN SUCEDIENDO LAS JUGADAS}
PROCEDURE SiguientesJugadas (VAR jugador1, maquina, repeticion:integer; numerodado, casillaposada, casillacalavera:integer;
                             VAR turno:char; VAR turnodoble, turnooca:boolean);
BEGIN
     writeln;
     write('El dado muestra un '); LanzarDado(numerodado);
     writeln;
     writeln('Pulse "Enter" para continuar el juego');
     readln;
     ClrScr;
     writeln;
     SumarPuntuacion(turno,numerodado,jugador1,maquina);
     MostrarTablero(casillaposada,casillacalavera,jugador1,maquina);
     CasillasOca(jugador1,maquina,turnooca);
     CasillasPuente(casillaposada,turno,jugador1,maquina);
     CaerPosada(casillaposada,jugador1,maquina,turno,turnodoble);
     CaerCalavera(casillacalavera,jugador1,maquina);
     CambioTurno(casillaposada,jugador1,maquina,repeticion,turnodoble,turnooca,turno);
     writeln('Pulse "Enter" para continuar el juego');
     readln;
     ClrScr;
     writeln;
END;


VAR
   jugador1, maquina, contador, numerodado, repeticion:integer;
   casillaposada, casillacalavera:integer;
   turno:char;
   turnooca, turnodoble:boolean;

BEGIN
    randomize;
    PrimeraJugada(jugador1,maquina,repeticion,casillaposada,casillacalavera,turno);
    REPEAT
          IF turno=turnojugador THEN
             BEGIN
                  write('Juega el Jugador 1, tu ficha es:');
                  NormVideo; TextColor(3); writeln(' x'); NormVideo;
                  SiguientesJugadas(jugador1,maquina,repeticion,numerodado,casillaposada,casillacalavera,
                                    turno,turnodoble,turnooca);
             END

          ELSE
              BEGIN
                   write('Juega la Maquina, su ficha es:');
                   NormVideo; TextColor(4); writeln(' o'); NormVideo;
                   SiguientesJugadas(jugador1,maquina,repeticion,numerodado,casillaposada,casillacalavera,
                                     turno,turnodoble,turnooca);
              END;
    UNTIL (jugador1=jardinoca) OR (maquina=jardinoca);
    writeln;
    MostrarTablero(casillaposada,casillacalavera,jugador1,maquina);
    IF (jugador1=jardinoca) THEN
       BEGIN
            NormVideo; TextColor(12);
            writeln('HAS GANADO, JUGADOR 1!!!!'); NormVideo;
       END
    ELSE
        BEGIN
             NormVideo; TextColor(12);
             writeln('HA GANADO LA MAQUINA!!!!'); NormVideo;
        END;
    write('Pulse "Enter" para finalizar el juego');
    readln;
    ClrScr;
END.