Program Juego_De_La_Oca;

Uses crt;

Const
  tmax=27;   {posicion jardn de la oca}
  oca1=5;
  oca2=9;    {oca(n):los valores constantes de las casillas oca}
  oca3=14;
  oca4=18;
  oca5=23;
  pue1=6;    {pue(n):los valores constantes de las casillas puente}
  pue2=12;

Procedure Posada (var casillapos:integer);
{Introducir por teclado el valor de la casilla posada para la partida: hay
restricciones de que debe estar despus de cualquier casilla puente y no debe
coincidir con ninguna casilla especial}
   Begin
      {$I-}
      Repeat
         writeln ('Introduce la casilla que ser la posada');
         readln (casillapos);
      until (IOresult=0) and (casillapos>pue2) and (casillapos<>oca3) and
         (casillapos<>oca4) and (casillapos<>oca5) and (casillapos<tmax)
      {$I+}
   end;

Procedure Calavera (caspos:integer;var casical:integer);
{Introducir por teclado la casilla que sera la calavera en la partida.No debe
coincidir con ninguna casilla especial, incluida la posada, por eso en este
procedimiento hay una variable de E (caspos)}
   Begin
     {$I-}
     Repeat
        writeln ('Introduce la casilla que ser la calavera');
        readln (casical);
        writeln;
     until (IOresult=0) and (casical<>oca1) and (casical<>oca2) and
         (casical<>oca3) and (casical<>oca4) and (casical<>oca5) and
         (casical<>pue1) and (casical<>pue2) and (casical<>caspos) and
         (casical<tmax) and (casical>0)
     {$I+}
   end;

Procedure Dibujar_Tablero (posada,calavera,posmaq,posjug:integer);
{Dibujar el tablero por pantalla, indicar las posiciones de los dos
jugadores y de todas las casillas especiales. Como solo se utiliza para
mostrar por pantalla, se utilizan variables de E y dentro del
procedimiento se usa una variable auxiliar (indi)}
   Var
   indi:integer;
   Begin
     for indi:=0 to tmax do
       begin
          textcolor(white);
          write (indi:2,' : ');
          if (indi=oca1) or (indi=oca2) or (indi=oca3) or (indi=oca4) or
           (indi=oca5) then
            begin
               textcolor(10);
               write (' Oca /')
            end;
          if (indi=pue1) or (indi=pue2) then
            begin
               textcolor(9);
               write (' Puente /')
            end;

          if (indi=tmax) then
            begin
               textcolor(12);
               write (' Jardn de la oca /')
            end;
          textcolor(7);
          if indi=posada then write (' Posada /');
          if indi=calavera then write (' Calavera /');
          textcolor(11);
          if indi=posjug then write (' posicion USUARIO');
          textcolor(13);
         if indi=posmaq then write (' posicion MAQUINA');
         writeln;
         textcolor(white)
       end;
       writeln
   end;

Function Tirar_Dado:integer;
   Begin
      Tirar_Dado:=random(6)+1
   end;

Procedure Tirada_Jugador (ndad:integer; var pos:integer);
{Se utiliza dentro de este procedimiento una llamada a la funcion anterior y
asi se indica el valor del dado que ha sacado y actualiza la posicion del
jugador}
   Begin
      ndad:=Tirar_Dado;
      writeln('Has sacado un: ',ndad);
      pos:=pos+ndad;
      if (pos>tmax) then
          pos:=pos-(pos-tmax)*2
   end;

Procedure Casillas_Especiales (caposada,cacalavera:integer;var posicion,num:integer);
   Begin
      If (posicion=oca1) or (posicion=oca2) or (posicion=oca3)  or
      (posicion=oca4) or (posicion=oca5) then
        {OCA: reglas del juego, si se cae en una oca se avanza hasta la
        siguiente esto lo he hecho con un CASE OF y se vuelve a tirar pero
        esto lo he puesto mas adelantee sin cambiar el turno}
         begin
            case posicion of
               oca1: posicion:=oca2;
               oca2: posicion:=oca3;
               oca3: posicion:=oca4;
               oca4: posicion:=oca5;
               oca5: posicion:=tmax
            end;
            writeln ('Has caido en OCA, pasas a la siguiente oca, y vuelves a tirar')
         end;
      if  (posicion=pue1) or (posicion=pue2) then
        {PUENTE: si se cae aqui vas a la posada, lo he hecho con una asignacion
        de la posada a la posicion del jugador.Ademas se pierde un turno, lo
        indico asignndole a la variable num el valor de 2, que ms adelante
        utilizar con FOR para que se cumpla que pierde turno}
         begin
            posicion:=caposada;
            num:=2;
            writeln('Has cado en PUENTE, vas a la posada')
         end;
      if (posicion=caposada) then    {POSADA}
         begin
            num:=2;
            writeln ('Has cado en POSADA. pierde un turno')
         end;
      if  (posicion=cacalavera) then   {CALAVERA}
         begin
            posicion:=1;
            num:=1;
            writeln ('Has cado en CALAVERA, retrocedes a la casilla 1')
         end;
      if (posicion<>oca1) and (posicion<>oca2) and (posicion<>oca3) and
         (posicion<>oca4) and (posicion<>oca5) and (posicion<>pue1) and
         (posicion<>pue2) and (posicion<>caposada) and (posicion<>cacalavera)
          and (posicion<>tmax) and (posicion<>0) then
       {CASILLA NORMAL:hay que tener en cuenta esta opcion para que funcione
       bien el cambio de turno}
         Begin
            num:=1
         end;
      readln
  end;

Procedure Turno_jugador(dad,calav,posad:integer;var pjug,nve:integer);
{Para simplificar el programa principal he creado este procedimiento en el
que se hace llamada a dos procedimientos definidos antes}
  Begin
     Tirada_jugador(dad,pjug);
     Casillas_Especiales (posad,calav,pjug,nve);
     writeln
  end;

Procedure Cambio_Turno (posi:integer;var turn:char);
{Para simplificar el programa principal:si el jugador no cae en oca, no vuelve
a tirar por tanto cambia el turno}
   Begin
     If (posi<>oca1) and (posi<>oca2) and (posi<>oca3) and (posi<>oca4)
        and (posi<>oca5) then
        begin
          case turn of
            'U': turn:='M';
            'M': turn:='U'
          end;
        end;
   end;

Procedure Inicializar_Partida (var cpos,ccal,nvece,pmaquina,pusuario:integer;
                               var  ntur:char);
{Para simplificar el programa principal, se inicializan todas las posiciones y
valores para iniciar la partida}
  Begin
      writeln ('"""""""""Bienvenido al juego de la oca""""""""""""""""');
      readln;
      Posada (cpos);
      Calavera (cpos,ccal);
      ntur:='U';
      nvece:=1;
      pmaquina:=0;
      pusuario:=0
   end;

Function Fin_del_Juego (posjugad,posmaquin:integer):boolean;
{TERMINAR EL JUEGO: es una funcion que devuelve un valor booleano.Si uno de
los dos jugadores se encuentra en la casilla 27,devuelve Fin_del_juego:=true}
   begin
      if (posjugad=tmax) then
        begin
           Fin_Del_Juego:=true;
           writeln ('   HAS GANADO EL JUEGO   !!!!!!!!!!')
        end;
      if (posmaquin=tmax) then
        begin
           Fin_del_Juego:=true;
           writeln ('   TE HA GANADO LA MAQUINA   !!!!!!!!!')
        end;
   end;

{=======================PROGRAMA PRINCIPAL===================================}
{============================================================================}
Var
  pmaq,pusuar:integer;
  ndado,nveces:integer;
  cposada,ccalavera:integer;
  nturno:char;  {Indicar quien juega U:usuario y M:mquina}
  ind:integer;  {utilizar con FOR-TO en el caso de que se pierda turno}

Begin
  randomize;
  Inicializar_Partida (cposada,ccalavera,nveces,pmaq,pusuar,nturno);
  Dibujar_Tablero(cposada,ccalavera,pmaq,pusuar);
  Repeat
     If (nturno='U') then
       begin
          for ind:=nveces downto 1 do
            begin
              writeln ('Turno del USUARIO');
              writeln;
              writeln ('Tire el dado: pulse enter');
              readln;
              Turno_jugador(ndado,ccalavera,cposada,pusuar,nveces);
              Dibujar_Tablero(cposada,ccalavera,pmaq,pusuar)
            end;
            Cambio_Turno (pusuar,nturno)
       end
       else
       begin
         for ind:=nveces downto 1 do
           begin
             writeln ('Turno de la MAQUINA');
             readln;
             Turno_jugador(ndado,ccalavera,cposada,pmaq,nveces);
             Dibujar_Tablero(cposada,ccalavera,pmaq,pusuar)
           end;
           Cambio_Turno (pmaq,nturno)
      end;
  until Fin_Del_Juego(pusuar,pmaq)=true;
  readln
end.