program oca;

uses crt;


function comprobar_posada(posada:integer;turno:boolean; var casilla:integer):boolean;
{Funcion que devuelve verdadero cuando el jugador con el turno cae en la posada o en un puente,
si cae en un puente le avanza hasta la posada}
var
aux:boolean;
begin
     textcolor(brown);
     aux:=false;
     if casilla=posada then
                       begin
                            aux:=true;
                            if turno=true
                            then writeln('!Has caido en la posada! Pierdes un turno')
                            else writeln('!He caido en la posada! Pierdo un turno')
                       end;

     while (casilla=6) or (casilla=12) do
           begin
                if turno=true
                   then writeln('!Has caido en un puente! Avanzas hasta la posada pero pierdes un turno')
                   else writeln('!He caido en un puente! Avanzo hasta la posada pero pierdo un turno');
                casilla:=posada;
                aux:=true;
           end;
     textcolor(white);
     comprobar_posada:=aux;
end;


procedure cambiar_turno(var turno:boolean);
{Proceso que cambia el valor de 'turno', asi el programa alterna los turnos en el bucle principal.
Tambien es utilizado para mantener el turno cuando hay una oca (proceso casilla_oca).
O para perderlo cuando alguien cae en la posada (proceso perder_turno)}
begin
     if turno=true then turno:=false
                   else turno:=true;
end;


procedure perder_turno(var turno,contador:boolean);
{Cuando un jugador cae en la posada(comprobar_posada) 'contador' es verdadero,
asi en el turno siguiente ente proceso pueda entrar en el WHILE cambiando 'turno'
y manteniendo un turno mas}
begin
     while contador=true do
     begin
          cambiar_turno(turno);
          contador:=false;
          writeln('Tiras otra vez');
     end;
end;


procedure comprobar_calavera(turno:boolean; var calavera,aux:integer);
{Compruba si el juegador que tiene el turno ha caido en el calavera, si es asi
lo lleva a las casilla 1}
begin
     if aux=calavera
        then begin
             aux:=1;
             textcolor(lightred);
             if (turno=true)
                then writeln('!Has caido en la Calavera! Retrocedes hasta la casilla 1')
                else writeln('!He caido en la Calavera! Retrocedo hasta la casilla 1');
             textcolor(white);
        end;
end;

procedure casilla_oca(var turno:boolean;var casilla:integer);
{Cuando un jugador cae en una oca le da el valor de la siguiente oca y llama
a 'cambiar_turno' que cambia el valor de 'turno' para tirar otra vez}
begin
     if (casilla=5) or (casilla=9) or (casilla=14) or (casilla=18) or (casilla=23) then
          begin
               case casilla of
               5:casilla:=9;
               9:casilla:=14;
               14:casilla:=18;
               18:casilla:=23;
               23:casilla:=27;
               end;
               textcolor(lightblue);
               if (turno=true) and (casilla<>27)
                  then writeln('!!Has caido en una oca!! Tiras otra vez')
                  else writeln('!!De oca a oca y tiro porque me toca!!');
               cambiar_turno(turno);
               textcolor(white);
          end;
end;


procedure tablero(posada,calavera,jugador,maquina:integer);
{Dibuja el tablero, indica la posicion de la posada y la calavera, ademas de
la posicion del jugador y de la maquina}
begin
     clrscr;
     textcolor(lightgreen);
     writeln(' ___ ___ ___ ___ ___ ___ ___ ___ ___ ___ ');
     write('|  1|  2|  3|  4|  5|  ');textcolor(brown);write('6');textcolor(lightgreen);write('|  7|  8|  9| 10|');
     textcolor(yellow);
     writeln('     ESTAS EN LA CASILLA:',jugador);
     textcolor(lightgreen);
     writeln('|   |   |   |   |OCA|   |   |   |OCA|   |');
     writeln('|___|___|___|___|___|___|___|___|___|___|');
     writeln(' ___ ___ ___ ___ ___ ___ ___ ___ ___ ___ ');
     write('| 11| ');textcolor(brown);write('12');textcolor(lightgreen);write('| 13| 14| 15| 16| 17| 18| 19| 20|');
     textcolor(yellow);
     writeln('     ESTOY EN LA CASILLA:',maquina);
     textcolor(lightgreen);
     writeln('|   |   |   |OCA|   |   |   |OCA|   |   |');
     writeln('|___|___|___|___|___|___|___|___|___|___|');
     writeln(' ___ ___ ___ ___ ___ ___ ___ ___ ___ ___ ');
     write('| 21| 22| 23| 24| 25| 26|             ');textcolor(lightblue);write('27');textcolor(lightgreen);write('|');
     textcolor(lightred);
     writeln('     POSADA: ',posada);
     textcolor(lightgreen);
     write('|   |   |OCA|   |   |   |     ');textcolor(lightblue);write('FINAL');textcolor(lightgreen);write('     |');
     textcolor(lightred);
     writeln('     CALAVERA: ',calavera);
     textcolor(lightgreen);
     writeln('|___|___|___|___|___|___|___ ___ ___ ___|');
     writeln(' ');
     textcolor(brown);
     writeln('CASILLA PUENTE');
     textcolor(lightblue);
     writeln('JARDIN DE LA OCA');
     textcolor(lightgreen);
     writeln('________________________________________________________________________________');
     textcolor(white);
end;


function casilla_calavera(casillaposada:integer):integer;
{Devuelve el valor introducido por el usuario de la calavera}
var
aux:integer;
begin
     {$I-}
     write('Que casilla quieres que sea la calavera? ');
     readln(aux);

     while (ioresult<>0) or (aux=5) or (aux=9) or (aux=14) or (aux=18)
     or (aux=23) or (aux>26) or (aux=casillaposada)
     or (aux=6) or (aux=12) do
     begin
          textcolor(lightred);
          write('Casilla no valida, escribe una casilla libre. ');
          textcolor(white);
          readln(aux);
     end;
     casilla_calavera:=aux;
     {$I+}
end;


function casilla_posada:integer;
{Devuelve el valor de la posada introduciodo por el usuario}
var
aux:integer;
begin
     {$I-}
     write('Que casilla quieres que sea la posada? ');
     readln(aux);

     while(ioresult<>0) or (aux<13) or (aux=14) or (aux=18)
     or (aux=23) or (aux>26) do
     begin
          textcolor(lightred);
          write('Casilla no valida, escribe una casilla libre. ');
          textcolor(white);
          readln(aux)
     end;
     {$I+}
     casilla_posada:=aux;
     writeln(' ');
end;


function dado:integer;
{Devuelve un valor aleatorio entre 1 y 6, simula un dado}
var
     aux:integer;
begin
     textcolor(lightgreen);
     aux:=random(5);
     if aux=0 then aux:=6;
     writeln(' ');
     writeln('Ha salido un: ',aux);
     dado:=aux;
     textcolor(white);
end;


procedure pasar27(turno:boolean; var aux:integer);
{Comprueba si el jugador con el turno se a pasado de 27, si es asi le resta los
puntos sobrantes}
begin
     while aux>27 do
     begin
          textcolor(lightred);
          aux:=27-(aux-27);
          if turno=true
             then begin
                  writeln('!Te has pasado!');
                  writeln('Rebotas a la casilla:',aux);
             end
             else begin
                  writeln('!Me he pasado!');
                  writeln('Reboto a la casilla:',aux);
             end;
          textcolor(white);
     end;
end;


var
maquina,jugador:integer; {Contiene la casilla de la maquina y del usuario}
turno,contador:boolean;  {'Turno' contiene el jugador que tiene el turno, verdadero usuario.
                         'Contador' es verdadero cuando un jugador cae en la posdada, y asi
                         en el siguiente turno 'perder_turno' le hace volver a tirar al otro jugador}
posada,calavera:integer; {Contiene la casilla de la posada y la calavera}

begin
clrscr;
randomize;
turno:=true;
contador:=false;
     {Introducion al juego}
     textcolor(lightblue);
     writeln(' ');
     writeln(' ');
     writeln('                   =======================================');
     writeln('                               JUEGO DE LA OCA            ');
     writeln('                   =======================================');
     writeln(' ');
     writeln(' ');
     textcolor(lightred);
     write('     Las ocas estan situadas en las casillas 5, 9, 14, 18 y 23. ');
     writeln('Si caes en           una oca avanzas a la siguiente y podras volver a tirar.');
     writeln(' ');
     write('     Los puentes estan situandos en las casillas 6 y 12. ');
     writeln(' Si caes en uno de          ellos avanzas hasta la posada pero perderas un turno para tirar.');
     writeln(' ');
     writeln('     La casilla Calavera la elige el jugador. Si caes en ella vuelves a la           casilla 1.');
     writeln(' ');
     writeln(' ');
     writeln(' ');
     writeln(' ');
     writeln(' ');
     textcolor(white);
     writeln('Pulsa intro para comenzar a jugar.');
     readln;

tablero(posada,calavera,jugador,maquina);
posada:=casilla_posada;
calavera:=casilla_calavera(posada);

repeat {Buble principal se repite hasta que uno de los jugadores tiene la
       casilla 27. El 'IF' anterna el turno.}
      tablero(posada,calavera,jugador,maquina);
      if turno=true
         then begin
              textcolor(yellow);
              writeln('Te toca tirar!');
              textcolor(white);
              write('Pulsa intro para tirar');
              readln;
              jugador:=jugador+dado;
              pasar27(turno,jugador);
              casilla_oca(turno,jugador);
              comprobar_calavera(turno,calavera,jugador);
              perder_turno(turno,contador);                     {Cuando en el ELSE el jugador cae en la posada 'contador' }
              contador:=comprobar_posada(posada,turno,jugador); {es true, entonces en el THEN cambia el turno, y al final del }
         end                                                    {bucle lo vuelve a cambiar, repitiendo asi el turno el jugador}
         else begin
              textcolor(yellow);
              writeln('Me toca tirar!');
              textcolor(white);
              maquina:=maquina+dado;
              pasar27(turno,maquina);
              casilla_oca(turno,maquina);
              comprobar_calavera(turno,calavera,maquina);
              perder_turno(turno,contador);
              contador:=comprobar_posada(posada,turno,maquina);
         end;
writeln(' ');
write('Pulsa intro para cambiar de turno');
readln;
cambiar_turno(turno);{Cambia el turno al final del bucle}
until (jugador=27) or (maquina=27);

    writeln(' ');
    textcolor(yellow);
    write('                        !JARDIN DE LA OCA!  ');
    textcolor(green);

    if turno=true
	then writeln('!HAS GANADO!')
	else writeln('!HE GANADO!');

    textcolor(white);
    writeln('Pulsa intro para finalizar');
    readln;
end.
