PROGRAM juego_de_la_oca;

 FUNCTION tirar_dado (var v:integer):integer;  {funcion para tirar el dado}
  BEGIN
     v:=random(6)+1;
  END;

  {pedimos al usuario que seleccione la casilla posada}
  FUNCTION  casilla_posada (var posada:integer): integer;

  BEGIN
   writeln ('elija la casilla posada');
   writeln ('no puede tomar valores menores a 13, ni 14, 18, 23 y 27');
   {$I-}
   readln (posada);
   while ((IOResult<>0) or (posada<13) or (posada=14) or (posada=18)
         or (posada=23) or (posada>=27)) do
     begin
         writeln ('ese valor no es correcto');
         readln (posada);
     end;
   {SI+}
  END;

   {pedimos al usuario que seleccione la casilla calavera}
  FUNCTION casilla_calavera (var calavera:integer; posadita: integer):integer;

  BEGIN
   writeln ('elija la casilla calavera, no puede tomar los siguientes');
   writeln ('valores: 1, 5, 6, 9, 12, 14, 18, 23, 27');
   {$I-}
   readln (calavera);
   while ((IOResult<>0) or (calavera=posadita) or (calavera<=1) or
         (calavera=5) or (calavera=6) or (calavera=9) or (calavera=12)
         or (calavera=14) or (calavera=18) or (calavera=23)
         or (calavera>=27)) do
     begin
      writeln ('introduzcalo de nuevo');
      readln (calavera);
     end;
   {$I+}
  END;

   {dibuja el tablero en pantalla}
 PROCEDURE dibujar_tablero (pos_jug, pos_maq, calaverita, posadita: integer);
  VAR
  i: integer;
  BEGIN
   for i:=0 to 27 do
    begin
      write (' [', i,'] ');
       if i = 0 then write ('salida  ');
       if i = pos_jug then write ('J!!  ');
       if i = pos_maq then write ('M!!  ');
       if i = calaverita then write ('calavera  ');
       if i = posadita then write ('posada  ');
       if (i=5) or (i=9) or (i=14) or (i=18) or (i=23) then  write ('oca  ');
       if (i=6) or (i=12)  then write ('puente  ');
       if i = 27 then writeln ('jardin de la oca  ');
    end;
  END;

  {lee una tecla del teclado}
  PROCEDURE lanzar_dado (tecla:integer);

   BEGIN
    {$I-}
    readln (tecla);
    while ((IOResult<>0) or (tecla<>1)) do
     begin
      writeln ('pulse 1');
      readln (tecla);
     end;
    {$I+}
  END;


 {variables del programa principal}
 VAR
    pos_jug, pos_maq, dado_jug, dado_maq: integer;
    posada, posadita, calaverita, calavera, sobrantes, v, tecla: integer;
    pierde_turno_jug, pierde_turno_maq, ganador: boolean;

 BEGIN
   {inicializaciones}
   Randomize;
   writeln ('JUEGO DE LA OCA');
   pos_jug:=0;
   pos_maq:=0;
   pierde_turno_jug:=false;
   pierde_turno_maq:=false;
   ganador:=false;
   posadita:= casilla_posada (posada);
   posadita:= posada;
   calaverita:=casilla_calavera (calavera, posadita);
   calaverita:=calavera;
   writeln ('para comenzar el juego escriba 1');
   lanzar_dado (tecla);
   dibujar_tablero (pos_jug, pos_maq, calaverita, posadita);
   writeln; writeln;

   {comienza el juego, turno del jugador}
    WHILE ganador=false do
     BEGIN
      if pierde_turno_jug=false THEN
       BEGIN
        writeln ('para lanzar su dado escriba 1');
        lanzar_dado (tecla);
        dado_jug:=tirar_dado (v);
        dado_jug:=v;
        writeln ('has sacado: ', dado_jug);
        pos_jug:=(pos_jug+dado_jug);

       {se pasa del jardin de la oca y debe retroceder}
       if pos_jug>27
              then
                begin
                 sobrantes:=(pos_jug-27);
                 pos_jug:=(27-sobrantes);
                end;

        dibujar_tablero (pos_jug, pos_maq, calaverita, posadita);

       {cae en el jardin de la oca}
       if pos_jug=27
        then
         begin
          ganador:=true;
          writeln ('Enhorabuena, ha ganado');
         end

        {cae en una oca}
        else if ((pos_jug= 5) or (pos_jug=9) or (pos_jug=14) or (pos_jug=18)
               or (pos_jug=23))
             then
              begin
              writeln ('de oca a oca y tiro por que me toca');
              pierde_turno_maq:=true;
              if pos_jug=5 then pos_jug:=9
                 else if pos_jug=9 then pos_jug:=14
                  else if pos_jug=14 then pos_jug:=18
                   else if pos_jug=18 then pos_jug:=23
                    else if pos_jug=23 then
                                        begin
                                        pos_jug:=27;
                                        ganador:=true;
                                        writeln ('Enhorabuena, ha ganado');
                                        dibujar_tablero (pos_jug, pos_maq,
                                                      calaverita, posadita);

                                        end;
              writeln;
              dibujar_tablero (pos_jug, pos_maq, calaverita, posadita);
              end

        {cae en un puente}
        else if (pos_jug=6) or (pos_jug=12) then
           begin
              writeln ('ha caido en una casilla puente');
              writeln ('pierde turno e ira a la posada');
              pos_jug:=posadita;
              pierde_turno_jug:=true;
           end
          {cae en la posada}
        else if pos_jug=posadita
           then
            begin
             writeln ('ha caido en una posada, pierde turno');
             pierde_turno_jug:=true;
            end

        {cae en la calavera}
        else if pos_jug=calaverita
           then
            begin
             writeln ('ha caido en la calavera,');
             writeln ('va a la casilla 1');
             pos_jug:=1;
            end
        else begin
          writeln ('ninguna casilla especial');
         end;
       writeln; writeln;
       END
     ELSE
       begin
        writeln ('has perdido un turno, la maquina juega de nuevo');
        pierde_turno_jug:=false;
       end;


      {turno de la maquina}
   if ganador=false then
   BEGIN
    if pierde_turno_maq=false then
     BEGIN
       writeln ('para que lance el dado la maquina escriba 1');
       lanzar_dado (tecla);
       dado_maq:=tirar_dado (v);
       dado_maq:=v;
       writeln ('la maquina ha sacado: ', dado_maq);
       pos_maq:=(pos_maq+dado_maq);

       {se pasa del jardin de la oca y debe retroceder}
       if pos_maq>27
           then
            begin
             sobrantes:=(pos_maq-27);
             pos_maq:=(27-sobrantes);
            end;

        dibujar_tablero (pos_jug, pos_maq, calaverita, posadita);

       {cae en el jardin de la oca}
       if pos_maq=27
        then
         begin
          ganador:=true;
          writeln ('Game Over, la maquina ha ganado');
         end

        {cae en una oca}
         else if (pos_maq= 5) or (pos_maq=9) or (pos_maq=14) or (pos_maq=18)
               or (pos_maq=23)
            then
             begin
              writeln ('de oca a oca y tiro por que me toca');
              pierde_turno_jug:=true;
              if pos_maq=5 then pos_maq:=9
                 else if pos_maq=9 then pos_maq:=14
                  else if pos_maq=14 then pos_maq:=18
                   else if pos_maq=18 then pos_maq:=23
                    else if pos_maq=23 then begin
                                        pos_maq:=27;
                                        ganador:=true;
                                        write ('Game Over, la maquina ');
                                        writeln ('ha ganado');
                                        dibujar_tablero (pos_jug, pos_maq,
                                                        calaverita, posadita);
                                        end;
              writeln;
              dibujar_tablero (pos_jug, pos_maq, calaverita, posadita);
             end

         {cae en un puente}
         else if (pos_maq=6) or (pos_maq=12) then
           begin
              writeln ('la maquina ha caido en una casilla puente');
              writeln ('pierde turno e ira a la posada');
              pos_maq:=posadita;
              pierde_turno_maq:=true;
           end
         {cae en la posada}
         else if pos_maq=posadita
           then
            begin
             writeln ('la maquina ha caido en una posada y pierde turno');
             pierde_turno_maq:=true;
            end

         {cae en la calavera}
         else if pos_maq=calaverita
           then
            begin
             writeln ('la maquina ha caido en la calavera,');
             writeln ('va a la casilla 1');
             pos_maq:=1;
            end

         else
          begin
           writeln ('ninguna casilla especial');
          end;
       writeln; writeln;
     END
     ELSE
       begin
        writeln ('la maquina ha perdido turno, tiras de nuevo');
        pierde_turno_maq:=false;
       end;
    END;


  END;
  readln;
 END.
