{ALEJANDRO BERNAL HERRERO
G15P05}

PROGRAM   JuegoDeLaOca;
uses crt;
{Procedimiento que pide al usuario que introduzca la casilla especial "Posada"}
PROCEDURE pedir_casilla_posada(var ncasillaposada:integer);
	 BEGIN
                {me aseguro que el usuario especifique un n correcto para asignar la casilla "posada"};
                repeat
                writeln('Elije un nmero 12<n<27 y que no sea ni el 14,18 ni 23');
                {$I-}
                readln (ncasillaposada);
                {$I+}
                until (IOresult=0) and (ncasillaposada<>14) and (ncasillaposada<>18) and
                (ncasillaposada<>23) and (ncasillaposada<27) and (ncasillaposada>12);
                clrscr;
	 END;
{Procedimiento que pide al usuario que introduzca la casilla especial "Calavera"}
PROCEDURE pedir_casilla_calavera(var ncasillacalavera,ncasillaposada:integer);
	 BEGIN
		{me aseguro que el usuario especifique un n correcto para asignar la casilla "calavera"};
                repeat
                writeln ('Elije un nmero 1<n<27 y que no sea ni el 5,6,9,12,14,18,23 ni la...');
                writeln ('... ncasillaposada para asignar la casilla calavera');
                {$I-}
                readln  (ncasillacalavera);
                {$I+}
                until (IOresult=0) and
                (ncasillacalavera>1) and (ncasillacalavera<27) and (ncasillacalavera<>5) and (ncasillacalavera<>6)
                and (ncasillacalavera<>9) and (ncasillacalavera<>12) and (ncasillacalavera<>14)
                and (ncasillacalavera<>18) and (ncasillacalavera<>23) and (ncasillacalavera<>ncasillaposada);
                clrscr;

	 END;

PROCEDURE tirar_dado(var casilla:integer;color:integer);
{procedimiento que me crea el dado a traves de la funcin random, y que a su vez
 me coloca la casilla del jugador actualizada despus de tirarlo}
var dado:integer;
	 BEGIN
                TextColor(color);
                writeln ('Enter para tirar dado');
                readln;clrscr;
			{creo el dado con la funcin random..}
                randomize;
                dado:= random(6)+1;
                writeln ('El dado lanzado ha cado en el n:',dado);
                casilla:=casilla+dado;
                writeln ('Ha cado en la casilla n:',casilla);
                writeln('                                                                               ');
	END;
{Procedimiento que realiza las acciones pertinentes a casillas especiales o exceso de casilla 27}
PROCEDURE comprobar_casilla(var casilla:integer;nombrejugador:string;ncasillaposada:integer;ncasillacalavera:integer;
color:integer);

         BEGIN
                TextColor(color);
		{Hago que el jugador retroceda tantas casillas como puntos sobrantes en caso
                de exceder la casilla "Jardin de la Oca"};
                if (casilla>27) then
                begin
		casilla:=(casilla-27);
		casilla:=(27-casilla);
                end;
                {Si el jugador cae en una de las casillas que contienen oca..}
		if ((casilla=5)or(casilla=9)or(casilla=14)or(casilla=18)or(casilla=23)) then
                begin
                writeln(nombrejugador,' se encuentra en la casilla especial "Oca"!!');
                case(casilla) of
		        5: casilla:=9;
			9: casilla:=14;
			14: casilla:=18;
			18: casilla:=23;
			23: casilla:=27;
		end;
		writeln(nombrejugador, ' avanza hasta la casilla n:',casilla);
		if(casilla<>27)then
		begin
		writeln(nombrejugador, ' avanza de "Oca a Oca" y tira porque le toca!');
                writeln('                                                                               ');
		{El jugador al estar en "Oca" vuelve a lanzar el dado y para ello creo el dado otra vez}
		tirar_dado(casilla,7);
		end
                end;

                {Cuando el jugador cae en la casilla 6 o 12 avanza hasta la casilla "Posada"}
		if (casilla=6) or (casilla=12) then
                begin
                writeln(nombrejugador, ' ha cado en la casilla especial "Puente"!!');
                casilla:=ncasillaposada;
                writeln(nombrejugador, ' avanza hasta la casilla especial "Posada"');
                end;
                {Si el jugador llega a una "posada" directamente sin pasar por puente..}
		if (casilla=ncasillaposada)then
		begin
		writeln (nombrejugador, ' se encuentra en la casilla especial "Posada"');
		writeln (nombrejugador, ' pierde un turno...');
                writeln('                                                                               ');
                end;

                {Cuando el jugador cae en la casilla "Calavera" retrocede hasta la casilla 1}
		if (casilla=ncasillacalavera)then
		begin
		writeln (nombrejugador, ' se encuentra en la casilla especial "Calavera"');
		casilla:=1;
		writeln (nombrejugador, ' vuelve a la casilla n1');
                writeln('                                                                               ');
		end;


	 END;
{Procedimiento que adopta el usuario/maquina para gestionar sus tiradas}
PROCEDURE jugador(var casilla:integer;nombrejugador:string; ncasillaposada:integer;ncasillacalavera:integer;color:integer);

	 BEGIN
		TextColor(color);
	 	writeln ('La posicin de ',nombrejugador, ' en el tablero es: ',casilla);
                writeln('                                                                               ');
        	tirar_dado(casilla,7);
		while
                     ((casilla=5) or (casilla=6) or (casilla=9) or (casilla=12) or (casilla=14) or (casilla=18) or
		     (casilla=23) or (casilla=ncasillacalavera) or (casilla>27)) do
		     comprobar_casilla(casilla, nombrejugador, ncasillaposada,ncasillacalavera, 10);
                if (casilla=27) then
		writeln(nombrejugador, ' se encuentra en el "Jardn de la Oca"!..', nombrejugador, ' HA GANADO LA PARTIDA!!');

         END;
{Procedimiento que uso para evitar las variables globales}
PROCEDURE juego;
VAR
          ncasillaposada:   integer;
	  ncasillacalavera: integer;
	  usuario:          integer;
          maquina:          integer;

BEGIN
               {Pedimos al usuario que introduzca un n para asignar las casillas "posada" y "calavera"}
pedir_casilla_posada(ncasillaposada);
pedir_casilla_calavera(ncasillacalavera, ncasillaposada);

                {asigno el n de casilla "0" al usuario y a la mquina para empezar a jugar};
usuario:=0;
maquina:=0;

                {bucle principal del juego}
         Repeat
		{despues de un jugador otro, a no ser q esten alguno de los dos en la
                casilla posada q volvera a tirar el jugador contrario otra vez}
                writeln ('La posicin de Mquina en el tablero es: ', maquina);
		jugador(usuario, 'Usuario', ncasillaposada,ncasillacalavera, 14);
                {Hago que la mquina pierda un turno en caso de que haya caido en la casilla "Posada"}
		if (usuario<>27)and (usuario<>ncasillaposada)and(maquina=ncasillaposada) then
		jugador(usuario, 'Usuario', ncasillaposada,ncasillacalavera, 14);

		if (usuario<>27) then
		begin
                writeln ('La posicin de Usuario en el tablero es: ', usuario);
		jugador(maquina, 'Mquina', ncasillaposada,ncasillacalavera,14);
                {Hago que el usuario pierda un turno en caso de que haya caido en la casilla "Posada"}
		if (maquina<>27)and (maquina<>ncasillaposada)and(usuario=ncasillaposada) then
		jugador(maquina, 'Mquina', ncasillaposada,ncasillacalavera,14);
		end;
	 until (usuario=27) or (maquina=27);
         readln;
END;

BEGIN
clrscr;
writeln('                                                                               ');
writeln('******************************  JUEGO DE LA OCA  ******************************');
writeln('                                                                               ');

juego;

END.

